
// -*-c++-*-
//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2016 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file vbic_3T_et_cf_Xyce_typed.vla with ADMS 
//                  interface for Xyce 6.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.5
//
// Creation Date  : Wed, 05 Oct 2016 09:47:06
//
//-----------------------------------------------------------------------------
#ifndef Xyce_N_DEV_ADMSvbic_h
#define Xyce_N_DEV_ADMSvbic_h


#include <Sacado.hpp>

#include <N_DEV_Configuration.h>
#include <N_DEV_Const.h>
#include <N_DEV_DeviceBlock.h>
#include <N_DEV_DeviceInstance.h>
#include <N_DEV_DeviceModel.h>
#include <N_DEV_BJT.h>


namespace Xyce {
namespace Device {
namespace ADMSvbic {

// This typedef is for our automatic differentiation:
typedef Sacado::Fad::SFad<double,15> AdmsFadType;
typedef Sacado::Fad::SFad<double,1> AdmsSensFadType;

class Model;
class Instance;
class InstanceSensitivity;

#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Class         : InstanceSensitivity
//
// Purpose       : This class is a functor for sensitivity
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class InstanceSensitivity : public baseSensitivity
{
public:
  InstanceSensitivity() :
    baseSensitivity() {};

  virtual ~InstanceSensitivity() {};

  virtual void operator()(
     const ParameterBase &entity,
     const std::string &param,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
                          ) const ;
};

static InstanceSensitivity instSens;


//-----------------------------------------------------------------------------
// Class         : ModelSensitivity
//
// Purpose       : This class is a functor for sensitivity
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class ModelSensitivity : public baseSensitivity
{
public:
  ModelSensitivity() :
    baseSensitivity() {};

  virtual ~ModelSensitivity() {};

  virtual void operator()(
     const ParameterBase &entity,
     const std::string &param,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
                          ) const ;
};

static ModelSensitivity modSens;
#endif // Xyce_ADMS_SENSITIVITIES

// general purpose free functions
// thermal voltage at kelvin temperature temp)
template <typename T> static inline T adms_vt(const T temp) {return(CONSTKoverQ*temp);};

// Figure out how to template this shiznit!
//-----------------------------------------------------------------------------


template<typename Tin>
static Tin adms_ternary_op(const bool cond, const Tin &ifTrue, const Tin &ifFalse)
{
  if (cond)
    return ifTrue;
  else
    return ifFalse;
}

template<typename Tin>
static Tin adms_ternary_op(const bool cond, const Tin &ifTrue, const double &ifFalse)
{
  if (cond)
    return ifTrue;
  else
    return Tin(ifFalse);
}

template<typename Tin>
static Tin adms_ternary_op(const bool cond, const double &ifTrue, const Tin &ifFalse)
{
  if (cond)
    return Tin(ifTrue);
  else
    return ifFalse;
}




#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Free functions used by sensitivity
// 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_ci_ei,
   const int admsProbeID_V_b_c,
   const int admsProbeID_V_bp_cx,
   const int admsProbeID_V_e_ei,
   const int admsProbeID_V_b_bx,
   const int admsProbeID_V_bx_bi,
   const int admsProbeID_V_cx_ci,
   const int admsProbeID_V_c_cx,
   const int admsProbeID_V_b_e,
   const int admsProbeID_V_dt_GND,
   const int admsProbeID_V_bx_bp,
   const int admsProbeID_V_bi_cx,
   const int admsProbeID_V_bx_ei,
   const int admsProbeID_V_bi_ci,
   const int admsProbeID_V_bi_ei,
   // node constants
   const int admsNodeID_c,
   const int admsNodeID_b,
   const int admsNodeID_e,
   const int admsNodeID_dt,
   const int admsNodeID_cx,
   const int admsNodeID_ci,
   const int admsNodeID_bx,
   const int admsNodeID_bi,
   const int admsNodeID_ei,
   const int admsNodeID_bp,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_DTEMP,
   bool instancePar_given_DTEMP,
   // non-reals(including hidden)
   int instancePar_M,
   bool instancePar_given_M,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_RCX,
   bool modelPar_given_RCX,
   AdmsSensFadType & modelPar_RCI,
   bool modelPar_given_RCI,
   AdmsSensFadType & modelPar_VO,
   bool modelPar_given_VO,
   AdmsSensFadType & modelPar_GAMM,
   bool modelPar_given_GAMM,
   AdmsSensFadType & modelPar_HRCF,
   bool modelPar_given_HRCF,
   AdmsSensFadType & modelPar_RBX,
   bool modelPar_given_RBX,
   AdmsSensFadType & modelPar_RBI,
   bool modelPar_given_RBI,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_RBP,
   bool modelPar_given_RBP,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_NF,
   bool modelPar_given_NF,
   AdmsSensFadType & modelPar_NR,
   bool modelPar_given_NR,
   AdmsSensFadType & modelPar_FC,
   bool modelPar_given_FC,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_ME,
   bool modelPar_given_ME,
   AdmsSensFadType & modelPar_AJE,
   bool modelPar_given_AJE,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_QCO,
   bool modelPar_given_QCO,
   AdmsSensFadType & modelPar_CJEP,
   bool modelPar_given_CJEP,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_AJC,
   bool modelPar_given_AJC,
   AdmsSensFadType & modelPar_CJCP,
   bool modelPar_given_CJCP,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_MS,
   bool modelPar_given_MS,
   AdmsSensFadType & modelPar_AJS,
   bool modelPar_given_AJS,
   AdmsSensFadType & modelPar_IBEI,
   bool modelPar_given_IBEI,
   AdmsSensFadType & modelPar_WBE,
   bool modelPar_given_WBE,
   AdmsSensFadType & modelPar_NEI,
   bool modelPar_given_NEI,
   AdmsSensFadType & modelPar_IBEN,
   bool modelPar_given_IBEN,
   AdmsSensFadType & modelPar_NEN,
   bool modelPar_given_NEN,
   AdmsSensFadType & modelPar_IBCI,
   bool modelPar_given_IBCI,
   AdmsSensFadType & modelPar_NCI,
   bool modelPar_given_NCI,
   AdmsSensFadType & modelPar_IBCN,
   bool modelPar_given_IBCN,
   AdmsSensFadType & modelPar_NCN,
   bool modelPar_given_NCN,
   AdmsSensFadType & modelPar_AVC1,
   bool modelPar_given_AVC1,
   AdmsSensFadType & modelPar_AVC2,
   bool modelPar_given_AVC2,
   AdmsSensFadType & modelPar_ISP,
   bool modelPar_given_ISP,
   AdmsSensFadType & modelPar_WSP,
   bool modelPar_given_WSP,
   AdmsSensFadType & modelPar_NFP,
   bool modelPar_given_NFP,
   AdmsSensFadType & modelPar_IBEIP,
   bool modelPar_given_IBEIP,
   AdmsSensFadType & modelPar_IBENP,
   bool modelPar_given_IBENP,
   AdmsSensFadType & modelPar_IBCIP,
   bool modelPar_given_IBCIP,
   AdmsSensFadType & modelPar_NCIP,
   bool modelPar_given_NCIP,
   AdmsSensFadType & modelPar_IBCNP,
   bool modelPar_given_IBCNP,
   AdmsSensFadType & modelPar_NCNP,
   bool modelPar_given_NCNP,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_IKP,
   bool modelPar_given_IKP,
   AdmsSensFadType & modelPar_TF,
   bool modelPar_given_TF,
   AdmsSensFadType & modelPar_QTF,
   bool modelPar_given_QTF,
   AdmsSensFadType & modelPar_XTF,
   bool modelPar_given_XTF,
   AdmsSensFadType & modelPar_VTF,
   bool modelPar_given_VTF,
   AdmsSensFadType & modelPar_ITF,
   bool modelPar_given_ITF,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_TD,
   bool modelPar_given_TD,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_AFN,
   bool modelPar_given_AFN,
   AdmsSensFadType & modelPar_BFN,
   bool modelPar_given_BFN,
   AdmsSensFadType & modelPar_XRE,
   bool modelPar_given_XRE,
   AdmsSensFadType & modelPar_XRBI,
   bool modelPar_given_XRBI,
   AdmsSensFadType & modelPar_XRCI,
   bool modelPar_given_XRCI,
   AdmsSensFadType & modelPar_XRS,
   bool modelPar_given_XRS,
   AdmsSensFadType & modelPar_XVO,
   bool modelPar_given_XVO,
   AdmsSensFadType & modelPar_EA,
   bool modelPar_given_EA,
   AdmsSensFadType & modelPar_EAIE,
   bool modelPar_given_EAIE,
   AdmsSensFadType & modelPar_EAIC,
   bool modelPar_given_EAIC,
   AdmsSensFadType & modelPar_EAIS,
   bool modelPar_given_EAIS,
   AdmsSensFadType & modelPar_EANE,
   bool modelPar_given_EANE,
   AdmsSensFadType & modelPar_EANC,
   bool modelPar_given_EANC,
   AdmsSensFadType & modelPar_EANS,
   bool modelPar_given_EANS,
   AdmsSensFadType & modelPar_XIS,
   bool modelPar_given_XIS,
   AdmsSensFadType & modelPar_XII,
   bool modelPar_given_XII,
   AdmsSensFadType & modelPar_XIN,
   bool modelPar_given_XIN,
   AdmsSensFadType & modelPar_TNF,
   bool modelPar_given_TNF,
   AdmsSensFadType & modelPar_TAVC,
   bool modelPar_given_TAVC,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_VRT,
   bool modelPar_given_VRT,
   AdmsSensFadType & modelPar_ART,
   bool modelPar_given_ART,
   AdmsSensFadType & modelPar_CCSO,
   bool modelPar_given_CCSO,
   AdmsSensFadType & modelPar_QBM,
   bool modelPar_given_QBM,
   AdmsSensFadType & modelPar_NKF,
   bool modelPar_given_NKF,
   AdmsSensFadType & modelPar_XIKF,
   bool modelPar_given_XIKF,
   AdmsSensFadType & modelPar_XRCX,
   bool modelPar_given_XRCX,
   AdmsSensFadType & modelPar_XRBX,
   bool modelPar_given_XRBX,
   AdmsSensFadType & modelPar_XRBP,
   bool modelPar_given_XRBP,
   AdmsSensFadType & modelPar_ISRR,
   bool modelPar_given_ISRR,
   AdmsSensFadType & modelPar_XISR,
   bool modelPar_given_XISR,
   AdmsSensFadType & modelPar_DEAR,
   bool modelPar_given_DEAR,
   AdmsSensFadType & modelPar_EAP,
   bool modelPar_given_EAP,
   AdmsSensFadType & modelPar_VBBE,
   bool modelPar_given_VBBE,
   AdmsSensFadType & modelPar_NBBE,
   bool modelPar_given_NBBE,
   AdmsSensFadType & modelPar_IBBE,
   bool modelPar_given_IBBE,
   AdmsSensFadType & modelPar_TVBBE1,
   bool modelPar_given_TVBBE1,
   AdmsSensFadType & modelPar_TVBBE2,
   bool modelPar_given_TVBBE2,
   AdmsSensFadType & modelPar_TNBBE,
   bool modelPar_given_TNBBE,
   AdmsSensFadType & modelPar_EBBE,
   bool modelPar_given_EBBE,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_VERS,
   bool modelPar_given_VERS,
   AdmsSensFadType & modelPar_VREV,
   bool modelPar_given_VREV,
   // non-reals (including hidden)
   int modelPar_dtype,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance);

void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_DTEMP,
   bool instancePar_given_DTEMP,
   // non-reals(including hidden)
   int instancePar_M,
   bool instancePar_given_M,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_RCX,
   bool modelPar_given_RCX,
   AdmsSensFadType & modelPar_RCI,
   bool modelPar_given_RCI,
   AdmsSensFadType & modelPar_VO,
   bool modelPar_given_VO,
   AdmsSensFadType & modelPar_GAMM,
   bool modelPar_given_GAMM,
   AdmsSensFadType & modelPar_HRCF,
   bool modelPar_given_HRCF,
   AdmsSensFadType & modelPar_RBX,
   bool modelPar_given_RBX,
   AdmsSensFadType & modelPar_RBI,
   bool modelPar_given_RBI,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_RBP,
   bool modelPar_given_RBP,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_NF,
   bool modelPar_given_NF,
   AdmsSensFadType & modelPar_NR,
   bool modelPar_given_NR,
   AdmsSensFadType & modelPar_FC,
   bool modelPar_given_FC,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_ME,
   bool modelPar_given_ME,
   AdmsSensFadType & modelPar_AJE,
   bool modelPar_given_AJE,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_QCO,
   bool modelPar_given_QCO,
   AdmsSensFadType & modelPar_CJEP,
   bool modelPar_given_CJEP,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_AJC,
   bool modelPar_given_AJC,
   AdmsSensFadType & modelPar_CJCP,
   bool modelPar_given_CJCP,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_MS,
   bool modelPar_given_MS,
   AdmsSensFadType & modelPar_AJS,
   bool modelPar_given_AJS,
   AdmsSensFadType & modelPar_IBEI,
   bool modelPar_given_IBEI,
   AdmsSensFadType & modelPar_WBE,
   bool modelPar_given_WBE,
   AdmsSensFadType & modelPar_NEI,
   bool modelPar_given_NEI,
   AdmsSensFadType & modelPar_IBEN,
   bool modelPar_given_IBEN,
   AdmsSensFadType & modelPar_NEN,
   bool modelPar_given_NEN,
   AdmsSensFadType & modelPar_IBCI,
   bool modelPar_given_IBCI,
   AdmsSensFadType & modelPar_NCI,
   bool modelPar_given_NCI,
   AdmsSensFadType & modelPar_IBCN,
   bool modelPar_given_IBCN,
   AdmsSensFadType & modelPar_NCN,
   bool modelPar_given_NCN,
   AdmsSensFadType & modelPar_AVC1,
   bool modelPar_given_AVC1,
   AdmsSensFadType & modelPar_AVC2,
   bool modelPar_given_AVC2,
   AdmsSensFadType & modelPar_ISP,
   bool modelPar_given_ISP,
   AdmsSensFadType & modelPar_WSP,
   bool modelPar_given_WSP,
   AdmsSensFadType & modelPar_NFP,
   bool modelPar_given_NFP,
   AdmsSensFadType & modelPar_IBEIP,
   bool modelPar_given_IBEIP,
   AdmsSensFadType & modelPar_IBENP,
   bool modelPar_given_IBENP,
   AdmsSensFadType & modelPar_IBCIP,
   bool modelPar_given_IBCIP,
   AdmsSensFadType & modelPar_NCIP,
   bool modelPar_given_NCIP,
   AdmsSensFadType & modelPar_IBCNP,
   bool modelPar_given_IBCNP,
   AdmsSensFadType & modelPar_NCNP,
   bool modelPar_given_NCNP,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_IKP,
   bool modelPar_given_IKP,
   AdmsSensFadType & modelPar_TF,
   bool modelPar_given_TF,
   AdmsSensFadType & modelPar_QTF,
   bool modelPar_given_QTF,
   AdmsSensFadType & modelPar_XTF,
   bool modelPar_given_XTF,
   AdmsSensFadType & modelPar_VTF,
   bool modelPar_given_VTF,
   AdmsSensFadType & modelPar_ITF,
   bool modelPar_given_ITF,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_TD,
   bool modelPar_given_TD,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_AFN,
   bool modelPar_given_AFN,
   AdmsSensFadType & modelPar_BFN,
   bool modelPar_given_BFN,
   AdmsSensFadType & modelPar_XRE,
   bool modelPar_given_XRE,
   AdmsSensFadType & modelPar_XRBI,
   bool modelPar_given_XRBI,
   AdmsSensFadType & modelPar_XRCI,
   bool modelPar_given_XRCI,
   AdmsSensFadType & modelPar_XRS,
   bool modelPar_given_XRS,
   AdmsSensFadType & modelPar_XVO,
   bool modelPar_given_XVO,
   AdmsSensFadType & modelPar_EA,
   bool modelPar_given_EA,
   AdmsSensFadType & modelPar_EAIE,
   bool modelPar_given_EAIE,
   AdmsSensFadType & modelPar_EAIC,
   bool modelPar_given_EAIC,
   AdmsSensFadType & modelPar_EAIS,
   bool modelPar_given_EAIS,
   AdmsSensFadType & modelPar_EANE,
   bool modelPar_given_EANE,
   AdmsSensFadType & modelPar_EANC,
   bool modelPar_given_EANC,
   AdmsSensFadType & modelPar_EANS,
   bool modelPar_given_EANS,
   AdmsSensFadType & modelPar_XIS,
   bool modelPar_given_XIS,
   AdmsSensFadType & modelPar_XII,
   bool modelPar_given_XII,
   AdmsSensFadType & modelPar_XIN,
   bool modelPar_given_XIN,
   AdmsSensFadType & modelPar_TNF,
   bool modelPar_given_TNF,
   AdmsSensFadType & modelPar_TAVC,
   bool modelPar_given_TAVC,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_VRT,
   bool modelPar_given_VRT,
   AdmsSensFadType & modelPar_ART,
   bool modelPar_given_ART,
   AdmsSensFadType & modelPar_CCSO,
   bool modelPar_given_CCSO,
   AdmsSensFadType & modelPar_QBM,
   bool modelPar_given_QBM,
   AdmsSensFadType & modelPar_NKF,
   bool modelPar_given_NKF,
   AdmsSensFadType & modelPar_XIKF,
   bool modelPar_given_XIKF,
   AdmsSensFadType & modelPar_XRCX,
   bool modelPar_given_XRCX,
   AdmsSensFadType & modelPar_XRBX,
   bool modelPar_given_XRBX,
   AdmsSensFadType & modelPar_XRBP,
   bool modelPar_given_XRBP,
   AdmsSensFadType & modelPar_ISRR,
   bool modelPar_given_ISRR,
   AdmsSensFadType & modelPar_XISR,
   bool modelPar_given_XISR,
   AdmsSensFadType & modelPar_DEAR,
   bool modelPar_given_DEAR,
   AdmsSensFadType & modelPar_EAP,
   bool modelPar_given_EAP,
   AdmsSensFadType & modelPar_VBBE,
   bool modelPar_given_VBBE,
   AdmsSensFadType & modelPar_NBBE,
   bool modelPar_given_NBBE,
   AdmsSensFadType & modelPar_IBBE,
   bool modelPar_given_IBBE,
   AdmsSensFadType & modelPar_TVBBE1,
   bool modelPar_given_TVBBE1,
   AdmsSensFadType & modelPar_TVBBE2,
   bool modelPar_given_TVBBE2,
   AdmsSensFadType & modelPar_TNBBE,
   bool modelPar_given_TNBBE,
   AdmsSensFadType & modelPar_EBBE,
   bool modelPar_given_EBBE,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_VERS,
   bool modelPar_given_VERS,
   AdmsSensFadType & modelPar_VREV,
   bool modelPar_given_VREV,
   // non-reals (including hidden)
   int modelPar_dtype,
   double admsTemperature,double adms_vt_nom, double gmin, const Instance & theInstance);

void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_RCX,
   bool modelPar_given_RCX,
   AdmsSensFadType & modelPar_RCI,
   bool modelPar_given_RCI,
   AdmsSensFadType & modelPar_VO,
   bool modelPar_given_VO,
   AdmsSensFadType & modelPar_GAMM,
   bool modelPar_given_GAMM,
   AdmsSensFadType & modelPar_HRCF,
   bool modelPar_given_HRCF,
   AdmsSensFadType & modelPar_RBX,
   bool modelPar_given_RBX,
   AdmsSensFadType & modelPar_RBI,
   bool modelPar_given_RBI,
   AdmsSensFadType & modelPar_RE,
   bool modelPar_given_RE,
   AdmsSensFadType & modelPar_RS,
   bool modelPar_given_RS,
   AdmsSensFadType & modelPar_RBP,
   bool modelPar_given_RBP,
   AdmsSensFadType & modelPar_IS,
   bool modelPar_given_IS,
   AdmsSensFadType & modelPar_NF,
   bool modelPar_given_NF,
   AdmsSensFadType & modelPar_NR,
   bool modelPar_given_NR,
   AdmsSensFadType & modelPar_FC,
   bool modelPar_given_FC,
   AdmsSensFadType & modelPar_CBEO,
   bool modelPar_given_CBEO,
   AdmsSensFadType & modelPar_CJE,
   bool modelPar_given_CJE,
   AdmsSensFadType & modelPar_PE,
   bool modelPar_given_PE,
   AdmsSensFadType & modelPar_ME,
   bool modelPar_given_ME,
   AdmsSensFadType & modelPar_AJE,
   bool modelPar_given_AJE,
   AdmsSensFadType & modelPar_CBCO,
   bool modelPar_given_CBCO,
   AdmsSensFadType & modelPar_CJC,
   bool modelPar_given_CJC,
   AdmsSensFadType & modelPar_QCO,
   bool modelPar_given_QCO,
   AdmsSensFadType & modelPar_CJEP,
   bool modelPar_given_CJEP,
   AdmsSensFadType & modelPar_PC,
   bool modelPar_given_PC,
   AdmsSensFadType & modelPar_MC,
   bool modelPar_given_MC,
   AdmsSensFadType & modelPar_AJC,
   bool modelPar_given_AJC,
   AdmsSensFadType & modelPar_CJCP,
   bool modelPar_given_CJCP,
   AdmsSensFadType & modelPar_PS,
   bool modelPar_given_PS,
   AdmsSensFadType & modelPar_MS,
   bool modelPar_given_MS,
   AdmsSensFadType & modelPar_AJS,
   bool modelPar_given_AJS,
   AdmsSensFadType & modelPar_IBEI,
   bool modelPar_given_IBEI,
   AdmsSensFadType & modelPar_WBE,
   bool modelPar_given_WBE,
   AdmsSensFadType & modelPar_NEI,
   bool modelPar_given_NEI,
   AdmsSensFadType & modelPar_IBEN,
   bool modelPar_given_IBEN,
   AdmsSensFadType & modelPar_NEN,
   bool modelPar_given_NEN,
   AdmsSensFadType & modelPar_IBCI,
   bool modelPar_given_IBCI,
   AdmsSensFadType & modelPar_NCI,
   bool modelPar_given_NCI,
   AdmsSensFadType & modelPar_IBCN,
   bool modelPar_given_IBCN,
   AdmsSensFadType & modelPar_NCN,
   bool modelPar_given_NCN,
   AdmsSensFadType & modelPar_AVC1,
   bool modelPar_given_AVC1,
   AdmsSensFadType & modelPar_AVC2,
   bool modelPar_given_AVC2,
   AdmsSensFadType & modelPar_ISP,
   bool modelPar_given_ISP,
   AdmsSensFadType & modelPar_WSP,
   bool modelPar_given_WSP,
   AdmsSensFadType & modelPar_NFP,
   bool modelPar_given_NFP,
   AdmsSensFadType & modelPar_IBEIP,
   bool modelPar_given_IBEIP,
   AdmsSensFadType & modelPar_IBENP,
   bool modelPar_given_IBENP,
   AdmsSensFadType & modelPar_IBCIP,
   bool modelPar_given_IBCIP,
   AdmsSensFadType & modelPar_NCIP,
   bool modelPar_given_NCIP,
   AdmsSensFadType & modelPar_IBCNP,
   bool modelPar_given_IBCNP,
   AdmsSensFadType & modelPar_NCNP,
   bool modelPar_given_NCNP,
   AdmsSensFadType & modelPar_VEF,
   bool modelPar_given_VEF,
   AdmsSensFadType & modelPar_VER,
   bool modelPar_given_VER,
   AdmsSensFadType & modelPar_IKF,
   bool modelPar_given_IKF,
   AdmsSensFadType & modelPar_IKR,
   bool modelPar_given_IKR,
   AdmsSensFadType & modelPar_IKP,
   bool modelPar_given_IKP,
   AdmsSensFadType & modelPar_TF,
   bool modelPar_given_TF,
   AdmsSensFadType & modelPar_QTF,
   bool modelPar_given_QTF,
   AdmsSensFadType & modelPar_XTF,
   bool modelPar_given_XTF,
   AdmsSensFadType & modelPar_VTF,
   bool modelPar_given_VTF,
   AdmsSensFadType & modelPar_ITF,
   bool modelPar_given_ITF,
   AdmsSensFadType & modelPar_TR,
   bool modelPar_given_TR,
   AdmsSensFadType & modelPar_TD,
   bool modelPar_given_TD,
   AdmsSensFadType & modelPar_KFN,
   bool modelPar_given_KFN,
   AdmsSensFadType & modelPar_AFN,
   bool modelPar_given_AFN,
   AdmsSensFadType & modelPar_BFN,
   bool modelPar_given_BFN,
   AdmsSensFadType & modelPar_XRE,
   bool modelPar_given_XRE,
   AdmsSensFadType & modelPar_XRBI,
   bool modelPar_given_XRBI,
   AdmsSensFadType & modelPar_XRCI,
   bool modelPar_given_XRCI,
   AdmsSensFadType & modelPar_XRS,
   bool modelPar_given_XRS,
   AdmsSensFadType & modelPar_XVO,
   bool modelPar_given_XVO,
   AdmsSensFadType & modelPar_EA,
   bool modelPar_given_EA,
   AdmsSensFadType & modelPar_EAIE,
   bool modelPar_given_EAIE,
   AdmsSensFadType & modelPar_EAIC,
   bool modelPar_given_EAIC,
   AdmsSensFadType & modelPar_EAIS,
   bool modelPar_given_EAIS,
   AdmsSensFadType & modelPar_EANE,
   bool modelPar_given_EANE,
   AdmsSensFadType & modelPar_EANC,
   bool modelPar_given_EANC,
   AdmsSensFadType & modelPar_EANS,
   bool modelPar_given_EANS,
   AdmsSensFadType & modelPar_XIS,
   bool modelPar_given_XIS,
   AdmsSensFadType & modelPar_XII,
   bool modelPar_given_XII,
   AdmsSensFadType & modelPar_XIN,
   bool modelPar_given_XIN,
   AdmsSensFadType & modelPar_TNF,
   bool modelPar_given_TNF,
   AdmsSensFadType & modelPar_TAVC,
   bool modelPar_given_TAVC,
   AdmsSensFadType & modelPar_RTH,
   bool modelPar_given_RTH,
   AdmsSensFadType & modelPar_CTH,
   bool modelPar_given_CTH,
   AdmsSensFadType & modelPar_VRT,
   bool modelPar_given_VRT,
   AdmsSensFadType & modelPar_ART,
   bool modelPar_given_ART,
   AdmsSensFadType & modelPar_CCSO,
   bool modelPar_given_CCSO,
   AdmsSensFadType & modelPar_QBM,
   bool modelPar_given_QBM,
   AdmsSensFadType & modelPar_NKF,
   bool modelPar_given_NKF,
   AdmsSensFadType & modelPar_XIKF,
   bool modelPar_given_XIKF,
   AdmsSensFadType & modelPar_XRCX,
   bool modelPar_given_XRCX,
   AdmsSensFadType & modelPar_XRBX,
   bool modelPar_given_XRBX,
   AdmsSensFadType & modelPar_XRBP,
   bool modelPar_given_XRBP,
   AdmsSensFadType & modelPar_ISRR,
   bool modelPar_given_ISRR,
   AdmsSensFadType & modelPar_XISR,
   bool modelPar_given_XISR,
   AdmsSensFadType & modelPar_DEAR,
   bool modelPar_given_DEAR,
   AdmsSensFadType & modelPar_EAP,
   bool modelPar_given_EAP,
   AdmsSensFadType & modelPar_VBBE,
   bool modelPar_given_VBBE,
   AdmsSensFadType & modelPar_NBBE,
   bool modelPar_given_NBBE,
   AdmsSensFadType & modelPar_IBBE,
   bool modelPar_given_IBBE,
   AdmsSensFadType & modelPar_TVBBE1,
   bool modelPar_given_TVBBE1,
   AdmsSensFadType & modelPar_TVBBE2,
   bool modelPar_given_TVBBE2,
   AdmsSensFadType & modelPar_TNBBE,
   bool modelPar_given_TNBBE,
   AdmsSensFadType & modelPar_EBBE,
   bool modelPar_given_EBBE,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_VERS,
   bool modelPar_given_VERS,
   AdmsSensFadType & modelPar_VREV,
   bool modelPar_given_VREV,
   // non-reals (including hidden)
   int modelPar_dtype,
   double admsTemperature, double gmin, const Instance & theInstance);

#endif // Xyce_ADMS_SENSITIVITIES


// Limited exponential --- NOT what verilog LRM says, but what qucs,
// ng-spice, and zspice do.

template <typename T>
T limexp(const T &x)
{
  if ((x) < 80.0)
    return (exp(x));
  else
    return (exp(80.0)*(x-79.0));
}

// Maybe this will do as a substitute for a sacado-provided "floor" and "ceil"?
// It is wrong to try to propagate the Sacado derivatives to the return
// value, as the floor and ceil functions have zero derivative w.r.t. any
// of the variables in the argument, except when X is an integer at which
// point the derivative is undefined.
template <typename T>
double ADMSfloor(const T & x)
{
  return (floor(x.val())); 
}

template <typename T>
double ADMSceil(const T & x)
{
  return (ceil(x.val()));
}


struct Traits: public DeviceTraits<Model, Instance, BJT::Traits>
{
  static const char *name() {return "VBIC 3T et cf v1.2";}
  static const char *deviceTypeName() {return "q level 10";}

  static int numNodes() {return 4;}
  static int numOptionalNodes() {return 5;}
  static bool modelRequired() {return true;}
  static bool isLinearDevice() {return false;}

  static Device *factory(const Configuration &configuration, const FactoryBlock &factory_block);
  static void loadModelParameters(ParametricData<Model> &model_parameters);
  static void loadInstanceParameters(ParametricData<Instance> &instance_parameters);
};

//-----------------------------------------------------------------------------
// Class         : Instance

//
// Purpose       : This class represents a single instance  of the
//                 device.  It mainly contains indices and pointers into
//                 the matrix equation (see the resistor instance class for
//                 more details).
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class Instance : public DeviceInstance
{
  friend class ParametricData<Instance>;
  friend class Model;
#ifdef Xyce_ADMS_SENSITIVITIES
  friend class InstanceSensitivity;
  friend class ModelSensitivity;
#endif // Xyce_ADMS_SENSITIVITIES
  friend class Traits;

public:
  Instance(
     const Configuration &       configuration,
     const InstanceBlock &       instance_block,
     Model &                     model,
     const FactoryBlock &        factory_block);

  ~Instance();

private:
  Instance(const Instance &);
  Instance &operator=(const Instance &);

public:
  void registerLIDs( const LocalIdVector & intLIDVecRef,
                     const LocalIdVector & extLIDVecRef );
  void registerStoreLIDs( const LocalIdVector & stoLIDVecRef );
  void setupPointers();

  void loadNodeSymbols(Util::SymbolTable &symbol_table) const;

  const JacobianStamp & jacobianStamp() const;
  void registerJacLIDs( const JacobianStamp & jacLIDVec );

  void registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef);
    
  bool processParams();
  bool updateTemperature ( const double & temp = -999.0 );
  bool updateIntermediateVars ();
  bool updatePrimaryState ();
  bool updateSecondaryState ();

  // load functions, residual:
  bool loadDAEQVector ();
  bool loadDAEFVector ();

  // load functions, Jacobian:
  bool loadDAEdQdx ();
  bool loadDAEdFdx ();

  void collapseNodes();
    
private:

public:
  // iterator reference to the vbic model which owns this instance.
  // Getters and setters
  Model &getModel()
  {
    return model_;
  }

private:

  Model & model_;   //< Owning Model
  // Begin verilog Instance Variables
  //   Instance Parameters
  double DTEMP;
  int M;
  //  Variables of global_instance scope
  // end verilog Instance Variables=====
  // Nodal LID Variables
  int li_c;
  int li_b;
  int li_e;
  int li_dt;
  int li_cx;
  int li_ci;
  int li_bx;
  int li_bi;
  int li_ei;
  int li_bp;
  // end Nodal LID Variables
  // Branch LID Variables
  // end Branch LID Variables
  // Lead (branch) LID Variables
  int li_branch_ic;
  int li_branch_ib;
  int li_branch_ie;
  int li_branch_idt;
  // end Lead (branch) LID Variables
  // Jacobian  pointers
  double * f_bi_Equ_bi_Node_Ptr;
  double * f_bi_Equ_ei_Node_Ptr;
  double * f_ei_Equ_bi_Node_Ptr;
  double * f_ei_Equ_ei_Node_Ptr;
  double * f_bi_Equ_dt_Node_Ptr;
  double * f_ei_Equ_dt_Node_Ptr;
  double * f_bx_Equ_bx_Node_Ptr;
  double * f_bx_Equ_ei_Node_Ptr;
  double * f_ei_Equ_bx_Node_Ptr;
  double * f_bx_Equ_dt_Node_Ptr;
  double * f_ci_Equ_bi_Node_Ptr;
  double * f_ci_Equ_ci_Node_Ptr;
  double * f_ei_Equ_ci_Node_Ptr;
  double * f_ci_Equ_ei_Node_Ptr;
  double * f_ci_Equ_dt_Node_Ptr;
  double * f_bi_Equ_ci_Node_Ptr;
  double * f_bx_Equ_bp_Node_Ptr;
  double * f_bp_Equ_bx_Node_Ptr;
  double * f_bp_Equ_bp_Node_Ptr;
  double * f_bp_Equ_dt_Node_Ptr;
  double * f_c_Equ_dt_Node_Ptr;
  double * f_cx_Equ_dt_Node_Ptr;
  double * f_c_Equ_c_Node_Ptr;
  double * f_c_Equ_cx_Node_Ptr;
  double * f_cx_Equ_c_Node_Ptr;
  double * f_cx_Equ_cx_Node_Ptr;
  double * f_cx_Equ_bi_Node_Ptr;
  double * f_ci_Equ_cx_Node_Ptr;
  double * f_cx_Equ_ci_Node_Ptr;
  double * f_b_Equ_dt_Node_Ptr;
  double * f_b_Equ_b_Node_Ptr;
  double * f_b_Equ_bx_Node_Ptr;
  double * f_bx_Equ_b_Node_Ptr;
  double * f_bx_Equ_bi_Node_Ptr;
  double * f_bx_Equ_ci_Node_Ptr;
  double * f_bi_Equ_bx_Node_Ptr;
  double * f_e_Equ_dt_Node_Ptr;
  double * f_e_Equ_e_Node_Ptr;
  double * f_e_Equ_ei_Node_Ptr;
  double * f_ei_Equ_e_Node_Ptr;
  double * f_bp_Equ_bi_Node_Ptr;
  double * f_bp_Equ_ci_Node_Ptr;
  double * f_cx_Equ_bx_Node_Ptr;
  double * f_cx_Equ_bp_Node_Ptr;
  double * f_bp_Equ_cx_Node_Ptr;
  double * f_bi_Equ_cx_Node_Ptr;
  double * f_b_Equ_e_Node_Ptr;
  double * f_e_Equ_b_Node_Ptr;
  double * f_b_Equ_c_Node_Ptr;
  double * f_c_Equ_b_Node_Ptr;
  double * f_dt_Equ_dt_Node_Ptr;
  double * f_dt_Equ_bp_Node_Ptr;
  double * f_dt_Equ_cx_Node_Ptr;
  double * f_dt_Equ_e_Node_Ptr;
  double * f_dt_Equ_ei_Node_Ptr;
  double * f_dt_Equ_bx_Node_Ptr;
  double * f_dt_Equ_bi_Node_Ptr;
  double * f_dt_Equ_b_Node_Ptr;
  double * f_dt_Equ_ci_Node_Ptr;
  double * f_dt_Equ_c_Node_Ptr;
  double * q_bi_Equ_bi_Node_Ptr;
  double * q_bi_Equ_ei_Node_Ptr;
  double * q_ei_Equ_bi_Node_Ptr;
  double * q_ei_Equ_ei_Node_Ptr;
  double * q_bi_Equ_dt_Node_Ptr;
  double * q_ei_Equ_dt_Node_Ptr;
  double * q_bx_Equ_bx_Node_Ptr;
  double * q_bx_Equ_ei_Node_Ptr;
  double * q_ei_Equ_bx_Node_Ptr;
  double * q_bx_Equ_dt_Node_Ptr;
  double * q_ci_Equ_bi_Node_Ptr;
  double * q_ci_Equ_ci_Node_Ptr;
  double * q_ei_Equ_ci_Node_Ptr;
  double * q_ci_Equ_ei_Node_Ptr;
  double * q_ci_Equ_dt_Node_Ptr;
  double * q_bi_Equ_ci_Node_Ptr;
  double * q_bx_Equ_bp_Node_Ptr;
  double * q_bp_Equ_bx_Node_Ptr;
  double * q_bp_Equ_bp_Node_Ptr;
  double * q_bp_Equ_dt_Node_Ptr;
  double * q_c_Equ_dt_Node_Ptr;
  double * q_cx_Equ_dt_Node_Ptr;
  double * q_c_Equ_c_Node_Ptr;
  double * q_c_Equ_cx_Node_Ptr;
  double * q_cx_Equ_c_Node_Ptr;
  double * q_cx_Equ_cx_Node_Ptr;
  double * q_cx_Equ_bi_Node_Ptr;
  double * q_ci_Equ_cx_Node_Ptr;
  double * q_cx_Equ_ci_Node_Ptr;
  double * q_b_Equ_dt_Node_Ptr;
  double * q_b_Equ_b_Node_Ptr;
  double * q_b_Equ_bx_Node_Ptr;
  double * q_bx_Equ_b_Node_Ptr;
  double * q_bx_Equ_bi_Node_Ptr;
  double * q_bx_Equ_ci_Node_Ptr;
  double * q_bi_Equ_bx_Node_Ptr;
  double * q_e_Equ_dt_Node_Ptr;
  double * q_e_Equ_e_Node_Ptr;
  double * q_e_Equ_ei_Node_Ptr;
  double * q_ei_Equ_e_Node_Ptr;
  double * q_bp_Equ_bi_Node_Ptr;
  double * q_bp_Equ_ci_Node_Ptr;
  double * q_cx_Equ_bx_Node_Ptr;
  double * q_cx_Equ_bp_Node_Ptr;
  double * q_bp_Equ_cx_Node_Ptr;
  double * q_bi_Equ_cx_Node_Ptr;
  double * q_b_Equ_e_Node_Ptr;
  double * q_e_Equ_b_Node_Ptr;
  double * q_b_Equ_c_Node_Ptr;
  double * q_c_Equ_b_Node_Ptr;
  double * q_dt_Equ_dt_Node_Ptr;
  double * q_dt_Equ_bp_Node_Ptr;
  double * q_dt_Equ_cx_Node_Ptr;
  double * q_dt_Equ_e_Node_Ptr;
  double * q_dt_Equ_ei_Node_Ptr;
  double * q_dt_Equ_bx_Node_Ptr;
  double * q_dt_Equ_bi_Node_Ptr;
  double * q_dt_Equ_b_Node_Ptr;
  double * q_dt_Equ_ci_Node_Ptr;
  double * q_dt_Equ_c_Node_Ptr;
  // Jacobian offsets
  int A_bi_Equ_bi_NodeOffset;
  int A_bi_Equ_ei_NodeOffset;
  int A_ei_Equ_bi_NodeOffset;
  int A_ei_Equ_ei_NodeOffset;
  int A_bi_Equ_dt_NodeOffset;
  int A_ei_Equ_dt_NodeOffset;
  int A_bx_Equ_bx_NodeOffset;
  int A_bx_Equ_ei_NodeOffset;
  int A_ei_Equ_bx_NodeOffset;
  int A_bx_Equ_dt_NodeOffset;
  int A_ci_Equ_bi_NodeOffset;
  int A_ci_Equ_ci_NodeOffset;
  int A_ei_Equ_ci_NodeOffset;
  int A_ci_Equ_ei_NodeOffset;
  int A_ci_Equ_dt_NodeOffset;
  int A_bi_Equ_ci_NodeOffset;
  int A_bx_Equ_bp_NodeOffset;
  int A_bp_Equ_bx_NodeOffset;
  int A_bp_Equ_bp_NodeOffset;
  int A_bp_Equ_dt_NodeOffset;
  int A_c_Equ_dt_NodeOffset;
  int A_cx_Equ_dt_NodeOffset;
  int A_c_Equ_c_NodeOffset;
  int A_c_Equ_cx_NodeOffset;
  int A_cx_Equ_c_NodeOffset;
  int A_cx_Equ_cx_NodeOffset;
  int A_cx_Equ_bi_NodeOffset;
  int A_ci_Equ_cx_NodeOffset;
  int A_cx_Equ_ci_NodeOffset;
  int A_b_Equ_dt_NodeOffset;
  int A_b_Equ_b_NodeOffset;
  int A_b_Equ_bx_NodeOffset;
  int A_bx_Equ_b_NodeOffset;
  int A_bx_Equ_bi_NodeOffset;
  int A_bx_Equ_ci_NodeOffset;
  int A_bi_Equ_bx_NodeOffset;
  int A_e_Equ_dt_NodeOffset;
  int A_e_Equ_e_NodeOffset;
  int A_e_Equ_ei_NodeOffset;
  int A_ei_Equ_e_NodeOffset;
  int A_bp_Equ_bi_NodeOffset;
  int A_bp_Equ_ci_NodeOffset;
  int A_cx_Equ_bx_NodeOffset;
  int A_cx_Equ_bp_NodeOffset;
  int A_bp_Equ_cx_NodeOffset;
  int A_bi_Equ_cx_NodeOffset;
  int A_b_Equ_e_NodeOffset;
  int A_e_Equ_b_NodeOffset;
  int A_b_Equ_c_NodeOffset;
  int A_c_Equ_b_NodeOffset;
  int A_dt_Equ_dt_NodeOffset;
  int A_dt_Equ_bp_NodeOffset;
  int A_dt_Equ_cx_NodeOffset;
  int A_dt_Equ_e_NodeOffset;
  int A_dt_Equ_ei_NodeOffset;
  int A_dt_Equ_bx_NodeOffset;
  int A_dt_Equ_bi_NodeOffset;
  int A_dt_Equ_b_NodeOffset;
  int A_dt_Equ_ci_NodeOffset;
  int A_dt_Equ_c_NodeOffset;
  // end of Jacobian and pointers
  // node numbers
  static const int admsNodeID_c = 0;
  static const int admsNodeID_b = 1;
  static const int admsNodeID_e = 2;
  static const int admsNodeID_dt = 3;
  static const int admsNodeID_cx = 4;
  static const int admsNodeID_ci = 5;
  static const int admsNodeID_bx = 6;
  static const int admsNodeID_bi = 7;
  static const int admsNodeID_ei = 8;
  static const int admsNodeID_bp = 9;
  static const int admsNodeID_GND = -1;
  // end node numbers
  // Additional IDs for branch equations
  // end branch numbers
  // Probe numbers
  static const int admsProbeID_V_ci_ei = 0;
  static const int admsProbeID_V_b_c = 1;
  static const int admsProbeID_V_bp_cx = 2;
  static const int admsProbeID_V_e_ei = 3;
  static const int admsProbeID_V_b_bx = 4;
  static const int admsProbeID_V_bx_bi = 5;
  static const int admsProbeID_V_cx_ci = 6;
  static const int admsProbeID_V_c_cx = 7;
  static const int admsProbeID_V_b_e = 8;
  static const int admsProbeID_V_dt_GND = 9;
  static const int admsProbeID_V_bx_bp = 10;
  static const int admsProbeID_V_bi_cx = 11;
  static const int admsProbeID_V_bx_ei = 12;
  static const int admsProbeID_V_bi_ci = 13;
  static const int admsProbeID_V_bi_ei = 14;
  // end probe numbers
  // Store LIDs
  int li_store_admsProbeID_V_bi_ei;
  int li_store_admsProbeID_V_bi_ci;
  int li_store_admsProbeID_V_bx_ei;
  int li_store_admsProbeID_V_bi_cx;
  int li_store_admsProbeID_V_bx_bp;
  int li_store_admsProbeID_V_dt_GND;
  int li_store_admsProbeID_V_b_e;
  // end store LIDs
  // bools for collapsing nodes
  bool collapseNode_cx;
  bool collapseNode_bx;
  bool collapseNode_ei;
  // Arrays to hold probes
  std::vector < AdmsFadType > probeVars;
  // Arrays to hold contributions
  // dynamic contributions are differentiated w.r.t time
  std::vector < AdmsFadType > staticContributions;
  std::vector < AdmsFadType > dynamicContributions;

  // This array stores the differences between original and limited variables.
  std::vector<double> probeDiffs;
  // These store the Jdxp's for F and Q, respectively
  std::vector<double> Jdxp_static;
  std::vector<double> Jdxp_dynamic;

  // this is what we'll use when any model uses $temperature.  We'll
  // set it in updateTemperature, and initialize it to whatever
  // is in devOptions when the instance is constructed.
  double admsTemperature;

  // vt at $temperature;
  double adms_vt_nom;

  // This is used to flag whether the cx, bx, and ei nodes are exposed
  // on the instance line as external nodes.
  bool externalNodeMode;


  // This one is for the annoying bogus "XyceADMSInstTemp" parameter
  // that we need so we can set it from the device manager when there's no
  // "TEMP" parameter to use
  double admsInstTemp;


  JacobianStamp jacStamp;
  IdVector nodeMap;
  PairMap pairToJacStampMap;

  // These instance-owned vectors are for storage of lead current data
  std::vector<double> leadCurrentF;
  std::vector<double> leadCurrentQ;
};



namespace AnalogFunctions
{

// Analog Function limRTH
template<typename ScalarT> ScalarT limRTH(ScalarT orig, ScalarT old)
{


  ScalarT limRTH;
  ScalarT t0;
  ScalarT t1;
  ScalarT retval;
  {
    t0 = (orig-old);
    t1 = fabs(t0);
    retval = orig;
    if ((t1>5.0))
    {
      if ((t0>0))
      {
        retval = (old+5.0);
      }
      else
      {
        retval = (old-5.0);
      }
    }
    limRTH = retval;
  }
  return(limRTH);
}

}


//-----------------------------------------------------------------------------
// Class         : Model

// Purpose       :
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class Model : public DeviceModel
{
  typedef std::vector<Instance *> InstanceVector;

  friend class ParametricData<Model>;
  friend class Instance;
#ifdef Xyce_ADMS_SENSITIVITIES
  friend class InstanceSensitivity;
  friend class ModelSensitivity;
#endif // Xyce_ADMS_SENSITIVITIES
  friend class Traits;

public:
  Model(
     const Configuration &       configuration,
     const ModelBlock &          model_block,
     const FactoryBlock &        factory_block);

  ~Model();

private:
  Model(const Model &);
  Model &operator=(const Model &);

public:
  virtual void forEachInstance(DeviceInstanceOp &op) const /* override */;
  virtual std::ostream &printOutInstances(std::ostream &os) const;
  bool processParams();
  bool processInstanceParams();

private:

public:
  void addInstance(Instance *instance)
  {
    instanceContainer.push_back(instance);
  }

private:
  std::vector<Instance*> instanceContainer;

private:

  // This one is for the annoying bogus "XyceADMSInstTemp" parameter
  // that we need so we can set it from the device manager when there's no
  // "TEMP" model parameter to use
  double admsModTemp;
  // Begin verilog Model Variables
  //   Model Parameters
  double TNOM;
  double RCX;
  double RCI;
  double VO;
  double GAMM;
  double HRCF;
  double RBX;
  double RBI;
  double RE;
  double RS;
  double RBP;
  double IS;
  double NF;
  double NR;
  double FC;
  double CBEO;
  double CJE;
  double PE;
  double ME;
  double AJE;
  double CBCO;
  double CJC;
  double QCO;
  double CJEP;
  double PC;
  double MC;
  double AJC;
  double CJCP;
  double PS;
  double MS;
  double AJS;
  double IBEI;
  double WBE;
  double NEI;
  double IBEN;
  double NEN;
  double IBCI;
  double NCI;
  double IBCN;
  double NCN;
  double AVC1;
  double AVC2;
  double ISP;
  double WSP;
  double NFP;
  double IBEIP;
  double IBENP;
  double IBCIP;
  double NCIP;
  double IBCNP;
  double NCNP;
  double VEF;
  double VER;
  double IKF;
  double IKR;
  double IKP;
  double TF;
  double QTF;
  double XTF;
  double VTF;
  double ITF;
  double TR;
  double TD;
  double KFN;
  double AFN;
  double BFN;
  double XRE;
  double XRBI;
  double XRCI;
  double XRS;
  double XVO;
  double EA;
  double EAIE;
  double EAIC;
  double EAIS;
  double EANE;
  double EANC;
  double EANS;
  double XIS;
  double XII;
  double XIN;
  double TNF;
  double TAVC;
  double RTH;
  double CTH;
  double VRT;
  double ART;
  double CCSO;
  double QBM;
  double NKF;
  double XIKF;
  double XRCX;
  double XRBX;
  double XRBP;
  double ISRR;
  double XISR;
  double DEAR;
  double EAP;
  double VBBE;
  double NBBE;
  double IBBE;
  double TVBBE1;
  double TVBBE2;
  double TNBBE;
  double EBBE;
  double DTEMP;
  double VERS;
  double VREV;
  int dtype;
  //  Variables of global_model scope
  // end verilog model variables=====
};

void registerDevice();

} // namespace ADMSvbic
} // namespace Device
} // namespace Xyce
#endif //Xyce_N_DEV_ADMSvbic_h
