
// -*-c++-*-
//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2016 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file bsimcmg.va with ADMS 
//                  interface for Xyce 6.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.5
//
// Creation Date  : Wed, 05 Oct 2016 09:50:51
//
//-----------------------------------------------------------------------------
#ifndef Xyce_N_DEV_ADMSbsimcmg_h
#define Xyce_N_DEV_ADMSbsimcmg_h


#include <Sacado.hpp>

#include <N_DEV_Configuration.h>
#include <N_DEV_Const.h>
#include <N_DEV_DeviceBlock.h>
#include <N_DEV_DeviceInstance.h>
#include <N_DEV_DeviceModel.h>
#include <N_DEV_MOSFET1.h>


namespace Xyce {
namespace Device {
namespace ADMSbsimcmg {

// This typedef is for our automatic differentiation:
typedef Sacado::Fad::SFad<double,14> AdmsFadType;
typedef Sacado::Fad::SFad<double,1> AdmsSensFadType;

class Model;
class Instance;
class InstanceSensitivity;

#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Class         : InstanceSensitivity
//
// Purpose       : This class is a functor for sensitivity
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class InstanceSensitivity : public baseSensitivity
{
public:
  InstanceSensitivity() :
    baseSensitivity() {};

  virtual ~InstanceSensitivity() {};

  virtual void operator()(
     const ParameterBase &entity,
     const std::string &param,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
                          ) const ;
};

static InstanceSensitivity instSens;


//-----------------------------------------------------------------------------
// Class         : ModelSensitivity
//
// Purpose       : This class is a functor for sensitivity
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class ModelSensitivity : public baseSensitivity
{
public:
  ModelSensitivity() :
    baseSensitivity() {};

  virtual ~ModelSensitivity() {};

  virtual void operator()(
     const ParameterBase &entity,
     const std::string &param,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
                          ) const ;
};

static ModelSensitivity modSens;
#endif // Xyce_ADMS_SENSITIVITIES

// general purpose free functions
// thermal voltage at kelvin temperature temp)
template <typename T> static inline T adms_vt(const T temp) {return(CONSTKoverQ*temp);};

// Figure out how to template this shiznit!
//-----------------------------------------------------------------------------


template<typename Tin>
static Tin adms_ternary_op(const bool cond, const Tin &ifTrue, const Tin &ifFalse)
{
  if (cond)
    return ifTrue;
  else
    return ifFalse;
}

template<typename Tin>
static Tin adms_ternary_op(const bool cond, const Tin &ifTrue, const double &ifFalse)
{
  if (cond)
    return ifTrue;
  else
    return Tin(ifFalse);
}

template<typename Tin>
static Tin adms_ternary_op(const bool cond, const double &ifTrue, const Tin &ifFalse)
{
  if (cond)
    return Tin(ifTrue);
  else
    return ifFalse;
}




#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Free functions used by sensitivity
// 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_s_si,
   const int admsProbeID_V_d_di,
   const int admsProbeID_V_e_g,
   const int admsProbeID_V_d_s,
   const int admsProbeID_V_g_d,
   const int admsProbeID_V_g_s,
   const int admsProbeID_V_di_d,
   const int admsProbeID_V_si_s,
   const int admsProbeID_V_g_e,
   const int admsProbeID_V_e_di,
   const int admsProbeID_V_e_si,
   const int admsProbeID_V_g_di,
   const int admsProbeID_V_di_si,
   const int admsProbeID_V_g_si,
   // node constants
   const int admsNodeID_d,
   const int admsNodeID_g,
   const int admsNodeID_s,
   const int admsNodeID_e,
   const int admsNodeID_di,
   const int admsNodeID_si,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_D,
   bool instancePar_given_D,
   AdmsSensFadType & instancePar_TFIN,
   bool instancePar_given_TFIN,
   AdmsSensFadType & instancePar_FPITCH,
   bool instancePar_given_FPITCH,
   AdmsSensFadType & instancePar_NFIN,
   bool instancePar_given_NFIN,
   AdmsSensFadType & instancePar_ASEO,
   bool instancePar_given_ASEO,
   AdmsSensFadType & instancePar_ADEO,
   bool instancePar_given_ADEO,
   AdmsSensFadType & instancePar_PSEO,
   bool instancePar_given_PSEO,
   AdmsSensFadType & instancePar_PDEO,
   bool instancePar_given_PDEO,
   AdmsSensFadType & instancePar_ASEJ,
   bool instancePar_given_ASEJ,
   AdmsSensFadType & instancePar_ADEJ,
   bool instancePar_given_ADEJ,
   AdmsSensFadType & instancePar_PSEJ,
   bool instancePar_given_PSEJ,
   AdmsSensFadType & instancePar_PDEJ,
   bool instancePar_given_PDEJ,
   AdmsSensFadType & instancePar_COVS,
   bool instancePar_given_COVS,
   AdmsSensFadType & instancePar_COVD,
   bool instancePar_given_COVD,
   AdmsSensFadType & instancePar_CGSP,
   bool instancePar_given_CGSP,
   AdmsSensFadType & instancePar_CGDP,
   bool instancePar_given_CGDP,
   AdmsSensFadType & instancePar_CDSP,
   bool instancePar_given_CDSP,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_LRSD,
   bool instancePar_given_LRSD,
   // non-reals(including hidden)
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K1SI,
   bool modelPar_given_K1SI,
   AdmsSensFadType & modelPar_K1SI1,
   bool modelPar_given_K1SI1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K1SAT,
   bool modelPar_given_K1SAT,
   AdmsSensFadType & modelPar_K1SAT1,
   bool modelPar_given_K1SAT1,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENIV,
   bool modelPar_given_QMTCENIV,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1SI,
   bool modelPar_given_LK1SI,
   AdmsSensFadType & modelPar_NK1SI,
   bool modelPar_given_NK1SI,
   AdmsSensFadType & modelPar_PK1SI,
   bool modelPar_given_PK1SI,
   AdmsSensFadType & modelPar_LK1SI1,
   bool modelPar_given_LK1SI1,
   AdmsSensFadType & modelPar_NK1SI1,
   bool modelPar_given_NK1SI1,
   AdmsSensFadType & modelPar_PK1SI1,
   bool modelPar_given_PK1SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK1SAT,
   bool modelPar_given_LK1SAT,
   AdmsSensFadType & modelPar_NK1SAT,
   bool modelPar_given_NK1SAT,
   AdmsSensFadType & modelPar_PK1SAT,
   bool modelPar_given_PK1SAT,
   AdmsSensFadType & modelPar_LK1SAT1,
   bool modelPar_given_LK1SAT1,
   AdmsSensFadType & modelPar_NK1SAT1,
   bool modelPar_given_NK1SAT1,
   AdmsSensFadType & modelPar_PK1SAT1,
   bool modelPar_given_PK1SAT1,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENIV,
   bool modelPar_given_LQMTCENIV,
   AdmsSensFadType & modelPar_NQMTCENIV,
   bool modelPar_given_NQMTCENIV,
   AdmsSensFadType & modelPar_PQMTCENIV,
   bool modelPar_given_PQMTCENIV,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_COREMOD,
   bool modelPar_given_COREMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_CAPMOD,
   bool modelPar_given_CAPMOD,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance);

void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_D,
   bool instancePar_given_D,
   AdmsSensFadType & instancePar_TFIN,
   bool instancePar_given_TFIN,
   AdmsSensFadType & instancePar_FPITCH,
   bool instancePar_given_FPITCH,
   AdmsSensFadType & instancePar_NFIN,
   bool instancePar_given_NFIN,
   AdmsSensFadType & instancePar_ASEO,
   bool instancePar_given_ASEO,
   AdmsSensFadType & instancePar_ADEO,
   bool instancePar_given_ADEO,
   AdmsSensFadType & instancePar_PSEO,
   bool instancePar_given_PSEO,
   AdmsSensFadType & instancePar_PDEO,
   bool instancePar_given_PDEO,
   AdmsSensFadType & instancePar_ASEJ,
   bool instancePar_given_ASEJ,
   AdmsSensFadType & instancePar_ADEJ,
   bool instancePar_given_ADEJ,
   AdmsSensFadType & instancePar_PSEJ,
   bool instancePar_given_PSEJ,
   AdmsSensFadType & instancePar_PDEJ,
   bool instancePar_given_PDEJ,
   AdmsSensFadType & instancePar_COVS,
   bool instancePar_given_COVS,
   AdmsSensFadType & instancePar_COVD,
   bool instancePar_given_COVD,
   AdmsSensFadType & instancePar_CGSP,
   bool instancePar_given_CGSP,
   AdmsSensFadType & instancePar_CGDP,
   bool instancePar_given_CGDP,
   AdmsSensFadType & instancePar_CDSP,
   bool instancePar_given_CDSP,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_LRSD,
   bool instancePar_given_LRSD,
   // non-reals(including hidden)
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K1SI,
   bool modelPar_given_K1SI,
   AdmsSensFadType & modelPar_K1SI1,
   bool modelPar_given_K1SI1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K1SAT,
   bool modelPar_given_K1SAT,
   AdmsSensFadType & modelPar_K1SAT1,
   bool modelPar_given_K1SAT1,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENIV,
   bool modelPar_given_QMTCENIV,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1SI,
   bool modelPar_given_LK1SI,
   AdmsSensFadType & modelPar_NK1SI,
   bool modelPar_given_NK1SI,
   AdmsSensFadType & modelPar_PK1SI,
   bool modelPar_given_PK1SI,
   AdmsSensFadType & modelPar_LK1SI1,
   bool modelPar_given_LK1SI1,
   AdmsSensFadType & modelPar_NK1SI1,
   bool modelPar_given_NK1SI1,
   AdmsSensFadType & modelPar_PK1SI1,
   bool modelPar_given_PK1SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK1SAT,
   bool modelPar_given_LK1SAT,
   AdmsSensFadType & modelPar_NK1SAT,
   bool modelPar_given_NK1SAT,
   AdmsSensFadType & modelPar_PK1SAT,
   bool modelPar_given_PK1SAT,
   AdmsSensFadType & modelPar_LK1SAT1,
   bool modelPar_given_LK1SAT1,
   AdmsSensFadType & modelPar_NK1SAT1,
   bool modelPar_given_NK1SAT1,
   AdmsSensFadType & modelPar_PK1SAT1,
   bool modelPar_given_PK1SAT1,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENIV,
   bool modelPar_given_LQMTCENIV,
   AdmsSensFadType & modelPar_NQMTCENIV,
   bool modelPar_given_NQMTCENIV,
   AdmsSensFadType & modelPar_PQMTCENIV,
   bool modelPar_given_PQMTCENIV,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_COREMOD,
   bool modelPar_given_COREMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_CAPMOD,
   bool modelPar_given_CAPMOD,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   double admsTemperature,double adms_vt_nom, double gmin, const Instance & theInstance);

void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K1SI,
   bool modelPar_given_K1SI,
   AdmsSensFadType & modelPar_K1SI1,
   bool modelPar_given_K1SI1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K1SAT,
   bool modelPar_given_K1SAT,
   AdmsSensFadType & modelPar_K1SAT1,
   bool modelPar_given_K1SAT1,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENIV,
   bool modelPar_given_QMTCENIV,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1SI,
   bool modelPar_given_LK1SI,
   AdmsSensFadType & modelPar_NK1SI,
   bool modelPar_given_NK1SI,
   AdmsSensFadType & modelPar_PK1SI,
   bool modelPar_given_PK1SI,
   AdmsSensFadType & modelPar_LK1SI1,
   bool modelPar_given_LK1SI1,
   AdmsSensFadType & modelPar_NK1SI1,
   bool modelPar_given_NK1SI1,
   AdmsSensFadType & modelPar_PK1SI1,
   bool modelPar_given_PK1SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK1SAT,
   bool modelPar_given_LK1SAT,
   AdmsSensFadType & modelPar_NK1SAT,
   bool modelPar_given_NK1SAT,
   AdmsSensFadType & modelPar_PK1SAT,
   bool modelPar_given_PK1SAT,
   AdmsSensFadType & modelPar_LK1SAT1,
   bool modelPar_given_LK1SAT1,
   AdmsSensFadType & modelPar_NK1SAT1,
   bool modelPar_given_NK1SAT1,
   AdmsSensFadType & modelPar_PK1SAT1,
   bool modelPar_given_PK1SAT1,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENIV,
   bool modelPar_given_LQMTCENIV,
   AdmsSensFadType & modelPar_NQMTCENIV,
   bool modelPar_given_NQMTCENIV,
   AdmsSensFadType & modelPar_PQMTCENIV,
   bool modelPar_given_PQMTCENIV,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_COREMOD,
   bool modelPar_given_COREMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_CAPMOD,
   bool modelPar_given_CAPMOD,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   double admsTemperature, double gmin, const Instance & theInstance);

#endif // Xyce_ADMS_SENSITIVITIES


// Limited exponential --- NOT what verilog LRM says, but what qucs,
// ng-spice, and zspice do.

template <typename T>
T limexp(const T &x)
{
  if ((x) < 80.0)
    return (exp(x));
  else
    return (exp(80.0)*(x-79.0));
}

// Maybe this will do as a substitute for a sacado-provided "floor" and "ceil"?
// It is wrong to try to propagate the Sacado derivatives to the return
// value, as the floor and ceil functions have zero derivative w.r.t. any
// of the variables in the argument, except when X is an integer at which
// point the derivative is undefined.
template <typename T>
double ADMSfloor(const T & x)
{
  return (floor(x.val())); 
}

template <typename T>
double ADMSceil(const T & x)
{
  return (ceil(x.val()));
}


struct Traits: public DeviceTraits<Model, Instance, MOSFET1::Traits>
{
  static const char *name() {return "BSIM-CMG FINFET v107.0.0";}
  static const char *deviceTypeName() {return "m level 107";}

  static int numNodes() {return 4;}
  static bool modelRequired() {return true;}
  static bool isLinearDevice() {return false;}

  static Device *factory(const Configuration &configuration, const FactoryBlock &factory_block);
  static void loadModelParameters(ParametricData<Model> &model_parameters);
  static void loadInstanceParameters(ParametricData<Instance> &instance_parameters);
};

//-----------------------------------------------------------------------------
// Class         : Instance

//
// Purpose       : This class represents a single instance  of the
//                 device.  It mainly contains indices and pointers into
//                 the matrix equation (see the resistor instance class for
//                 more details).
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class Instance : public DeviceInstance
{
  friend class ParametricData<Instance>;
  friend class Model;
#ifdef Xyce_ADMS_SENSITIVITIES
  friend class InstanceSensitivity;
  friend class ModelSensitivity;
#endif // Xyce_ADMS_SENSITIVITIES
  friend class Traits;

public:
  Instance(
     const Configuration &       configuration,
     const InstanceBlock &       instance_block,
     Model &                     model,
     const FactoryBlock &        factory_block);

  ~Instance();

private:
  Instance(const Instance &);
  Instance &operator=(const Instance &);

public:
  void registerLIDs( const LocalIdVector & intLIDVecRef,
                     const LocalIdVector & extLIDVecRef );
  void registerStoreLIDs( const LocalIdVector & stoLIDVecRef );
  void setupPointers();

  void loadNodeSymbols(Util::SymbolTable &symbol_table) const;

  const JacobianStamp & jacobianStamp() const;
  void registerJacLIDs( const JacobianStamp & jacLIDVec );

  void registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef);
    
  bool processParams();
  bool updateTemperature ( const double & temp = -999.0 );
  bool updateIntermediateVars ();
  bool updatePrimaryState ();
  bool updateSecondaryState ();

  // load functions, residual:
  bool loadDAEQVector ();
  bool loadDAEFVector ();

  // load functions, Jacobian:
  bool loadDAEdQdx ();
  bool loadDAEdFdx ();

  int getNumNoiseSources () const;  // 11
  void setupNoiseSources (Xyce::Analysis::NoiseData & noiseData);
  void getNoiseSources (Xyce::Analysis::NoiseData & noiseData);
    
private:

public:
  // iterator reference to the bsimcmg model which owns this instance.
  // Getters and setters
  Model &getModel()
  {
    return model_;
  }

private:

  Model & model_;   //< Owning Model
  // Begin verilog Instance Variables
  //   Instance Parameters
  double L;
  double D;
  double TFIN;
  double FPITCH;
  double NFIN;
  int NGCON;
  double ASEO;
  double ADEO;
  double PSEO;
  double PDEO;
  double ASEJ;
  double ADEJ;
  double PSEJ;
  double PDEJ;
  double COVS;
  double COVD;
  double CGSP;
  double CGDP;
  double CDSP;
  double NRS;
  double NRD;
  double LRSD;
  //  Variables of global_instance scope
  // end verilog Instance Variables=====
  // Nodal LID Variables
  int li_d;
  int li_g;
  int li_s;
  int li_e;
  int li_di;
  int li_si;
  // end Nodal LID Variables
  // Branch LID Variables
  // end Branch LID Variables
  // Lead (branch) LID Variables
  int li_branch_id;
  int li_branch_ig;
  int li_branch_is;
  int li_branch_ie;
  // end Lead (branch) LID Variables
  // Jacobian  pointers
  double * f_di_Equ_g_Node_Ptr;
  double * f_di_Equ_di_Node_Ptr;
  double * f_si_Equ_g_Node_Ptr;
  double * f_si_Equ_di_Node_Ptr;
  double * f_di_Equ_si_Node_Ptr;
  double * f_si_Equ_si_Node_Ptr;
  double * f_di_Equ_e_Node_Ptr;
  double * f_si_Equ_e_Node_Ptr;
  double * f_g_Equ_g_Node_Ptr;
  double * f_g_Equ_di_Node_Ptr;
  double * f_g_Equ_si_Node_Ptr;
  double * f_g_Equ_e_Node_Ptr;
  double * f_g_Equ_s_Node_Ptr;
  double * f_si_Equ_s_Node_Ptr;
  double * f_g_Equ_d_Node_Ptr;
  double * f_si_Equ_d_Node_Ptr;
  double * f_di_Equ_s_Node_Ptr;
  double * f_di_Equ_d_Node_Ptr;
  double * f_e_Equ_g_Node_Ptr;
  double * f_e_Equ_e_Node_Ptr;
  double * f_e_Equ_di_Node_Ptr;
  double * f_e_Equ_si_Node_Ptr;
  double * f_e_Equ_s_Node_Ptr;
  double * f_e_Equ_d_Node_Ptr;
  double * f_d_Equ_d_Node_Ptr;
  double * f_d_Equ_s_Node_Ptr;
  double * f_s_Equ_d_Node_Ptr;
  double * f_s_Equ_s_Node_Ptr;
  double * f_s_Equ_di_Node_Ptr;
  double * f_s_Equ_si_Node_Ptr;
  double * f_s_Equ_g_Node_Ptr;
  double * f_s_Equ_e_Node_Ptr;
  double * f_d_Equ_di_Node_Ptr;
  double * f_d_Equ_si_Node_Ptr;
  double * f_d_Equ_g_Node_Ptr;
  double * f_d_Equ_e_Node_Ptr;
  double * q_di_Equ_g_Node_Ptr;
  double * q_di_Equ_di_Node_Ptr;
  double * q_si_Equ_g_Node_Ptr;
  double * q_si_Equ_di_Node_Ptr;
  double * q_di_Equ_si_Node_Ptr;
  double * q_si_Equ_si_Node_Ptr;
  double * q_di_Equ_e_Node_Ptr;
  double * q_si_Equ_e_Node_Ptr;
  double * q_g_Equ_g_Node_Ptr;
  double * q_g_Equ_di_Node_Ptr;
  double * q_g_Equ_si_Node_Ptr;
  double * q_g_Equ_e_Node_Ptr;
  double * q_g_Equ_s_Node_Ptr;
  double * q_si_Equ_s_Node_Ptr;
  double * q_g_Equ_d_Node_Ptr;
  double * q_si_Equ_d_Node_Ptr;
  double * q_di_Equ_s_Node_Ptr;
  double * q_di_Equ_d_Node_Ptr;
  double * q_e_Equ_g_Node_Ptr;
  double * q_e_Equ_e_Node_Ptr;
  double * q_e_Equ_di_Node_Ptr;
  double * q_e_Equ_si_Node_Ptr;
  double * q_e_Equ_s_Node_Ptr;
  double * q_e_Equ_d_Node_Ptr;
  double * q_d_Equ_d_Node_Ptr;
  double * q_d_Equ_s_Node_Ptr;
  double * q_s_Equ_d_Node_Ptr;
  double * q_s_Equ_s_Node_Ptr;
  double * q_s_Equ_di_Node_Ptr;
  double * q_s_Equ_si_Node_Ptr;
  double * q_s_Equ_g_Node_Ptr;
  double * q_s_Equ_e_Node_Ptr;
  double * q_d_Equ_di_Node_Ptr;
  double * q_d_Equ_si_Node_Ptr;
  double * q_d_Equ_g_Node_Ptr;
  double * q_d_Equ_e_Node_Ptr;
  // Jacobian offsets
  int A_di_Equ_g_NodeOffset;
  int A_di_Equ_di_NodeOffset;
  int A_si_Equ_g_NodeOffset;
  int A_si_Equ_di_NodeOffset;
  int A_di_Equ_si_NodeOffset;
  int A_si_Equ_si_NodeOffset;
  int A_di_Equ_e_NodeOffset;
  int A_si_Equ_e_NodeOffset;
  int A_g_Equ_g_NodeOffset;
  int A_g_Equ_di_NodeOffset;
  int A_g_Equ_si_NodeOffset;
  int A_g_Equ_e_NodeOffset;
  int A_g_Equ_s_NodeOffset;
  int A_si_Equ_s_NodeOffset;
  int A_g_Equ_d_NodeOffset;
  int A_si_Equ_d_NodeOffset;
  int A_di_Equ_s_NodeOffset;
  int A_di_Equ_d_NodeOffset;
  int A_e_Equ_g_NodeOffset;
  int A_e_Equ_e_NodeOffset;
  int A_e_Equ_di_NodeOffset;
  int A_e_Equ_si_NodeOffset;
  int A_e_Equ_s_NodeOffset;
  int A_e_Equ_d_NodeOffset;
  int A_d_Equ_d_NodeOffset;
  int A_d_Equ_s_NodeOffset;
  int A_s_Equ_d_NodeOffset;
  int A_s_Equ_s_NodeOffset;
  int A_s_Equ_di_NodeOffset;
  int A_s_Equ_si_NodeOffset;
  int A_s_Equ_g_NodeOffset;
  int A_s_Equ_e_NodeOffset;
  int A_d_Equ_di_NodeOffset;
  int A_d_Equ_si_NodeOffset;
  int A_d_Equ_g_NodeOffset;
  int A_d_Equ_e_NodeOffset;
  // end of Jacobian and pointers
  // node numbers
  static const int admsNodeID_d = 0;
  static const int admsNodeID_g = 1;
  static const int admsNodeID_s = 2;
  static const int admsNodeID_e = 3;
  static const int admsNodeID_di = 4;
  static const int admsNodeID_si = 5;
  static const int admsNodeID_GND = -1;
  // end node numbers
  // Additional IDs for branch equations
  // end branch numbers
  // Probe numbers
  static const int admsProbeID_V_s_si = 0;
  static const int admsProbeID_V_d_di = 1;
  static const int admsProbeID_V_e_g = 2;
  static const int admsProbeID_V_d_s = 3;
  static const int admsProbeID_V_g_d = 4;
  static const int admsProbeID_V_g_s = 5;
  static const int admsProbeID_V_di_d = 6;
  static const int admsProbeID_V_si_s = 7;
  static const int admsProbeID_V_g_e = 8;
  static const int admsProbeID_V_e_di = 9;
  static const int admsProbeID_V_e_si = 10;
  static const int admsProbeID_V_g_di = 11;
  static const int admsProbeID_V_di_si = 12;
  static const int admsProbeID_V_g_si = 13;
  // end probe numbers
  // Store LIDs
  // end store LIDs
  // Arrays to hold probes
  std::vector < AdmsFadType > probeVars;
  // Arrays to hold contributions
  // dynamic contributions are differentiated w.r.t time
  std::vector < AdmsFadType > staticContributions;
  std::vector < AdmsFadType > dynamicContributions;
  //vectors to hold noise information for communication between methods
  std::vector<double> noiseContribsPower;
  std::vector<double> noiseContribsExponent;


  // this is what we'll use when any model uses $temperature.  We'll
  // set it in updateTemperature, and initialize it to whatever
  // is in devOptions when the instance is constructed.
  double admsTemperature;

  // vt at $temperature;
  double adms_vt_nom;


  // This one is for the annoying bogus "XyceADMSInstTemp" parameter
  // that we need so we can set it from the device manager when there's no
  // "TEMP" parameter to use
  double admsInstTemp;


  static JacobianStamp jacStamp;
  static IdVector nodeMap;
  static PairMap pairToJacStampMap;

  // These instance-owned vectors are for storage of lead current data
  std::vector<double> leadCurrentF;
  std::vector<double> leadCurrentQ;
};



namespace AnalogFunctions
{

// Analog Function lexp
template<typename ScalarT> ScalarT lexp(ScalarT x)
{


  ScalarT lexp;
  {
    if ((x>80.0))
    {
      lexp = (5.540622384e+34*((1.0+x)-80.0));
    }
    else
    {
      if ((x<(-80.0)))
      {
        lexp = 1.804851387e-35;
      }
      else
      {
        lexp = exp(x);
      }
    }
  }
  return(lexp);
}


// Analog Function lln
template<typename ScalarT> ScalarT lln(ScalarT x)
{


  ScalarT lln;
  {
    lln = log(std::max(x,static_cast<double>(1.0e-38)));
  }
  return(lln);
}


// Analog Function hypsmooth
template<typename ScalarT> ScalarT hypsmooth(ScalarT x, ScalarT c)
{


  ScalarT hypsmooth;
  {
    hypsmooth = (0.5*(x+sqrt(((x*x)+((4*c)*c)))));
  }
  return(hypsmooth);
}


// Analog Function hypmax
template<typename ScalarT> ScalarT hypmax(ScalarT x, ScalarT xmin, ScalarT c)
{


  ScalarT hypmax;
  {
    hypmax = (xmin+(0.5*(((x-xmin)-c)+sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))));
  }
  return(hypmax);
}

}


//-----------------------------------------------------------------------------
// Class         : Model

// Purpose       :
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class Model : public DeviceModel
{
  typedef std::vector<Instance *> InstanceVector;

  friend class ParametricData<Model>;
  friend class Instance;
#ifdef Xyce_ADMS_SENSITIVITIES
  friend class InstanceSensitivity;
  friend class ModelSensitivity;
#endif // Xyce_ADMS_SENSITIVITIES
  friend class Traits;

public:
  Model(
     const Configuration &       configuration,
     const ModelBlock &          model_block,
     const FactoryBlock &        factory_block);

  ~Model();

private:
  Model(const Model &);
  Model &operator=(const Model &);

public:
  virtual void forEachInstance(DeviceInstanceOp &op) const /* override */;
  virtual std::ostream &printOutInstances(std::ostream &os) const;
  bool processParams();
  bool processInstanceParams();

private:

public:
  void addInstance(Instance *instance)
  {
    instanceContainer.push_back(instance);
  }

private:
  std::vector<Instance*> instanceContainer;

private:

  // This one is for the annoying bogus "XyceADMSInstTemp" parameter
  // that we need so we can set it from the device manager when there's no
  // "TEMP" model parameter to use
  double admsModTemp;
  // Begin verilog Model Variables
  //   Model Parameters
  double L;
  double D;
  double TFIN;
  double FPITCH;
  int NF;
  double NFIN;
  int NGCON;
  double ASEO;
  double ADEO;
  double PSEO;
  double PDEO;
  double ASEJ;
  double ADEJ;
  double PSEJ;
  double PDEJ;
  double COVS;
  double COVD;
  double CGSP;
  double CGDP;
  double CDSP;
  double NRS;
  double NRD;
  double LRSD;
  double XL;
  double DTEMP;
  double DELVTRAND;
  double U0MULT;
  double IDS0MULT;
  int DEVTYPE;
  int BULKMOD;
  int COREMOD;
  int GEOMOD;
  int CGEO1SW;
  int RDSMOD;
  int ASYMMOD;
  int IGCMOD;
  int IGBMOD;
  int GIDLMOD;
  int IIMOD;
  int NQSMOD;
  int SHMOD;
  int RGATEMOD;
  int RGEOMOD;
  int CGEOMOD;
  int CAPMOD;
  double LINT;
  double LL;
  double LLN;
  double DLC;
  double DLCACC;
  double DLBIN;
  double LLC;
  double EOT;
  double TOXP;
  double EOTBOX;
  double HFIN;
  double FECH;
  double DELTAW;
  double FECHCV;
  double DELTAWCV;
  double NBODY;
  double NBODYN1;
  double NBODYN2;
  double NSD;
  double PHIG;
  double PHIGL;
  double PHIGN1;
  double PHIGN2;
  double EPSROX;
  double EPSRSUB;
  double EASUB;
  double NI0SUB;
  double BG0SUB;
  double NC0SUB;
  double NGATE;
  double Imin;
  double CIT;
  double CDSC;
  double CDSCN1;
  double CDSCN2;
  double CDSCD;
  double CDSCDN1;
  double CDSCDN2;
  double CDSCDR;
  double CDSCDRN1;
  double CDSCDRN2;
  double DVT0;
  double DVT1;
  double DVT1SS;
  double PHIN;
  double ETA0;
  double ETA0N1;
  double ETA0N2;
  double TETA0;
  double ETA0R;
  double TETA0R;
  double DSUB;
  double DVTP0;
  double DVTP1;
  double K1RSCE;
  double LPE0;
  double DVTSHIFT;
  double K0;
  double K01;
  double K0SI;
  double K0SI1;
  double K1SI;
  double K1SI1;
  double PHIBE;
  double K1;
  double K11;
  double K1SAT;
  double K1SAT1;
  double QMFACTOR;
  double QMTCENIV;
  double QMTCENCV;
  double QMTCENCVA;
  double AQMTCEN;
  double BQMTCEN;
  double ETAQM;
  double QM0;
  double PQM;
  double QM0ACC;
  double PQMACC;
  double VSAT;
  double VSATN1;
  double VSATN2;
  double AVSAT;
  double BVSAT;
  double VSAT1;
  double VSAT1N1;
  double VSAT1N2;
  double VSAT1R;
  double VSAT1RN1;
  double VSAT1RN2;
  double AVSAT1;
  double BVSAT1;
  double DELTAVSAT;
  double PSAT;
  double APSAT;
  double BPSAT;
  double KSATIV;
  double VSATCV;
  double AVSATCV;
  double BVSATCV;
  double DELTAVSATCV;
  double PSATCV;
  double APSATCV;
  double BPSATCV;
  double MEXP;
  double AMEXP;
  double BMEXP;
  double MEXPR;
  double AMEXPR;
  double BMEXPR;
  double PTWG;
  double PTWGR;
  double APTWG;
  double BPTWG;
  double AT;
  double TMEXP;
  double TMEXPR;
  double PTWGT;
  double U0;
  double U0N1;
  double U0N2;
  double ETAMOB;
  double UP;
  double LPA;
  double UA;
  double AUA;
  double BUA;
  double UC;
  double EU;
  double AEU;
  double BEU;
  double UD;
  double AUD;
  double BUD;
  double UCS;
  double UTE;
  double UTL;
  double EMOBT;
  double UA1;
  double UC1;
  double UD1;
  double UCSTE;
  double CHARGEWF;
  double RDSWMIN;
  double RDSW;
  double ARDSW;
  double BRDSW;
  double RSWMIN;
  double RSW;
  double ARSW;
  double BRSW;
  double RDWMIN;
  double RDW;
  double ARDW;
  double BRDW;
  double RSDR;
  double RSDRR;
  double RDDR;
  double RDDRR;
  double PRSDR;
  double PRDDR;
  double PRWGS;
  double PRWGD;
  double WR;
  double PRT;
  double TRSDR;
  double TRDDR;
  double PDIBL1;
  double PDIBL1R;
  double PDIBL2;
  double DROUT;
  double PVAG;
  double PCLM;
  double APCLM;
  double BPCLM;
  double PCLMG;
  double PCLMCV;
  double A1;
  double A11;
  double A2;
  double A21;
  double RGEXT;
  double RGFIN;
  double RSHS;
  double RSHD;
  double HEPI;
  double TSILI;
  double RHOC;
  double RHORSD;
  double CRATIO;
  double DELTAPRSD;
  int SDTERM;
  double LSP;
  double EPSRSP;
  double TGATE;
  double TMASK;
  double ASILIEND;
  double ARSDEND;
  double PRSDEND;
  double NSDE;
  double RGEOA;
  double RGEOB;
  double RGEOC;
  double RGEOD;
  double RGEOE;
  double CGEOA;
  double CGEOB;
  double CGEOC;
  double CGEOD;
  double CGEOE;
  double AIGBINV;
  double AIGBINV1;
  double BIGBINV;
  double CIGBINV;
  double EIGBINV;
  double NIGBINV;
  double AIGBACC;
  double AIGBACC1;
  double BIGBACC;
  double CIGBACC;
  double NIGBACC;
  double AIGC;
  double AIGC1;
  double BIGC;
  double CIGC;
  double PIGCD;
  double DLCIGS;
  double AIGS;
  double AIGS1;
  double BIGS;
  double CIGS;
  double DLCIGD;
  double AIGD;
  double AIGD1;
  double BIGD;
  double CIGD;
  double TOXREF;
  double TOXG;
  double NTOX;
  double POXEDGE;
  double AGISL;
  double BGISL;
  double CGISL;
  double EGISL;
  double PGISL;
  double AGIDL;
  double BGIDL;
  double CGIDL;
  double EGIDL;
  double PGIDL;
  double ALPHA0;
  double ALPHA01;
  double ALPHA1;
  double ALPHA11;
  double BETA0;
  double ALPHAII0;
  double ALPHAII01;
  double ALPHAII1;
  double ALPHAII11;
  double BETAII0;
  double BETAII1;
  double BETAII2;
  double ESATII;
  double LII;
  double SII0;
  double SII1;
  double SII2;
  double SIID;
  double EOTACC;
  double DELVFBACC;
  double CFS;
  double CFD;
  double CGSO;
  double CGDO;
  double CGSL;
  double CGDL;
  double CKAPPAS;
  double CKAPPAD;
  double CGBO;
  double CGBN;
  double CGBL;
  double CKAPPAB;
  double CSDESW;
  double CJS;
  double CJD;
  double CJSWS;
  double CJSWD;
  double CJSWGS;
  double CJSWGD;
  double PBS;
  double PBD;
  double PBSWS;
  double PBSWD;
  double PBSWGS;
  double PBSWGD;
  double MJS;
  double MJD;
  double MJSWS;
  double MJSWD;
  double MJSWGS;
  double MJSWGD;
  double SJS;
  double SJD;
  double SJSWS;
  double SJSWD;
  double SJSWGS;
  double SJSWGD;
  double MJS2;
  double MJD2;
  double MJSWS2;
  double MJSWD2;
  double MJSWGS2;
  double MJSWGD2;
  double JSS;
  double JSD;
  double JSWS;
  double JSWD;
  double JSWGS;
  double JSWGD;
  double NJS;
  double NJD;
  double IJTHSFWD;
  double IJTHDFWD;
  double IJTHSREV;
  double IJTHDREV;
  double BVS;
  double BVD;
  double XJBVS;
  double XJBVD;
  double JTSS;
  double JTSD;
  double JTSSWS;
  double JTSSWD;
  double JTSSWGS;
  double JTSSWGD;
  double JTWEFF;
  double NJTS;
  double NJTSD;
  double NJTSSW;
  double NJTSSWD;
  double NJTSSWG;
  double NJTSSWGD;
  double VTSS;
  double VTSD;
  double VTSSWS;
  double VTSSWD;
  double VTSSWGS;
  double VTSSWGD;
  double LINTIGEN;
  double NTGEN;
  double AIGEN;
  double BIGEN;
  double XRCRG1;
  double XRCRG2;
  int NSEG;
  double EF;
  double EM;
  double NOIA;
  double NOIB;
  double NOIC;
  double NTNOI;
  double TNOM;
  double TBGASUB;
  double TBGBSUB;
  double KT1;
  double KT1L;
  double TSS;
  double IIT;
  double TII;
  double TGIDL;
  double IGT;
  double TCJ;
  double TCJSW;
  double TCJSWG;
  double TPB;
  double TPBSW;
  double TPBSWG;
  double XTIS;
  double XTID;
  double XTSS;
  double XTSD;
  double XTSSWS;
  double XTSSWD;
  double XTSSWGS;
  double XTSSWGD;
  double TNJTS;
  double TNJTSD;
  double TNJTSSW;
  double TNJTSSWD;
  double TNJTSSWG;
  double TNJTSSWGD;
  double RTH0;
  double CTH0;
  double WTH0;
  double LNBODY;
  double NNBODY;
  double PNBODY;
  double LPHIG;
  double NPHIG;
  double PPHIG;
  double LNGATE;
  double NNGATE;
  double PNGATE;
  double LCIT;
  double NCIT;
  double PCIT;
  double LCDSC;
  double NCDSC;
  double PCDSC;
  double LCDSCD;
  double NCDSCD;
  double PCDSCD;
  double LCDSCDR;
  double NCDSCDR;
  double PCDSCDR;
  double LDVT0;
  double NDVT0;
  double PDVT0;
  double LDVT1;
  double NDVT1;
  double PDVT1;
  double LDVT1SS;
  double NDVT1SS;
  double PDVT1SS;
  double LPHIN;
  double NPHIN;
  double PPHIN;
  double LETA0;
  double NETA0;
  double PETA0;
  double LETA0R;
  double NETA0R;
  double PETA0R;
  double LDSUB;
  double NDSUB;
  double PDSUB;
  double LK1RSCE;
  double NK1RSCE;
  double PK1RSCE;
  double LLPE0;
  double NLPE0;
  double PLPE0;
  double LDVTSHIFT;
  double NDVTSHIFT;
  double PDVTSHIFT;
  double LPHIBE;
  double NPHIBE;
  double PPHIBE;
  double LK0;
  double NK0;
  double PK0;
  double LK01;
  double NK01;
  double PK01;
  double LK0SI;
  double NK0SI;
  double PK0SI;
  double LK0SI1;
  double NK0SI1;
  double PK0SI1;
  double LK1SI;
  double NK1SI;
  double PK1SI;
  double LK1SI1;
  double NK1SI1;
  double PK1SI1;
  double LK1;
  double NK1;
  double PK1;
  double LK11;
  double NK11;
  double PK11;
  double LK1SAT;
  double NK1SAT;
  double PK1SAT;
  double LK1SAT1;
  double NK1SAT1;
  double PK1SAT1;
  double LDVTB;
  double NDVTB;
  double PDVTB;
  double LLPEB;
  double NLPEB;
  double PLPEB;
  double LQMFACTOR;
  double NQMFACTOR;
  double PQMFACTOR;
  double LQMTCENIV;
  double NQMTCENIV;
  double PQMTCENIV;
  double LQMTCENCV;
  double NQMTCENCV;
  double PQMTCENCV;
  double LQMTCENCVA;
  double NQMTCENCVA;
  double PQMTCENCVA;
  double LVSAT;
  double NVSAT;
  double PVSAT;
  double LVSAT1;
  double NVSAT1;
  double PVSAT1;
  double LVSAT1R;
  double NVSAT1R;
  double PVSAT1R;
  double LPSAT;
  double NPSAT;
  double PPSAT;
  double LDELTAVSAT;
  double NDELTAVSAT;
  double PDELTAVSAT;
  double LKSATIV;
  double NKSATIV;
  double PKSATIV;
  double LVSATCV;
  double NVSATCV;
  double PVSATCV;
  double LPSATCV;
  double NPSATCV;
  double PPSATCV;
  double LDELTAVSATCV;
  double NDELTAVSATCV;
  double PDELTAVSATCV;
  double LMEXP;
  double NMEXP;
  double PMEXP;
  double LMEXPR;
  double NMEXPR;
  double PMEXPR;
  double LPTWG;
  double NPTWG;
  double PPTWG;
  double LPTWGR;
  double NPTWGR;
  double PPTWGR;
  double LU0;
  double NU0;
  double PU0;
  double LETAMOB;
  double NETAMOB;
  double PETAMOB;
  double LUP;
  double NUP;
  double PUP;
  double LUA;
  double NUA;
  double PUA;
  double LUC;
  double NUC;
  double PUC;
  double LEU;
  double NEU;
  double PEU;
  double LUD;
  double NUD;
  double PUD;
  double LUCS;
  double NUCS;
  double PUCS;
  double LPCLM;
  double NPCLM;
  double PPCLM;
  double LPCLMG;
  double NPCLMG;
  double PPCLMG;
  double LPCLMCV;
  double NPCLMCV;
  double PPCLMCV;
  double LA1;
  double NA1;
  double PA1;
  double LA11;
  double NA11;
  double PA11;
  double LA2;
  double NA2;
  double PA2;
  double LA21;
  double NA21;
  double PA21;
  double LRDSW;
  double NRDSW;
  double PRDSW;
  double LRSW;
  double NRSW;
  double PRSW;
  double LRDW;
  double NRDW;
  double PRDW;
  double LPRWGS;
  double NPRWGS;
  double PPRWGS;
  double LPRWGD;
  double NPRWGD;
  double PPRWGD;
  double LWR;
  double NWR;
  double PWR;
  double LPDIBL1;
  double NPDIBL1;
  double PPDIBL1;
  double LPDIBL1R;
  double NPDIBL1R;
  double PPDIBL1R;
  double LPDIBL2;
  double NPDIBL2;
  double PPDIBL2;
  double LDROUT;
  double NDROUT;
  double PDROUT;
  double LPVAG;
  double NPVAG;
  double PPVAG;
  double LAIGBINV;
  double NAIGBINV;
  double PAIGBINV;
  double LAIGBINV1;
  double NAIGBINV1;
  double PAIGBINV1;
  double LBIGBINV;
  double NBIGBINV;
  double PBIGBINV;
  double LCIGBINV;
  double NCIGBINV;
  double PCIGBINV;
  double LEIGBINV;
  double NEIGBINV;
  double PEIGBINV;
  double LNIGBINV;
  double NNIGBINV;
  double PNIGBINV;
  double LAIGBACC;
  double NAIGBACC;
  double PAIGBACC;
  double LAIGBACC1;
  double NAIGBACC1;
  double PAIGBACC1;
  double LBIGBACC;
  double NBIGBACC;
  double PBIGBACC;
  double LCIGBACC;
  double NCIGBACC;
  double PCIGBACC;
  double LNIGBACC;
  double NNIGBACC;
  double PNIGBACC;
  double LAIGC;
  double NAIGC;
  double PAIGC;
  double LAIGC1;
  double NAIGC1;
  double PAIGC1;
  double LBIGC;
  double NBIGC;
  double PBIGC;
  double LCIGC;
  double NCIGC;
  double PCIGC;
  double LPIGCD;
  double NPIGCD;
  double PPIGCD;
  double LAIGS;
  double NAIGS;
  double PAIGS;
  double LAIGS1;
  double NAIGS1;
  double PAIGS1;
  double LBIGS;
  double NBIGS;
  double PBIGS;
  double LCIGS;
  double NCIGS;
  double PCIGS;
  double LAIGD;
  double NAIGD;
  double PAIGD;
  double LAIGD1;
  double NAIGD1;
  double PAIGD1;
  double LBIGD;
  double NBIGD;
  double PBIGD;
  double LCIGD;
  double NCIGD;
  double PCIGD;
  double LNTOX;
  double NNTOX;
  double PNTOX;
  double LPOXEDGE;
  double NPOXEDGE;
  double PPOXEDGE;
  double LAGISL;
  double NAGISL;
  double PAGISL;
  double LBGISL;
  double NBGISL;
  double PBGISL;
  double LCGISL;
  double NCGISL;
  double PCGISL;
  double LEGISL;
  double NEGISL;
  double PEGISL;
  double LPGISL;
  double NPGISL;
  double PPGISL;
  double LAGIDL;
  double NAGIDL;
  double PAGIDL;
  double LBGIDL;
  double NBGIDL;
  double PBGIDL;
  double LCGIDL;
  double NCGIDL;
  double PCGIDL;
  double LEGIDL;
  double NEGIDL;
  double PEGIDL;
  double LPGIDL;
  double NPGIDL;
  double PPGIDL;
  double LALPHA0;
  double NALPHA0;
  double PALPHA0;
  double LALPHA1;
  double NALPHA1;
  double PALPHA1;
  double LALPHAII0;
  double NALPHAII0;
  double PALPHAII0;
  double LALPHAII1;
  double NALPHAII1;
  double PALPHAII1;
  double LBETA0;
  double NBETA0;
  double PBETA0;
  double LBETAII0;
  double NBETAII0;
  double PBETAII0;
  double LBETAII1;
  double NBETAII1;
  double PBETAII1;
  double LBETAII2;
  double NBETAII2;
  double PBETAII2;
  double LESATII;
  double NESATII;
  double PESATII;
  double LLII;
  double NLII;
  double PLII;
  double LSII0;
  double NSII0;
  double PSII0;
  double LSII1;
  double NSII1;
  double PSII1;
  double LSII2;
  double NSII2;
  double PSII2;
  double LSIID;
  double NSIID;
  double PSIID;
  double LCFS;
  double NCFS;
  double PCFS;
  double LCFD;
  double NCFD;
  double PCFD;
  double LCOVS;
  double NCOVS;
  double PCOVS;
  double LCOVD;
  double NCOVD;
  double PCOVD;
  double LCGSL;
  double NCGSL;
  double PCGSL;
  double LCGDL;
  double NCGDL;
  double PCGDL;
  double LCKAPPAS;
  double NCKAPPAS;
  double PCKAPPAS;
  double LCKAPPAD;
  double NCKAPPAD;
  double PCKAPPAD;
  double LCGBL;
  double NCGBL;
  double PCGBL;
  double LCKAPPAB;
  double NCKAPPAB;
  double PCKAPPAB;
  double LNTGEN;
  double NNTGEN;
  double PNTGEN;
  double LAIGEN;
  double NAIGEN;
  double PAIGEN;
  double LBIGEN;
  double NBIGEN;
  double PBIGEN;
  double LXRCRG1;
  double NXRCRG1;
  double PXRCRG1;
  double LXRCRG2;
  double NXRCRG2;
  double PXRCRG2;
  double LINTNOI;
  double LUTE;
  double NUTE;
  double PUTE;
  double LUTL;
  double NUTL;
  double PUTL;
  double LEMOBT;
  double NEMOBT;
  double PEMOBT;
  double LUA1;
  double NUA1;
  double PUA1;
  double LUC1;
  double NUC1;
  double PUC1;
  double LUD1;
  double NUD1;
  double PUD1;
  double LUCSTE;
  double NUCSTE;
  double PUCSTE;
  double LPTWGT;
  double NPTWGT;
  double PPTWGT;
  double LAT;
  double NAT;
  double PAT;
  double LSTTHETASAT;
  double NSTTHETASAT;
  double PSTTHETASAT;
  double LPRT;
  double NPRT;
  double PPRT;
  double LKT1;
  double NKT1;
  double PKT1;
  double LTSS;
  double NTSS;
  double PTSS;
  double LIIT;
  double NIIT;
  double PIIT;
  double LTII;
  double NTII;
  double PTII;
  double LTGIDL;
  double NTGIDL;
  double PTGIDL;
  double LIGT;
  double NIGT;
  double PIGT;
  //  Variables of global_model scope
  // end verilog model variables=====
};

void registerDevice();

} // namespace ADMSbsimcmg
} // namespace Device
} // namespace Xyce
#endif //Xyce_N_DEV_ADMSbsimcmg_h
