
//-----------------------------------------------------------------------------
// Copyright Notice
//
//   Copyright 2002 Sandia Corporation. Under the terms
//   of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S.
//   Government retains certain rights in this software.
//
//    Xyce(TM) Parallel Electrical Simulator
//    Copyright (C) 2002-2016 Sandia Corporation
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file juncap200.va with ADMS
//                  interface for Xyce 6.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.5
//
// Creation Date  : Wed, 05 Oct 2016 10:21:21
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSJUNCAP200.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

#include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#if defined(HAVE_UNORDERED_MAP)
#include <unordered_map>
using std::unordered_map;
#elif defined(HAVE_TR1_UNORDERED_MAP)
#include <tr1/unordered_map>
using std::tr1::unordered_map;
#else
#error neither unordered_map or tr1/unordered_map found
#endif

namespace Xyce {
namespace Device {
namespace ADMSJUNCAP200 {
JacobianStamp Instance::jacStamp;
IdVector Instance::nodeMap;
PairMap Instance::pairToJacStampMap;


//This is necessary because the IntPair usage can trip undefined references
const int Instance::admsNodeID_A;
const int Instance::admsNodeID_K;
const int Instance::admsNodeID_GND;
// Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSJUNCAP200::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSJUNCAP200::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("AB", static_cast<double>(1.0e-12), &ADMSJUNCAP200::Instance::AB)
    .setUnit(U_METER2)
    .setDescription("Junction area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LS", static_cast<double>(1.0e-6), &ADMSJUNCAP200::Instance::LS)
    .setUnit(U_METER2)
    .setDescription("STI-edge part of junction perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("LG", static_cast<double>(1.0e-6), &ADMSJUNCAP200::Instance::LG)
    .setUnit(U_METER2)
    .setDescription("Gate-edge part of junction perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSJUNCAP200::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of devices in parallel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("M", static_cast<double>(1.0), &ADMSJUNCAP200::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;


}

void Traits::loadModelParameters(ParametricData<ADMSJUNCAP200::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSJUNCAP200::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<int>(200), &ADMSJUNCAP200::Model::LEVEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Model level must be 200");
  p.addPar("TYPE", static_cast<int>(1.0), &ADMSJUNCAP200::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("Type parameter, in output value 1 reflects n-type, -1 reflects p-type");
  p.addPar("DTA", static_cast<double>(0.0), &ADMSJUNCAP200::Model::DTA)
    .setUnit(U_DEGK)
    .setDescription("Temperature offset with respect to ambient temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IMAX", static_cast<double>(1000.0), &ADMSJUNCAP200::Model::IMAX)
    .setUnit(U_AMP)
    .setDescription("Maximum current up to which forward current behaves exponentially")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("TRJ", static_cast<double>(21.0), &ADMSJUNCAP200::Model::TRJ)
    .setUnit(U_DEGC)
    .setDescription("Reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FREV", static_cast<double>(1.0e3), &ADMSJUNCAP200::Model::FREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for reverse breakdown current limitation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORBOT", static_cast<double>(1.0e-3), &ADMSJUNCAP200::Model::CJORBOT)
    .setUnit(U_FARADMM2)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORSTI", static_cast<double>(1.0e-9), &ADMSJUNCAP200::Model::CJORSTI)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CJORGAT", static_cast<double>(1.0e-9), &ADMSJUNCAP200::Model::CJORGAT)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRBOT", static_cast<double>(1.0), &ADMSJUNCAP200::Model::VBIRBOT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRSTI", static_cast<double>(1.0), &ADMSJUNCAP200::Model::VBIRSTI)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBIRGAT", static_cast<double>(1.0), &ADMSJUNCAP200::Model::VBIRGAT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBOT", static_cast<double>(0.5), &ADMSJUNCAP200::Model::PBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PSTI", static_cast<double>(0.5), &ADMSJUNCAP200::Model::PSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PGAT", static_cast<double>(0.5), &ADMSJUNCAP200::Model::PGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGBOT", static_cast<double>(1.16), &ADMSJUNCAP200::Model::PHIGBOT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGSTI", static_cast<double>(1.16), &ADMSJUNCAP200::Model::PHIGSTI)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PHIGGAT", static_cast<double>(1.16), &ADMSJUNCAP200::Model::PHIGGAT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRBOT", static_cast<double>(1.0e-12), &ADMSJUNCAP200::Model::IDSATRBOT)
    .setUnit(U_AMPMM2)
    .setDescription("Saturation current density at the reference temperature of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRSTI", static_cast<double>(1.0e-18), &ADMSJUNCAP200::Model::IDSATRSTI)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("IDSATRGAT", static_cast<double>(1.0e-18), &ADMSJUNCAP200::Model::IDSATRGAT)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHBOT", static_cast<double>(1.0e2), &ADMSJUNCAP200::Model::CSRHBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Shockley-Read-Hall prefactor of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHSTI", static_cast<double>(1.0e-4), &ADMSJUNCAP200::Model::CSRHSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CSRHGAT", static_cast<double>(1.0e-4), &ADMSJUNCAP200::Model::CSRHGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNSTI", static_cast<double>(1.0e-7), &ADMSJUNCAP200::Model::XJUNSTI)
    .setUnit(U_METER)
    .setDescription("Junction depth of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("XJUNGAT", static_cast<double>(1.0e-7), &ADMSJUNCAP200::Model::XJUNGAT)
    .setUnit(U_METER)
    .setDescription("Junction depth of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATBOT", static_cast<double>(1.0e2), &ADMSJUNCAP200::Model::CTATBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Trap-assisted tunneling prefactor of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATSTI", static_cast<double>(1.0e-4), &ADMSJUNCAP200::Model::CTATSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CTATGAT", static_cast<double>(1.0e-4), &ADMSJUNCAP200::Model::CTATGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATBOT", static_cast<double>(0.25), &ADMSJUNCAP200::Model::MEFFTATBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATSTI", static_cast<double>(0.25), &ADMSJUNCAP200::Model::MEFFTATSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("MEFFTATGAT", static_cast<double>(0.25), &ADMSJUNCAP200::Model::MEFFTATGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTBOT", static_cast<double>(1.0e-12), &ADMSJUNCAP200::Model::CBBTBOT)
    .setUnit(U_AMPVM3)
    .setDescription("Band-to-band tunneling prefactor of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTSTI", static_cast<double>(1.0e-18), &ADMSJUNCAP200::Model::CBBTSTI)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("CBBTGAT", static_cast<double>(1.0e-18), &ADMSJUNCAP200::Model::CBBTGAT)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRBOT", static_cast<double>(1.0e9), &ADMSJUNCAP200::Model::FBBTRBOT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRSTI", static_cast<double>(1.0e9), &ADMSJUNCAP200::Model::FBBTRSTI)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FBBTRGAT", static_cast<double>(1.0e9), &ADMSJUNCAP200::Model::FBBTRGAT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTBOT", static_cast<double>((-1.0e-3)), &ADMSJUNCAP200::Model::STFBBTBOT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTSTI", static_cast<double>((-1.0e-3)), &ADMSJUNCAP200::Model::STFBBTSTI)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("STFBBTGAT", static_cast<double>((-1.0e-3)), &ADMSJUNCAP200::Model::STFBBTGAT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRBOT", static_cast<double>(10.0), &ADMSJUNCAP200::Model::VBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRSTI", static_cast<double>(10.0), &ADMSJUNCAP200::Model::VBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VBRGAT", static_cast<double>(10.0), &ADMSJUNCAP200::Model::VBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRBOT", static_cast<double>(4.0), &ADMSJUNCAP200::Model::PBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRSTI", static_cast<double>(4.0), &ADMSJUNCAP200::Model::PBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("PBRGAT", static_cast<double>(4.0), &ADMSJUNCAP200::Model::PBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("SWJUNEXP", static_cast<double>(0.0), &ADMSJUNCAP200::Model::SWJUNEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for JUNCAP-express; 0=full model, 1=express model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("VJUNREF", static_cast<double>(2.5), &ADMSJUNCAP200::Model::VJUNREF)
    .setUnit(U_VOLT)
    .setDescription("Typical maximum junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;
  p.addPar("FJUNQ", static_cast<double>(0.03), &ADMSJUNCAP200::Model::FJUNQ)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction below which junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
    ;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter AB : [ 0.0,  (+inf) [
  if ( (!((AB >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter AB value " << AB << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LS : [ 0.0,  (+inf) [
  if ( (!((LS >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter LS value " << LS << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter LG : [ 0.0,  (+inf) [
  if ( (!((LG >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter LG value " << LG << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MULT : [ 0.0,  (+inf) [
  if ( (!((MULT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter MULT value " << MULT << " out of range [ 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double I5;
  double I4;
  double I3;
  double I2;
  double I1;
  double ijungat;
  double ijunsti;
  double ijunbot;
  double V5;
  double V4;
  double V3;
  double V2;
  double V1;
  double FRACI;
  double FRACNB;
  double FRACNA;
  double qjungat;
  double qjunsti;
  double qjunbot;
  double fbreakdown;
  double Fmaxr;
  double ibbt;
  double gammamax;
  double erfctimesexpmtat;
  double xerfc;
  double mtat;
  double ltat;
  double ktat;
  double wtat;
  double wgamma;
  double umaxpoweronepointfive;
  double sqrtumax;
  double umax;
  double umaxbeforelimiting;
  double twoatatoverthreebtat;
  double btat;
  double itat;
  double asrh;
  double wdep;
  double wsrh;
  double dwsrh;
  double wsrhstep;
  double vbi_minus_vjsrh;
  double isrh;
  double id;
  double tmp;
  double vav;
  double vbbt;
  double vjsrh;
  double vjlim;
  double two_psistar;
  double zinv;
  double z;
  double vj;
  double idmult;
  double h5;
  double h4;
  double h3;
  double h2d;
  double h2;
  double h1;
  double erfcpos;
  double terfc;
  double ysq;
  double alphaje;
  double zfrac;
  double tt2;
  double tt1;
  double tt0;
  double I5_cor;
  double I4_cor;
  double I3_cor;
  double I2_cor;
  double I1_cor;
  double mcor_rev;
  double m0_rev;
  double pmax;
  double vbigat2r;
  double vbisti2r;
  double vbibot2r;
  double pgat2;
  double psti2;
  double pbot2;
  double vbigat2;
  double vbisti2;
  double vbibot2;
  double vmaxgat;
  double vmaxsti;
  double vmaxbot;
  //Begin block initial_instance
  {
    AB_i = ((AB>0.0)?AB:0.0);
    LS_i = ((LS>0.0)?LS:0.0);
    LG_i = ((LG>0.0)?LG:0.0);
    MULT_i = ((MULT>0.0)?MULT:0.0);
    exp_VMAX_over_phitd = 0.0;
    if ((((model_.idsatbot)*AB_i)>0.0))
    {
      vmaxbot = ((model_.phitd)*log((((model_.IMAX_i)/((model_.idsatbot)*AB_i))+1.0)));
    }
    else
    {
      vmaxbot = 1.0e8;
    }
    if ((((model_.idsatsti)*LS_i)>0.0))
    {
      vmaxsti = ((model_.phitd)*log((((model_.IMAX_i)/((model_.idsatsti)*LS_i))+1.0)));
    }
    else
    {
      vmaxsti = 1.0e8;
    }
    if ((((model_.idsatgat)*LG_i)>0.0))
    {
      vmaxgat = ((model_.phitd)*log((((model_.IMAX_i)/((model_.idsatgat)*LG_i))+1.0)));
    }
    else
    {
      vmaxgat = 1.0e8;
    }
    VMAX = std::min(std::min(vmaxbot,vmaxsti),vmaxgat);
    if ((fabs((VMAX*(model_.phitdinv)))<2.3025850929940458e+02))
    {
      exp_VMAX_over_phitd = exp((VMAX*(model_.phitdinv)));
    }
    else
    {
      if (((VMAX*(model_.phitdinv))<0.0))
      {
        exp_VMAX_over_phitd = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX*(model_.phitdinv)))*3.3333333333333333e-01))))))));
      }
      else
      {
        exp_VMAX_over_phitd = (1.0e100*(1.0+(((VMAX*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
      }
    }
    vbibot2 = (model_.vbibot);
    vbisti2 = (model_.vbisti);
    vbigat2 = (model_.vbigat);
    pbot2 = (model_.PBOT_i);
    psti2 = (model_.PSTI_i);
    pgat2 = (model_.PGAT_i);
    vbibot2r = (model_.VBIRBOT_i);
    vbisti2r = (model_.VBIRSTI_i);
    vbigat2r = (model_.VBIRGAT_i);
    if ((AB_i==0.0))
    {
      vbibot2 = ((model_.vbisti)+(model_.vbigat));
      pbot2 = (0.9*std::min((model_.PSTI_i),(model_.PGAT_i)));
      vbibot2r = ((model_.VBIRSTI_i)+(model_.VBIRGAT_i));
    }
    if ((LS_i==0.0))
    {
      vbisti2 = ((model_.vbibot)+(model_.vbigat));
      psti2 = (0.9*std::min((model_.PBOT_i),(model_.PGAT_i)));
      vbisti2r = ((model_.VBIRBOT_i)+(model_.VBIRGAT_i));
    }
    if ((LG_i==0.0))
    {
      vbigat2 = ((model_.vbibot)+(model_.vbisti));
      pgat2 = (0.9*std::min((model_.PBOT_i),(model_.PSTI_i)));
      vbigat2r = ((model_.VBIRBOT_i)+(model_.VBIRSTI_i));
    }
    vbimin = std::min(std::min(vbibot2,vbisti2),vbigat2);
    vch = (vbimin*0.1);
    pmax = std::max(std::max(pbot2,psti2),pgat2);
    vfmin = (vbimin*(1.0-pow(2.0,((-1.0)/pmax))));
    vbbtlim = (std::min(std::min(vbibot2r,vbisti2r),vbigat2r)-5.0e-2);
    ISATFOR1 = 0.0;
    MFOR1 = 1.0;
    MFOR2 = 1.0;
    ISATFOR2 = 0.0;
    MREV = 1.0;
    ISATREV = 0.0;
    m0flag = 0.0;
    xhighf1 = 0.0;
    expxhf1 = 0.0;
    xhighf2 = 0.0;
    expxhf2 = 0.0;
    xhighr = 0.0;
    expxhr = 0.0;
    m0_rev = 0.0;
    mcor_rev = 0.0;
    I1_cor = 0.0;
    I2_cor = 0.0;
    I3_cor = 0.0;
    I4_cor = 0.0;
    I5_cor = 0.0;
    tt0 = 0.0;
    tt1 = 0.0;
    tt2 = 0.0;
    zfrac = 0.0;
    zflagbot = 1.0;
    zflagsti = 1.0;
    zflaggat = 1.0;
    alphaje = 0.0;
    if (((model_.SWJUNEXP_i)==1.0))
      //Begin block JUNCAPexpressInit
    {
      //Block-local variables for block JUNCAPexpressInit
      double ysq;
      double terfc;
      double erfcpos;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double h1;
      double h2;
      double h2d;
      double h3;
      double h4;
      double h5;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double idmult;
      double vj;
      double z;
      double zinv;
      double two_psistar;
      double vjlim;
      double vjsrh;
      double vbbt;
      double vav;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double tmp;
      double id;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double isrh;
      double vbi_minus_vjsrh;
      double wsrhstep;
      double dwsrh;
      double wsrh;
      double wdep;
      double asrh;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double itat;
      double btat;
      double twoatatoverthreebtat;
      double umaxbeforelimiting;
      double umax;
      double sqrtumax;
      double umaxpoweronepointfive;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double wgamma;
      double wtat;
      double ktat;
      double ltat;
      double mtat;
      double xerfc;
      double erfctimesexpmtat;
      double gammamax;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double ibbt;
      double Fmaxr;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double fbreakdown;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      double ijunbot;
      double ijunsti;
      double ijungat;
      double qjunbot;
      double qjunsti;
      double qjungat;
      //End of Block-local variables
      ysq = 0.0;
      terfc = 0.0;
      erfcpos = 0.0;
      h1 = 0.0;
      h2 = 0.0;
      h2d = 0.0;
      h3 = 0.0;
      h4 = 0.0;
      h5 = 0.0;
      idmult = 0.0;
      vj = 0.0;
      z = 0.0;
      zinv = 0.0;
      two_psistar = 0.0;
      vjlim = 0.0;
      vjsrh = 0.0;
      vbbt = 0.0;
      vav = 0.0;
      tmp = 0.0;
      id = 0.0;
      isrh = 0.0;
      vbi_minus_vjsrh = 0.0;
      wsrhstep = 0.0;
      dwsrh = 0.0;
      wsrh = 0.0;
      wdep = 0.0;
      asrh = 0.0;
      itat = 0.0;
      btat = 0.0;
      twoatatoverthreebtat = 0.0;
      umaxbeforelimiting = 0.0;
      umax = 0.0;
      sqrtumax = 0.0;
      umaxpoweronepointfive = 0.0;
      wgamma = 0.0;
      wtat = 0.0;
      ktat = 0.0;
      ltat = 0.0;
      mtat = 0.0;
      xerfc = 0.0;
      erfctimesexpmtat = 0.0;
      gammamax = 0.0;
      ibbt = 0.0;
      Fmaxr = 0.0;
      fbreakdown = 0.0;
      qjunbot = 0.0;
      qjunsti = 0.0;
      qjungat = 0.0;
      FRACNA = 0.4;
      FRACNB = 0.65;
      FRACI = 0.8;
      V1 = ((-FRACNA)*(model_.VJUNREF_i));
      V2 = ((-FRACNB)*(model_.VJUNREF_i));
      V3 = ((-FRACI)*(model_.VJUNREF_i));
      V4 = 0.1;
      V5 = 0.2;
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
      {
        h1 = ((4.0*vch)*vch);
        h2 = (vch/vfmin);
        h2d = (V1+(vch*h2));
        h3 = (vfmin+h2d);
        h4 = (vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V1*vfmin)/(h3+h5)));
        if ((V1<VMAX))
        {
          if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V1*(model_.phitdinv))));
          }
          else
          {
            if (((0.5*(V1*(model_.phitdinv)))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V1-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V1>0.0))
        {
          two_psistar = (2.0*((model_.phitd)*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V1)+(2.0*((model_.phitd)*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (vbimin-two_psistar);
        vjsrh = (0.5*((V1+vjlim)-sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*(model_.phitd))*(model_.phitd))))));
        vbbt = (0.5*((V1+vbbtlim)-sqrt((((V1-vbbtlim)*(V1-vbbtlim))+((4.0*(model_.phitr))*(model_.phitr))))));
        vav = (0.5*((V1)-sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if (((model_.one_minus_PBOT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvbot))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
        }
        qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V1-vj)));
        id = ((model_.idsatbot)*idmult);
        if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PBOT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          wdep = ((model_.wdepnulrbot)*tmp);
          asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
        }
        if (((model_.CTATBOT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTBOT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
          if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtbot))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTBOT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRBOT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
          {
            if (((model_.PBRBOT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvbot))),(model_.PBRBOT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if (((model_.one_minus_PSTI)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvsti))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
        }
        qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V1-vj)));
        id = ((model_.idsatsti)*idmult);
        if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PSTI_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          wdep = ((model_.wdepnulrsti)*tmp);
          asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
        }
        if (((model_.CTATSTI_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTSTI_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
          if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtsti))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTSTI_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRSTI_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
          {
            if (((model_.PBRSTI_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvsti))),(model_.PBRSTI_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if (((model_.one_minus_PGAT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvgat))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
        }
        qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V1-vj)));
        id = ((model_.idsatgat)*idmult);
        if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PGAT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          wdep = ((model_.wdepnulrgat)*tmp);
          asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
        }
        if (((model_.CTATGAT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTGAT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
          if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtgat))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTGAT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRGAT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
          {
            if (((model_.PBRGAT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvgat))),(model_.PBRGAT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I1 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
      {
        h1 = ((4.0*vch)*vch);
        h2 = (vch/vfmin);
        h2d = (V2+(vch*h2));
        h3 = (vfmin+h2d);
        h4 = (vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V2*vfmin)/(h3+h5)));
        if ((V2<VMAX))
        {
          if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V2*(model_.phitdinv))));
          }
          else
          {
            if (((0.5*(V2*(model_.phitdinv)))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V2-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V2>0.0))
        {
          two_psistar = (2.0*((model_.phitd)*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V2)+(2.0*((model_.phitd)*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (vbimin-two_psistar);
        vjsrh = (0.5*((V2+vjlim)-sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*(model_.phitd))*(model_.phitd))))));
        vbbt = (0.5*((V2+vbbtlim)-sqrt((((V2-vbbtlim)*(V2-vbbtlim))+((4.0*(model_.phitr))*(model_.phitr))))));
        vav = (0.5*((V2)-sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if (((model_.one_minus_PBOT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvbot))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
        }
        qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V2-vj)));
        id = ((model_.idsatbot)*idmult);
        if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PBOT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          wdep = ((model_.wdepnulrbot)*tmp);
          asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
        }
        if (((model_.CTATBOT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTBOT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
          if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtbot))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTBOT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRBOT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
          {
            if (((model_.PBRBOT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvbot))),(model_.PBRBOT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if (((model_.one_minus_PSTI)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvsti))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
        }
        qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V2-vj)));
        id = ((model_.idsatsti)*idmult);
        if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PSTI_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          wdep = ((model_.wdepnulrsti)*tmp);
          asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
        }
        if (((model_.CTATSTI_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTSTI_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
          if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtsti))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTSTI_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRSTI_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
          {
            if (((model_.PBRSTI_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvsti))),(model_.PBRSTI_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if (((model_.one_minus_PGAT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvgat))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
        }
        qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V2-vj)));
        id = ((model_.idsatgat)*idmult);
        if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PGAT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          wdep = ((model_.wdepnulrgat)*tmp);
          asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
        }
        if (((model_.CTATGAT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTGAT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
          if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtgat))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTGAT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRGAT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
          {
            if (((model_.PBRGAT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvgat))),(model_.PBRGAT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I2 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
      {
        h1 = ((4.0*vch)*vch);
        h2 = (vch/vfmin);
        h2d = (V3+(vch*h2));
        h3 = (vfmin+h2d);
        h4 = (vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V3*vfmin)/(h3+h5)));
        if ((V3<VMAX))
        {
          if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V3*(model_.phitdinv))));
          }
          else
          {
            if (((0.5*(V3*(model_.phitdinv)))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V3-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V3>0.0))
        {
          two_psistar = (2.0*((model_.phitd)*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V3)+(2.0*((model_.phitd)*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (vbimin-two_psistar);
        vjsrh = (0.5*((V3+vjlim)-sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*(model_.phitd))*(model_.phitd))))));
        vbbt = (0.5*((V3+vbbtlim)-sqrt((((V3-vbbtlim)*(V3-vbbtlim))+((4.0*(model_.phitr))*(model_.phitr))))));
        vav = (0.5*((V3)-sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if (((model_.one_minus_PBOT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvbot))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
        }
        qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V3-vj)));
        id = ((model_.idsatbot)*idmult);
        if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PBOT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          wdep = ((model_.wdepnulrbot)*tmp);
          asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
        }
        if (((model_.CTATBOT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTBOT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
          if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtbot))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTBOT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRBOT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
          {
            if (((model_.PBRBOT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvbot))),(model_.PBRBOT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if (((model_.one_minus_PSTI)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvsti))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
        }
        qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V3-vj)));
        id = ((model_.idsatsti)*idmult);
        if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PSTI_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          wdep = ((model_.wdepnulrsti)*tmp);
          asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
        }
        if (((model_.CTATSTI_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTSTI_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
          if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtsti))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTSTI_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRSTI_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
          {
            if (((model_.PBRSTI_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvsti))),(model_.PBRSTI_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if (((model_.one_minus_PGAT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvgat))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
        }
        qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V3-vj)));
        id = ((model_.idsatgat)*idmult);
        if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PGAT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          wdep = ((model_.wdepnulrgat)*tmp);
          asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
        }
        if (((model_.CTATGAT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTGAT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
          if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtgat))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTGAT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRGAT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
          {
            if (((model_.PBRGAT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvgat))),(model_.PBRGAT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I3 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
      {
        h1 = ((4.0*vch)*vch);
        h2 = (vch/vfmin);
        h2d = (V4+(vch*h2));
        h3 = (vfmin+h2d);
        h4 = (vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V4*vfmin)/(h3+h5)));
        if ((V4<VMAX))
        {
          if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V4*(model_.phitdinv))));
          }
          else
          {
            if (((0.5*(V4*(model_.phitdinv)))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V4-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V4>0.0))
        {
          two_psistar = (2.0*((model_.phitd)*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V4)+(2.0*((model_.phitd)*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (vbimin-two_psistar);
        vjsrh = (0.5*((V4+vjlim)-sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*(model_.phitd))*(model_.phitd))))));
        vbbt = (0.5*((V4+vbbtlim)-sqrt((((V4-vbbtlim)*(V4-vbbtlim))+((4.0*(model_.phitr))*(model_.phitr))))));
        vav = (0.5*((V4)-sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if (((model_.one_minus_PBOT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvbot))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
        }
        qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V4-vj)));
        id = ((model_.idsatbot)*idmult);
        if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PBOT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          wdep = ((model_.wdepnulrbot)*tmp);
          asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
        }
        if (((model_.CTATBOT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTBOT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
          if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtbot))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTBOT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRBOT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
          {
            if (((model_.PBRBOT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvbot))),(model_.PBRBOT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if (((model_.one_minus_PSTI)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvsti))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
        }
        qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V4-vj)));
        id = ((model_.idsatsti)*idmult);
        if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PSTI_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          wdep = ((model_.wdepnulrsti)*tmp);
          asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
        }
        if (((model_.CTATSTI_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTSTI_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
          if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtsti))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTSTI_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRSTI_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
          {
            if (((model_.PBRSTI_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvsti))),(model_.PBRSTI_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if (((model_.one_minus_PGAT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvgat))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
        }
        qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V4-vj)));
        id = ((model_.idsatgat)*idmult);
        if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PGAT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          wdep = ((model_.wdepnulrgat)*tmp);
          asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
        }
        if (((model_.CTATGAT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTGAT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
          if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtgat))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTGAT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRGAT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
          {
            if (((model_.PBRGAT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvgat))),(model_.PBRGAT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I4 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
      {
        h1 = ((4.0*vch)*vch);
        h2 = (vch/vfmin);
        h2d = (V5+(vch*h2));
        h3 = (vfmin+h2d);
        h4 = (vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V5*vfmin)/(h3+h5)));
        if ((V5<VMAX))
        {
          if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V5*(model_.phitdinv))));
          }
          else
          {
            if (((0.5*(V5*(model_.phitdinv)))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V5-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V5>0.0))
        {
          two_psistar = (2.0*((model_.phitd)*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V5)+(2.0*((model_.phitd)*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (vbimin-two_psistar);
        vjsrh = (0.5*((V5+vjlim)-sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*(model_.phitd))*(model_.phitd))))));
        vbbt = (0.5*((V5+vbbtlim)-sqrt((((V5-vbbtlim)*(V5-vbbtlim))+((4.0*(model_.phitr))*(model_.phitr))))));
        vav = (0.5*((V5)-sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if (((model_.one_minus_PBOT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvbot))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
        }
        qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V5-vj)));
        id = ((model_.idsatbot)*idmult);
        if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PBOT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          wdep = ((model_.wdepnulrbot)*tmp);
          asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
        }
        if (((model_.CTATBOT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTBOT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PBOT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
          if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtbot))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTBOT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRBOT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
          {
            if (((model_.PBRBOT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvbot))),(model_.PBRBOT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if (((model_.one_minus_PSTI)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvsti))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
        }
        qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V5-vj)));
        id = ((model_.idsatsti)*idmult);
        if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PSTI_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          wdep = ((model_.wdepnulrsti)*tmp);
          asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
        }
        if (((model_.CTATSTI_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTSTI_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PSTI_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
          if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtsti))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTSTI_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRSTI_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
          {
            if (((model_.PBRSTI_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvsti))),(model_.PBRSTI_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if (((model_.one_minus_PGAT)==0.5))
        {
          tmp = sqrt((1.0-(vj*(model_.vbiinvgat))));
        }
        else
        {
          tmp = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
        }
        qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V5-vj)));
        id = ((model_.idsatgat)*idmult);
        if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if (((model_.PGAT_i)==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
          }
          wsrh = (wsrhstep+dwsrh);
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          wdep = ((model_.wdepnulrgat)*tmp);
          asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
          isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
        }
        if (((model_.CTATGAT_i)==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
          itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
        }
        if (((model_.CBBTGAT_i)==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if (((model_.PGAT_i)==0.5))
          {
            tmp = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
          }
          else
          {
            tmp = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
          }
          Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
          if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-(model_.fbbtgat))/Fmaxr));
          }
          else
          {
            if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = ((model_.CBBTGAT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
        }
        if (((model_.VBRGAT_i)>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
          {
            if (((model_.PBRGAT_i)==4.0))
            {
              tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
            }
            else
            {
              tmp = pow(fabs((vav*(model_.VBRinvgat))),(model_.PBRGAT_i));
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I5 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
      ISATFOR1 = (((AB_i*(model_.idsatbot))+(LS_i*(model_.idsatsti)))+(LG_i*(model_.idsatgat)));
      I4_cor = (I4-(ISATFOR1*(exp(((V4*(model_.phitdinv))*MFOR1))-1.0)));
      I5_cor = (I5-(ISATFOR1*(exp(((V5*(model_.phitdinv))*MFOR1))-1.0)));
      if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
      {
        if (((I4>0.0)&&(I5>0.0)))
        {
          if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
          {
            alphaje = (I4_cor/I5_cor);
            MFOR2 = (((model_.phitd)*log(alphaje))/(V4-V5));
            ISATFOR2 = (I4_cor/(exp(((V4*(model_.phitdinv))*MFOR2))-1.0));
          }
        }
        I1_cor = ((I1-(ISATFOR1*(exp(((V1*(model_.phitdinv))*MFOR1))-1.0)))-(ISATFOR2*(exp(((V1*(model_.phitdinv))*MFOR2))-1.0)));
        I2_cor = ((I2-(ISATFOR1*(exp(((V2*(model_.phitdinv))*MFOR1))-1.0)))-(ISATFOR2*(exp(((V2*(model_.phitdinv))*MFOR2))-1.0)));
        I3_cor = ((I3-(ISATFOR1*(exp(((V3*(model_.phitdinv))*MFOR1))-1.0)))-(ISATFOR2*(exp(((V3*(model_.phitdinv))*MFOR2))-1.0)));
        if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
        {
          if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
          {
            alphaje = (I1_cor/I2_cor);
            m0_rev = (((-(model_.phitd))*log(alphaje))/(V1-V2));
            tt0 = (V2/(V2-V1));
            tt1 = (((model_.phitd)*(alphaje-1.0))*(pow(alphaje,tt0)-1.0));
            tt0 = (V1/(V1-V2));
            tt2 = (((pow(alphaje,tt0)*(V2-V1))+(alphaje*V1))-V2);
            mcor_rev = (tt1/tt2);
            MREV = (m0_rev+mcor_rev);
            if ((fabs(((V3*(model_.phitdinv))*MREV))<1.0e-6))
            {
              m0flag = 1.0;
              ISATREV = (I3_cor*((1.0/V3)+((0.5*(model_.phitdinv))*MREV)));
              MREV = (((((-0.5)*I3_cor)*MREV)*(model_.phitdinv))/V3);
            }
            else
            {
              m0flag = 0.0;
              ISATREV = ((-I3_cor)/(exp((((-V3)*(model_.phitdinv))*MREV))-1.0));
            }
          }
        }
      }
      zfrac = ((model_.FJUNQ_i)*(((AB_i*(model_.cjobot))+(LS_i*(model_.cjosti)))+(LG_i*(model_.cjogat))));
      if (((AB_i*(model_.cjobot))<=zfrac))
      {
        zflagbot = 0.0;
      }
      if (((LS_i*(model_.cjosti))<=zfrac))
      {
        zflagsti = 0.0;
      }
      if (((LG_i*(model_.cjogat))<=zfrac))
      {
        zflaggat = 0.0;
      }
      if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
      {
        xhighf1 = log(((0.5*(model_.IMAX_i))/(ISATFOR1+1.0e-21)));
        xhighf2 = log(((0.5*(model_.IMAX_i))/(ISATFOR2+1.0e-21)));
        xhighr = log(((0.5*(model_.IMAX_i))/(fabs(ISATREV)+1.0e-21)));
      }
      xhighf1 = std::min(xhighf1,static_cast<double>(2.3025850929940458e+02));
      expxhf1 = exp(xhighf1);
      xhighf2 = std::min(xhighf2,static_cast<double>(2.3025850929940458e+02));
      expxhf2 = exp(xhighf2);
      xhighr = std::min(xhighr,static_cast<double>(2.3025850929940458e+02));
      expxhr = exp(xhighr);
    }
    // End block JUNCAPexpressInit
  }
  // End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
   const Configuration & configuration,
   const InstanceBlock & instance_block,
   Model &               model,
   const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    AB(1.0e-12),
    LS(1.0e-6),
    LG(1.0e-6),
    MULT(1.0),
    MULT_i(0.0),
    AB_i(0.0),
    LS_i(0.0),
    LG_i(0.0),
    zflagbot(0.0),
    zflagsti(0.0),
    zflaggat(0.0),
    VMAX(0.0),
    exp_VMAX_over_phitd(0.0),
    vbimin(0.0),
    vch(0.0),
    vfmin(0.0),
    vbbtlim(0.0),
    xhighf1(0.0),
    expxhf1(0.0),
    xhighf2(0.0),
    expxhf2(0.0),
    xhighr(0.0),
    expxhr(0.0),
    ISATFOR1(0.0),
    MFOR1(0.0),
    ISATFOR2(0.0),
    MFOR2(0.0),
    ISATREV(0.0),
    MREV(0.0),
    m0flag(0.0),
    li_A(-1),
    li_K(-1),
    li_branch_iA(-1),
    f_A_Equ_A_Node_Ptr(0),
    f_A_Equ_K_Node_Ptr(0),
    f_K_Equ_A_Node_Ptr(0),
    f_K_Equ_K_Node_Ptr(0),
    q_A_Equ_A_Node_Ptr(0),
    q_A_Equ_K_Node_Ptr(0),
    q_K_Equ_A_Node_Ptr(0),
    q_K_Equ_K_Node_Ptr(0),
    A_A_Equ_A_NodeOffset(-1),
    A_A_Equ_K_NodeOffset(-1),
    A_K_Equ_A_NodeOffset(-1),
    A_K_Equ_K_NodeOffset(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
  numIntVars = 0 + 0;
  numExtVars = 2;


  // Right now, we only have store for limited probes...
  setNumStoreVars(0);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 1;

  leadCurrentF.resize(2);
  leadCurrentQ.resize(2);
  
  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
  PairVector jacobianElements;
  jacobianElements.push_back(IntPair(admsNodeID_A,admsNodeID_A));
  jacobianElements.push_back(IntPair(admsNodeID_A,admsNodeID_K));
  jacobianElements.push_back(IntPair(admsNodeID_K,admsNodeID_A));
  jacobianElements.push_back(IntPair(admsNodeID_K,admsNodeID_K));

  

  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;

  // Now generate the jacstamp from what we already have.
  // This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
  // node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
  // (for devices that have no collapsibles, this will be static, so check that it hasn't already
  // been filled in)
  if (jacStamp.empty())
  {
    int originalSize = 2+0;
    computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
  }

}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local ID's.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;
  
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSJUNCAP200::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
  }
    
  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_A = localLIDVec[nodeMap[admsNodeID_A]];
  li_K = localLIDVec[nodeMap[admsNodeID_K]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
    Xyce::dout() << "\nli_A = " << li_A << std::endl;
    Xyce::dout() << "\nli_K = " << li_K << std::endl;

    Xyce::dout() << "\nEnd of ADMSJUNCAP200::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_iA, getName(), "BRANCH_D");
  }
}
 
//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {    
    li_branch_iA = branchLIDVecRef[0];
  }
}
  
//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes : In initial version, we won't support mapping away nodes
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
  return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_A,admsNodeID_A)];
  A_A_Equ_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_A,admsNodeID_K)];
  A_A_Equ_K_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_K,admsNodeID_A)];
  A_K_Equ_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
  jacLoc = pairToJacStampMap[IntPair(admsNodeID_K,admsNodeID_K)];
  A_K_Equ_K_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix * dFdxMatPtr = extData.dFdxMatrixPtr;
  Linear::Matrix * dQdxMatPtr = extData.dQdxMatrixPtr;
  f_A_Equ_A_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_A,li_A);
  q_A_Equ_A_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_A,li_A);
  f_A_Equ_K_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_A,li_K);
  q_A_Equ_K_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_A,li_K);
  f_K_Equ_A_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_K,li_A);
  q_K_Equ_A_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_K,li_A);
  f_K_Equ_K_Node_Ptr = dFdxMatPtr->returnRawEntryPointer(li_K,li_K);
  q_K_Equ_K_Node_Ptr = dQdxMatPtr->returnRawEntryPointer(li_K,li_K);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
  (*extData.daeFVectorPtr)[li_A] += staticContributions[admsNodeID_A].val();
  (*extData.daeFVectorPtr)[li_K] += staticContributions[admsNodeID_K].val();


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;

    leadF[li_branch_iA] = leadCurrentF[0];

    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.
    
    double * solVec = extData.nextSolVectorRawPtr;
    double * junctionV = extData.nextJunctionVCompRawPtr;
    junctionV[li_branch_iA] = solVec[li_A] - solVec[li_K];
          
  }  
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
  (*extData.daeQVectorPtr)[li_A] += dynamicContributions[admsNodeID_A].val();
  (*extData.daeQVectorPtr)[li_K] += dynamicContributions[admsNodeID_K].val();


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;

    leadQ[li_branch_iA] = leadCurrentQ[0];
  }  
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.


  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one JUNCAP200 instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSJUNCAP200::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double h1;
  double h2;
  AdmsFadType h2d;
  AdmsFadType h3;
  AdmsFadType h4;
  AdmsFadType h5;
  AdmsFadType ijunrev;
  AdmsFadType ijunfor2;
  AdmsFadType ijunfor1;
  AdmsFadType tm1;
  AdmsFadType tm0;
  AdmsFadType fbreakdown;
  AdmsFadType ibbt;
  AdmsFadType Fmaxr;
  AdmsFadType itat;
  AdmsFadType gammamax;
  AdmsFadType erfctimesexpmtat;
  AdmsFadType erfcpos;
  AdmsFadType terfc;
  AdmsFadType ysq;
  AdmsFadType xerfc;
  AdmsFadType mtat;
  AdmsFadType ltat;
  AdmsFadType ktat;
  AdmsFadType wtat;
  AdmsFadType wgamma;
  AdmsFadType umaxpoweronepointfive;
  AdmsFadType sqrtumax;
  AdmsFadType umax;
  AdmsFadType umaxbeforelimiting;
  AdmsFadType twoatatoverthreebtat;
  AdmsFadType btat;
  AdmsFadType isrh;
  AdmsFadType asrh;
  AdmsFadType wdep;
  AdmsFadType wsrh;
  AdmsFadType dwsrh;
  AdmsFadType wsrhstep;
  AdmsFadType vbi_minus_vjsrh;
  AdmsFadType id;
  AdmsFadType tmp;
  AdmsFadType vav;
  AdmsFadType vjsrh;
  AdmsFadType vjlim;
  AdmsFadType z;
  AdmsFadType idmult;
  AdmsFadType zinv;
  AdmsFadType vj;
  AdmsFadType two_psistar;
  AdmsFadType vbbt;
  double vbisgat;
  double vbissti;
  double vbisbot;
  double cjosgat;
  double cjossti;
  double cjosbot;
  AdmsFadType si;
  AdmsFadType ij;
  double idsatsgat;
  double idsatssti;
  double idsatsbot;
  AdmsFadType ijsti;
  AdmsFadType ijgat;
  AdmsFadType ijbot;
  AdmsFadType vak;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (1))
  {
    probeVars.resize(1);
    staticContributions.resize(2+0);
    dynamicContributions.resize(2+0);
  }

  noiseContribsPower.resize(1);
  noiseContribsExponent.resize(1);
  
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 2+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // extract solution variables and set as Fad independent variables.
  probeVars[admsProbeID_V_A_K] = (*solVectorPtr)[li_A] - (*solVectorPtr)[li_K];
  probeVars[admsProbeID_V_A_K].diff(admsProbeID_V_A_K,1);
  // -- code converted from analog/code block
  //Begin block evaluateblock
  {
    //Block-local variables for block evaluateblock
    AdmsFadType ijunbot;
    AdmsFadType qjunbot;
    AdmsFadType ijunsti;
    AdmsFadType qjunsti;
    AdmsFadType ijungat;
    AdmsFadType qjungat;
    AdmsFadType ijun;
    AdmsFadType qjun;
    AdmsFadType jnoise;
    AdmsFadType VAK;
    //End of Block-local variables
    ijun = 0.0;
    ijunbot = 0.0;
    ijunsti = 0.0;
    ijungat = 0.0;
    //Begin block evaluateStaticDynamic
    {
      VAK = ((model_.TYPE)*(probeVars[admsProbeID_V_A_K]));
      if (((model_.SWJUNEXP_i)==1.0))
      {
        tm0 = ((VAK*(model_.phitdinv))*MFOR1);
        tm1 = adms_ternary_op<AdmsFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsFadType>((tm0>xhighf1),(expxhf1*((tm0-xhighf1)+1.0)),exp(tm0)));
        ijunfor1 = (ISATFOR1*(tm1-1.0));
        tm0 = ((VAK*(model_.phitdinv))*MFOR2);
        tm1 = adms_ternary_op<AdmsFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsFadType>((tm0>xhighf2),(expxhf2*((tm0-xhighf2)+1.0)),exp(tm0)));
        ijunfor2 = (ISATFOR2*(tm1-1.0));
        ijunrev = 0.0;
        if ((m0flag>0.0))
        {
          ijunrev = (VAK*(ISATREV+(VAK*MREV)));
        }
        else
        {
          tm0 = (((-VAK)*(model_.phitdinv))*MREV);
          tm1 = adms_ternary_op<AdmsFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsFadType>((tm0>xhighr),(expxhr*((tm0-xhighr)+1.0)),exp(tm0)));
          ijunrev = ((-ISATREV)*(tm1-1.0));
        }
        ijun = ((ijunfor1+ijunfor2)+ijunrev);
        //Begin block evaluateDynamic
        {
          //Block-local variables for block evaluateDynamic
          AdmsFadType tmpv;
          AdmsFadType vjv;
          //End of Block-local variables
          tmpv = 0.0;
          vjv = 0.0;
          h1 = ((4.0*vch)*vch);
          h2 = (vch/vfmin);
          h2d = (VAK+(vch*h2));
          h3 = (vfmin+h2d);
          h4 = (vfmin-h2d);
          h5 = sqrt(((h4*h4)+h1));
          vjv = (2.0*((VAK*vfmin)/(h3+h5)));
          if ((zflagbot>0.5))
          {
            if (((model_.one_minus_PBOT)==0.5))
            {
              tmpv = sqrt((1.0-(vjv*(model_.vbiinvbot))));
            }
            else
            {
              tmpv = pow((1.0-(vjv*(model_.vbiinvbot))),(model_.one_minus_PBOT));
            }
            qjunbot = (((model_.qprefbot)*(1.0-tmpv))+((model_.qpref2bot)*(VAK-vjv)));
          }
          if ((zflagsti>0.5))
          {
            if (((model_.one_minus_PSTI)==0.5))
            {
              tmpv = sqrt((1.0-(vjv*(model_.vbiinvsti))));
            }
            else
            {
              tmpv = pow((1.0-(vjv*(model_.vbiinvsti))),(model_.one_minus_PSTI));
            }
            qjunsti = (((model_.qprefsti)*(1.0-tmpv))+((model_.qpref2sti)*(VAK-vjv)));
          }
          if ((zflaggat>0.5))
          {
            if (((model_.one_minus_PGAT)==0.5))
            {
              tmpv = sqrt((1.0-(vjv*(model_.vbiinvgat))));
            }
            else
            {
              tmpv = pow((1.0-(vjv*(model_.vbiinvgat))),(model_.one_minus_PGAT));
            }
            qjungat = (((model_.qprefgat)*(1.0-tmpv))+((model_.qpref2gat)*(VAK-vjv)));
          }
        }
        // End block evaluateDynamic
      }
      else
      {
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((AB_i==0.0)&&(LS_i==0.0))&&(LG_i==0.0))))
        {
          h1 = ((4.0*vch)*vch);
          h2 = (vch/vfmin);
          h2d = (VAK+(vch*h2));
          h3 = (vfmin+h2d);
          h4 = (vfmin-h2d);
          h5 = sqrt(((h4*h4)+h1));
          vj = (2.0*((VAK*vfmin)/(h3+h5)));
          if ((VAK<VMAX))
          {
            if ((fabs((0.5*(VAK*(model_.phitdinv))))<2.3025850929940458e+02))
            {
              zinv = exp((0.5*(VAK*(model_.phitdinv))));
            }
            else
            {
              if (((0.5*(VAK*(model_.phitdinv)))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((VAK-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd);
            zinv = sqrt(idmult);
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((VAK>0.0))
          {
            two_psistar = (2.0*((model_.phitd)*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
          }
          else
          {
            two_psistar = ((-VAK)+(2.0*((model_.phitd)*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
          }
          vjlim = (vbimin-two_psistar);
          vjsrh = (0.5*((VAK+vjlim)-sqrt((((VAK-vjlim)*(VAK-vjlim))+((4.0*(model_.phitd))*(model_.phitd))))));
          vbbt = (0.5*((VAK+vbbtlim)-sqrt((((VAK-vbbtlim)*(VAK-vbbtlim))+((4.0*(model_.phitr))*(model_.phitr))))));
          vav = (0.5*((VAK)-sqrt((((VAK)*(VAK))+((4.0*1.0e-6)*1.0e-6)))));
        }
        if ((AB_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if (((model_.one_minus_PBOT)==0.5))
          {
            tmp = sqrt((1.0-(vj*(model_.vbiinvbot))));
          }
          else
          {
            tmp = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
          }
          qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(VAK-vj)));
          id = ((model_.idsatbot)*idmult);
          if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
            wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
            if (((model_.PBOT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PBOT_i)==0.5))
            {
              tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
            }
            else
            {
              tmp = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
            }
            wdep = ((model_.wdepnulrbot)*tmp);
            asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
          }
          if (((model_.CTATBOT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
            sqrtumax = sqrt(fabs(umax));
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            ktat = sqrt((0.375*(btat/sqrtumax)));
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              tmp = exp(((-ysq)+mtat));
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                tmp = exp(mtat);
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTBOT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PBOT_i)==0.5))
            {
              tmp = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
            }
            else
            {
              tmp = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
            }
            Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
            if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
            {
              tmp = exp(((-(model_.fbbtbot))/Fmaxr));
            }
            else
            {
              if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTBOT_i)*(((VAK*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRBOT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
            {
              if (((model_.PBRBOT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
              }
              else
              {
                tmp = pow(fabs((vav*(model_.VBRinvbot))),(model_.PBRBOT_i));
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LS_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if (((model_.one_minus_PSTI)==0.5))
          {
            tmp = sqrt((1.0-(vj*(model_.vbiinvsti))));
          }
          else
          {
            tmp = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
          }
          qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(VAK-vj)));
          id = ((model_.idsatsti)*idmult);
          if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
            wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
            if (((model_.PSTI_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PSTI_i)==0.5))
            {
              tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
            }
            else
            {
              tmp = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
            }
            wdep = ((model_.wdepnulrsti)*tmp);
            asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
          }
          if (((model_.CTATSTI_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
            sqrtumax = sqrt(fabs(umax));
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            ktat = sqrt((0.375*(btat/sqrtumax)));
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              tmp = exp(((-ysq)+mtat));
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                tmp = exp(mtat);
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTSTI_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PSTI_i)==0.5))
            {
              tmp = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
            }
            else
            {
              tmp = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
            }
            Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
            if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
            {
              tmp = exp(((-(model_.fbbtsti))/Fmaxr));
            }
            else
            {
              if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTSTI_i)*(((VAK*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRSTI_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
            {
              if (((model_.PBRSTI_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
              }
              else
              {
                tmp = pow(fabs((vav*(model_.VBRinvsti))),(model_.PBRSTI_i));
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((LG_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if (((model_.one_minus_PGAT)==0.5))
          {
            tmp = sqrt((1.0-(vj*(model_.vbiinvgat))));
          }
          else
          {
            tmp = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
          }
          qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(VAK-vj)));
          id = ((model_.idsatgat)*idmult);
          if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
            wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
            if (((model_.PGAT_i)==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
            }
            wsrh = (wsrhstep+dwsrh);
            if (((model_.PGAT_i)==0.5))
            {
              tmp = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
            }
            else
            {
              tmp = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
            }
            wdep = ((model_.wdepnulrgat)*tmp);
            asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
            isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
          }
          if (((model_.CTATGAT_i)==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
            sqrtumax = sqrt(fabs(umax));
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            ktat = sqrt((0.375*(btat/sqrtumax)));
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              tmp = exp(((-ysq)+mtat));
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                tmp = exp(mtat);
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
            itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
          }
          if (((model_.CBBTGAT_i)==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if (((model_.PGAT_i)==0.5))
            {
              tmp = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
            }
            else
            {
              tmp = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
            }
            Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
            if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
            {
              tmp = exp(((-(model_.fbbtgat))/Fmaxr));
            }
            else
            {
              if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = ((model_.CBBTGAT_i)*(((VAK*Fmaxr)*Fmaxr)*tmp));
          }
          if (((model_.VBRGAT_i)>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
            {
              if (((model_.PBRGAT_i)==4.0))
              {
                tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
              }
              else
              {
                tmp = pow(fabs((vav*(model_.VBRinvgat))),(model_.PBRGAT_i));
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        ijun = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
      }
      qjun = (((AB_i*qjunbot)+(LS_i*qjunsti))+(LG_i*qjungat));
    }
    // End block evaluateStaticDynamic
    //Begin block loadStatic
    {
      // I(A,K) <+ (((TYPE*MULT_i)*ijun))
      staticContributions[admsNodeID_A] += (((model_.TYPE)*MULT_i)*ijun);
      staticContributions[admsNodeID_K] -= (((model_.TYPE)*MULT_i)*ijun);
    }
    // End block loadStatic
    //Begin block loadDynamic
    {
      // I(A,K) <+ (ddt(((TYPE*MULT_i)*qjun)))
      dynamicContributions[admsNodeID_A] += ((((model_.TYPE)*MULT_i)*qjun));
      dynamicContributions[admsNodeID_K] -= ((((model_.TYPE)*MULT_i)*qjun));
    }
    // End block loadDynamic
    //Begin block noise
    {
      jnoise = ((2*1.6021918E-19)*fabs(ijun));
      // I(A,K) <+ (white_noise((MULT_i*jnoise),"shot"))
      if (getSolverState().noiseFlag)
      {
        noiseContribsPower[0]= (MULT_i*jnoise.val());
      }
    }
    // End block noise
    //Begin block OPinfo
    {
      vak = VAK;
      if (((model_.SWJUNEXP_i)==1.0))
      {
        ijbot = 0.0;
        ijgat = 0.0;
        ijsti = 0.0;
        idsatsbot = 0.0;
        idsatssti = 0.0;
        idsatsgat = 0.0;
      }
      else
      {
        ijbot = ((MULT_i*AB_i)*ijunbot);
        ijgat = ((MULT_i*LG_i)*ijungat);
        ijsti = ((MULT_i*LS_i)*ijunsti);
        idsatsbot = ((MULT_i*AB_i)*(model_.idsatbot));
        idsatssti = ((MULT_i*LS_i)*(model_.idsatsti));
        idsatsgat = ((MULT_i*LG_i)*(model_.idsatgat));
      }
      ij = (MULT_i*ijun);
      si = (MULT_i*jnoise);
      cjosbot = ((MULT_i*AB_i)*(model_.cjobot));
      cjossti = ((MULT_i*LS_i)*(model_.cjosti));
      cjosgat = ((MULT_i*LG_i)*(model_.cjogat));
      vbisbot = (model_.vbibot);
      vbissti = (model_.vbisti);
      vbisgat = (model_.vbigat);
    }
    // End block OPinfo
  }
  // End block evaluateblock


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_A_K] =  "
                 <<probeVars[admsProbeID_V_A_K].val() << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_A] =  "
                 <<staticContributions[admsNodeID_A].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_A_K) =  " <<staticContributions[admsNodeID_A].dx(admsProbeID_V_A_K) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_A] =  "
                 <<dynamicContributions[admsNodeID_A].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_K) =  " <<dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_K) << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_K] =  "
                 <<staticContributions[admsNodeID_K].val() << std::endl;
    Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_A_K) =  " <<staticContributions[admsNodeID_K].dx(admsProbeID_V_A_K) << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_K] =  "
                 <<dynamicContributions[admsNodeID_K].val() << std::endl;
    Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_K) =  " <<dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_K) << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 2 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 2; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 2 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode].val();
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode].val();
      }
    }
  }  
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
  return 1;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
  int numSources=getNumNoiseSources();
  noiseData.numSources = numSources;
  noiseData.resize(numSources);

  noiseData.deviceName = getName().getEncodedName();
  std::string theNoiseName;
  theNoiseName = getName().getEncodedName()+std::string("_onoise_white_A_K")+std::string("_")+std::string("shot");
  noiseData.noiseNames[0]=theNoiseName;
  noiseData.li_Pos[0]=li_A;
  noiseData.li_Neg[0]=li_K;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
  noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));

}  

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_A_Equ_A_Node_Ptr) +=  +staticContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  (*f_A_Equ_K_Node_Ptr) +=  -staticContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  (*f_K_Equ_A_Node_Ptr) +=  +staticContributions[admsNodeID_K].dx(admsProbeID_V_A_K);
  (*f_K_Equ_K_Node_Ptr) +=  -staticContributions[admsNodeID_K].dx(admsProbeID_V_A_K);

#else
  //use the offsets instead of pointers
  dFdx[li_A][A_A_Equ_A_NodeOffset] +=  +staticContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  dFdx[li_A][A_A_Equ_K_NodeOffset] +=  -staticContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  dFdx[li_K][A_K_Equ_A_NodeOffset] +=  +staticContributions[admsNodeID_K].dx(admsProbeID_V_A_K);
  dFdx[li_K][A_K_Equ_K_NodeOffset] +=  -staticContributions[admsNodeID_K].dx(admsProbeID_V_A_K);

#endif
  
  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_A_Equ_A_Node_Ptr) +=  +dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  (*q_A_Equ_K_Node_Ptr) +=  -dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  (*q_K_Equ_A_Node_Ptr) +=  +dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_K);
  (*q_K_Equ_K_Node_Ptr) +=  -dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_K);

#else
  //use the offsets instead of pointers
  dQdx[li_A][A_A_Equ_A_NodeOffset] +=  +dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  dQdx[li_A][A_A_Equ_K_NodeOffset] +=  -dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_K);
  dQdx[li_K][A_K_Equ_A_NodeOffset] +=  +dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_K);
  dQdx[li_K][A_K_Equ_K_NodeOffset] +=  -dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_K);

  
#endif
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

  //    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  //    Parameter IMAX : [ 1.0e-12,  (+inf) [
  if ( (!((IMAX >=1.0e-12))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter IMAX value " << IMAX << " out of range [ 1.0e-12,  (+inf) [";
  }

  //    Parameter TRJ : [ (-2.5e2),  (+inf) [
  if ( (!((TRJ >=(-2.5e2)))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter TRJ value " << TRJ << " out of range [ (-2.5e2),  (+inf) [";
  }

  //    Parameter FREV : [ 1.0e1, 1.0e10 ]
  if ( (!((FREV >=1.0e1 && FREV <=1.0e10 ))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter FREV value " << FREV << " out of range [ 1.0e1, 1.0e10 ]";
  }

  //    Parameter CJORBOT : [ 1.0e-12,  (+inf) [
  if ( (!((CJORBOT >=1.0e-12))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CJORBOT value " << CJORBOT << " out of range [ 1.0e-12,  (+inf) [";
  }

  //    Parameter CJORSTI : [ 1.0e-18,  (+inf) [
  if ( (!((CJORSTI >=1.0e-18))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CJORSTI value " << CJORSTI << " out of range [ 1.0e-18,  (+inf) [";
  }

  //    Parameter CJORGAT : [ 1.0e-18,  (+inf) [
  if ( (!((CJORGAT >=1.0e-18))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CJORGAT value " << CJORGAT << " out of range [ 1.0e-18,  (+inf) [";
  }

  //    Parameter VBIRBOT : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRBOT >=5.0e-2))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter VBIRBOT value " << VBIRBOT << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter VBIRSTI : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRSTI >=5.0e-2))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter VBIRSTI value " << VBIRSTI << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter VBIRGAT : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRGAT >=5.0e-2))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter VBIRGAT value " << VBIRGAT << " out of range [ 5.0e-2,  (+inf) [";
  }

  //    Parameter PBOT : [ 5.0e-2, 0.95 ]
  if ( (!((PBOT >=5.0e-2 && PBOT <=0.95 ))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter PBOT value " << PBOT << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter PSTI : [ 5.0e-2, 0.95 ]
  if ( (!((PSTI >=5.0e-2 && PSTI <=0.95 ))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter PSTI value " << PSTI << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter PGAT : [ 5.0e-2, 0.95 ]
  if ( (!((PGAT >=5.0e-2 && PGAT <=0.95 ))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter PGAT value " << PGAT << " out of range [ 5.0e-2, 0.95 ]";
  }

  //    Parameter IDSATRBOT : [ 0.0,  (+inf) [
  if ( (!((IDSATRBOT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter IDSATRBOT value " << IDSATRBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IDSATRSTI : [ 0.0,  (+inf) [
  if ( (!((IDSATRSTI >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter IDSATRSTI value " << IDSATRSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter IDSATRGAT : [ 0.0,  (+inf) [
  if ( (!((IDSATRGAT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter IDSATRGAT value " << IDSATRGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHBOT : [ 0.0,  (+inf) [
  if ( (!((CSRHBOT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CSRHBOT value " << CSRHBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHSTI : [ 0.0,  (+inf) [
  if ( (!((CSRHSTI >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CSRHSTI value " << CSRHSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CSRHGAT : [ 0.0,  (+inf) [
  if ( (!((CSRHGAT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CSRHGAT value " << CSRHGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter XJUNSTI : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNSTI >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter XJUNSTI value " << XJUNSTI << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter XJUNGAT : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNGAT >=1.0e-9))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter XJUNGAT value " << XJUNGAT << " out of range [ 1.0e-9,  (+inf) [";
  }

  //    Parameter CTATBOT : [ 0.0,  (+inf) [
  if ( (!((CTATBOT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CTATBOT value " << CTATBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CTATSTI : [ 0.0,  (+inf) [
  if ( (!((CTATSTI >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CTATSTI value " << CTATSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CTATGAT : [ 0.0,  (+inf) [
  if ( (!((CTATGAT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CTATGAT value " << CTATGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter MEFFTATBOT : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATBOT >=1.0e-2))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter MEFFTATBOT value " << MEFFTATBOT << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter MEFFTATSTI : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATSTI >=1.0e-2))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter MEFFTATSTI value " << MEFFTATSTI << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter MEFFTATGAT : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATGAT >=1.0e-2))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter MEFFTATGAT value " << MEFFTATGAT << " out of range [ 1.0e-2,  (+inf) [";
  }

  //    Parameter CBBTBOT : [ 0.0,  (+inf) [
  if ( (!((CBBTBOT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CBBTBOT value " << CBBTBOT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBBTSTI : [ 0.0,  (+inf) [
  if ( (!((CBBTSTI >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CBBTSTI value " << CBBTSTI << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter CBBTGAT : [ 0.0,  (+inf) [
  if ( (!((CBBTGAT >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter CBBTGAT value " << CBBTGAT << " out of range [ 0.0,  (+inf) [";
  }

  //    Parameter VBRBOT : [ 0.1,  (+inf) [
  if ( (!((VBRBOT >=0.1))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter VBRBOT value " << VBRBOT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRSTI : [ 0.1,  (+inf) [
  if ( (!((VBRSTI >=0.1))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter VBRSTI value " << VBRSTI << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter VBRGAT : [ 0.1,  (+inf) [
  if ( (!((VBRGAT >=0.1))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter VBRGAT value " << VBRGAT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRBOT : [ 0.1,  (+inf) [
  if ( (!((PBRBOT >=0.1))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter PBRBOT value " << PBRBOT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRSTI : [ 0.1,  (+inf) [
  if ( (!((PBRSTI >=0.1))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter PBRSTI value " << PBRSTI << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter PBRGAT : [ 0.1,  (+inf) [
  if ( (!((PBRGAT >=0.1))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter PBRGAT value " << PBRGAT << " out of range [ 0.1,  (+inf) [";
  }

  //    Parameter SWJUNEXP : [ 0.0, 1.0 ]
  if ( (!((SWJUNEXP >=0.0 && SWJUNEXP <=1.0 ))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter SWJUNEXP value " << SWJUNEXP << " out of range [ 0.0, 1.0 ]";
  }

  //    Parameter VJUNREF : [ 0.5,  (+inf) [
  if ( (!((VJUNREF >=0.5))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter VJUNREF value " << VJUNREF << " out of range [ 0.5,  (+inf) [";
  }

  //    Parameter FJUNQ : [ 0.0,  (+inf) [
  if ( (!((FJUNQ >=0.0))) )
  {
    UserError0(*this) << "ADMSJUNCAP200: Parameter FJUNQ value " << FJUNQ << " out of range [ 0.0,  (+inf) [";
  }


  // and of course, this routine is where we should put the initial_model
  // stuff
  double deltaEgat;
  double deltaEsti;
  double deltaEbot;
  double ubigat;
  double ubisti;
  double ubibot;
  double phigdgat;
  double phigdsti;
  double phigdbot;
  double deltaphigd;
  double phigrgat;
  double phigrsti;
  double phigrbot;
  double deltaphigr;
  double phitrinv;
  double KBOL_over_QELE;
  double auxt;
  double tkd;
  double tkr;
  double STFBBTGAT_i;
  double STFBBTSTI_i;
  double STFBBTBOT_i;
  double FBBTRGAT_i;
  double FBBTRSTI_i;
  double FBBTRBOT_i;
  double MEFFTATGAT_i;
  double MEFFTATSTI_i;
  double MEFFTATBOT_i;
  double XJUNGAT_i;
  double XJUNSTI_i;
  double IDSATRGAT_i;
  double IDSATRSTI_i;
  double IDSATRBOT_i;
  double PHIGGAT_i;
  double PHIGSTI_i;
  double PHIGBOT_i;
  double CJORGAT_i;
  double CJORSTI_i;
  double CJORBOT_i;
  double FREV_i;
  double TRJ_i;
  double EPSSI;
  //Begin block initial_model
  {
    EPSSI = (8.8541878176E-12*11.8);
    TRJ_i = ((TRJ>(-2.5e2))?TRJ:(-2.5e2));
    IMAX_i = ((IMAX>1.0e-12)?IMAX:1.0e-12);
    FREV_i = ((FREV>1.0e1)?((FREV<1.0e10)?FREV:1.0e10):1.0e1);
    CJORBOT_i = ((CJORBOT>1.0e-12)?CJORBOT:1.0e-12);
    CJORSTI_i = ((CJORSTI>1.0e-18)?CJORSTI:1.0e-18);
    CJORGAT_i = ((CJORGAT>1.0e-18)?CJORGAT:1.0e-18);
    VBIRBOT_i = ((VBIRBOT>5.0e-2)?VBIRBOT:5.0e-2);
    VBIRSTI_i = ((VBIRSTI>5.0e-2)?VBIRSTI:5.0e-2);
    VBIRGAT_i = ((VBIRGAT>5.0e-2)?VBIRGAT:5.0e-2);
    PBOT_i = ((PBOT>5.0e-2)?((PBOT<0.95)?PBOT:0.95):5.0e-2);
    PSTI_i = ((PSTI>5.0e-2)?((PSTI<0.95)?PSTI:0.95):5.0e-2);
    PGAT_i = ((PGAT>5.0e-2)?((PGAT<0.95)?PGAT:0.95):5.0e-2);
    PHIGBOT_i = PHIGBOT;
    PHIGSTI_i = PHIGSTI;
    PHIGGAT_i = PHIGGAT;
    IDSATRBOT_i = ((IDSATRBOT>0.0)?IDSATRBOT:0.0);
    IDSATRSTI_i = ((IDSATRSTI>0.0)?IDSATRSTI:0.0);
    IDSATRGAT_i = ((IDSATRGAT>0.0)?IDSATRGAT:0.0);
    CSRHBOT_i = ((CSRHBOT>0.0)?CSRHBOT:0.0);
    CSRHSTI_i = ((CSRHSTI>0.0)?CSRHSTI:0.0);
    CSRHGAT_i = ((CSRHGAT>0.0)?CSRHGAT:0.0);
    XJUNSTI_i = ((XJUNSTI>1.0e-9)?XJUNSTI:1.0e-9);
    XJUNGAT_i = ((XJUNGAT>1.0e-9)?XJUNGAT:1.0e-9);
    CTATBOT_i = ((CTATBOT>0.0)?CTATBOT:0.0);
    CTATSTI_i = ((CTATSTI>0.0)?CTATSTI:0.0);
    CTATGAT_i = ((CTATGAT>0.0)?CTATGAT:0.0);
    MEFFTATBOT_i = ((MEFFTATBOT>1.0e-2)?MEFFTATBOT:1.0e-2);
    MEFFTATSTI_i = ((MEFFTATSTI>1.0e-2)?MEFFTATSTI:1.0e-2);
    MEFFTATGAT_i = ((MEFFTATGAT>1.0e-2)?MEFFTATGAT:1.0e-2);
    CBBTBOT_i = ((CBBTBOT>0.0)?CBBTBOT:0.0);
    CBBTSTI_i = ((CBBTSTI>0.0)?CBBTSTI:0.0);
    CBBTGAT_i = ((CBBTGAT>0.0)?CBBTGAT:0.0);
    FBBTRBOT_i = FBBTRBOT;
    FBBTRSTI_i = FBBTRSTI;
    FBBTRGAT_i = FBBTRGAT;
    STFBBTBOT_i = STFBBTBOT;
    STFBBTSTI_i = STFBBTSTI;
    STFBBTGAT_i = STFBBTGAT;
    VBRBOT_i = ((VBRBOT>0.1)?VBRBOT:0.1);
    VBRSTI_i = ((VBRSTI>0.1)?VBRSTI:0.1);
    VBRGAT_i = ((VBRGAT>0.1)?VBRGAT:0.1);
    PBRBOT_i = ((PBRBOT>0.1)?PBRBOT:0.1);
    PBRSTI_i = ((PBRSTI>0.1)?PBRSTI:0.1);
    PBRGAT_i = ((PBRGAT>0.1)?PBRGAT:0.1);
    SWJUNEXP_i = 0.0;
    if ((SWJUNEXP>0.5))
    {
      SWJUNEXP_i = 1.0;
    }
    else
    {
      SWJUNEXP_i = 0.0;
    }
    VJUNREF_i = ((VJUNREF>0.5)?VJUNREF:0.5);
    FJUNQ_i = ((FJUNQ>0.0)?FJUNQ:0.0);
    tkr = (273.15+TRJ_i);
    tkd = std::max((admsModTemp+DTA),(273.15+(-2.5e2)));
    auxt = (tkd/tkr);
    KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
    phitr = (KBOL_over_QELE*tkr);
    phitrinv = (1.0/phitr);
    phitd = (KBOL_over_QELE*tkd);
    phitdinv = (1.0/phitd);
    deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
    phigrbot = (PHIGBOT_i+deltaphigr);
    phigrsti = (PHIGSTI_i+deltaphigr);
    phigrgat = (PHIGGAT_i+deltaphigr);
    deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
    phigdbot = (PHIGBOT_i+deltaphigd);
    phigdsti = (PHIGSTI_i+deltaphigd);
    phigdgat = (PHIGGAT_i+deltaphigd);
    ftdbot = (pow(auxt,1.5)*exp((0.5*((phigrbot*phitrinv)-(phigdbot*phitdinv)))));
    ftdsti = (pow(auxt,1.5)*exp((0.5*((phigrsti*phitrinv)-(phigdsti*phitdinv)))));
    ftdgat = (pow(auxt,1.5)*exp((0.5*((phigrgat*phitrinv)-(phigdgat*phitdinv)))));
    idsatbot = ((IDSATRBOT_i*ftdbot)*ftdbot);
    idsatsti = ((IDSATRSTI_i*ftdsti)*ftdsti);
    idsatgat = ((IDSATRGAT_i*ftdgat)*ftdgat);
    ubibot = ((VBIRBOT_i*auxt)-((2.0*phitd)*log(ftdbot)));
    ubisti = ((VBIRSTI_i*auxt)-((2.0*phitd)*log(ftdsti)));
    ubigat = ((VBIRGAT_i*auxt)-((2.0*phitd)*log(ftdgat)));
    vbibot = (ubibot+(phitd*log((1+exp(((5.0e-2-ubibot)*phitdinv))))));
    vbisti = (ubisti+(phitd*log((1+exp(((5.0e-2-ubisti)*phitdinv))))));
    vbigat = (ubigat+(phitd*log((1+exp(((5.0e-2-ubigat)*phitdinv))))));
    vbiinvbot = (1.0/vbibot);
    vbiinvsti = (1.0/vbisti);
    vbiinvgat = (1.0/vbigat);
    one_minus_PBOT = (1.0-PBOT_i);
    one_minus_PSTI = (1.0-PSTI_i);
    one_minus_PGAT = (1.0-PGAT_i);
    one_over_one_minus_PBOT = (1.0/one_minus_PBOT);
    one_over_one_minus_PSTI = (1.0/one_minus_PSTI);
    one_over_one_minus_PGAT = (1.0/one_minus_PGAT);
    cjobot = (CJORBOT_i*pow((VBIRBOT_i*vbiinvbot),PBOT_i));
    cjosti = (CJORSTI_i*pow((VBIRSTI_i*vbiinvsti),PSTI_i));
    cjogat = (CJORGAT_i*pow((VBIRGAT_i*vbiinvgat),PGAT_i));
    qprefbot = ((cjobot*vbibot)*one_over_one_minus_PBOT);
    qprefsti = ((cjosti*vbisti)*one_over_one_minus_PSTI);
    qprefgat = ((cjogat*vbigat)*one_over_one_minus_PGAT);
    qpref2bot = (2.0*cjobot);
    qpref2sti = (2.0*cjosti);
    qpref2gat = (2.0*cjogat);
    wdepnulrbot = (EPSSI/CJORBOT_i);
    wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
    wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
    wdepnulrinvbot = (1.0/wdepnulrbot);
    wdepnulrinvsti = (1.0/wdepnulrsti);
    wdepnulrinvgat = (1.0/wdepnulrgat);
    VBIRBOTinv = (1.0/VBIRBOT_i);
    VBIRSTIinv = (1.0/VBIRSTI_i);
    VBIRGATinv = (1.0/VBIRGAT_i);
    perfc = (1.77245385090551603*0.29214664);
    berfc = (((((-5.0)*0.29214664)+6.0)-pow(perfc,(-2.0)))/3.0);
    cerfc = ((1.0-0.29214664)-berfc);
    deltaEbot = std::max((0.5*phigdbot),phitd);
    deltaEsti = std::max((0.5*phigdsti),phitd);
    deltaEgat = std::max((0.5*phigdgat),phitd);
    atatbot = (deltaEbot*phitdinv);
    atatsti = (deltaEsti*phitdinv);
    atatgat = (deltaEgat*phitdinv);
    btatpartbot = (sqrt(((((32.0*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)))/(3.0*1.05457168E-34));
    btatpartsti = (sqrt(((((32.0*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)))/(3.0*1.05457168E-34));
    btatpartgat = (sqrt(((((32.0*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)))/(3.0*1.05457168E-34));
    fbbtbot = (FBBTRBOT_i*(1.0+(STFBBTBOT_i*(tkd-tkr))));
    fbbtsti = (FBBTRSTI_i*(1.0+(STFBBTSTI_i*(tkd-tkr))));
    fbbtgat = (FBBTRGAT_i*(1.0+(STFBBTGAT_i*(tkd-tkr))));
    fbbtbot = ((fbbtbot>0.0)?fbbtbot:0.0);
    fbbtsti = ((fbbtsti>0.0)?fbbtsti:0.0);
    fbbtgat = ((fbbtgat>0.0)?fbbtgat:0.0);
    alphaav = (1.0-(1.0/FREV_i));
    fstopbot = (1.0/(1.0-pow(alphaav,PBRBOT_i)));
    fstopsti = (1.0/(1.0-pow(alphaav,PBRSTI_i)));
    fstopgat = (1.0/(1.0-pow(alphaav,PBRGAT_i)));
    VBRinvbot = (1.0/VBRBOT_i);
    VBRinvsti = (1.0/VBRSTI_i);
    VBRinvgat = (1.0/VBRGAT_i);
    slopebot = (((-((fstopbot*fstopbot)*pow(alphaav,(PBRBOT_i-1.0))))*PBRBOT_i)*VBRinvbot);
    slopesti = (((-((fstopsti*fstopsti)*pow(alphaav,(PBRSTI_i-1.0))))*PBRSTI_i)*VBRinvsti);
    slopegat = (((-((fstopgat*fstopgat)*pow(alphaav,(PBRGAT_i-1.0))))*PBRGAT_i)*VBRinvgat);
  }
  // End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
   const Configuration & configuration,
   const ModelBlock &    model_block,
   const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(200),
    TYPE(1.0),
    DTA(0.0),
    IMAX(1000.0),
    TRJ(21.0),
    FREV(1.0e3),
    CJORBOT(1.0e-3),
    CJORSTI(1.0e-9),
    CJORGAT(1.0e-9),
    VBIRBOT(1.0),
    VBIRSTI(1.0),
    VBIRGAT(1.0),
    PBOT(0.5),
    PSTI(0.5),
    PGAT(0.5),
    PHIGBOT(1.16),
    PHIGSTI(1.16),
    PHIGGAT(1.16),
    IDSATRBOT(1.0e-12),
    IDSATRSTI(1.0e-18),
    IDSATRGAT(1.0e-18),
    CSRHBOT(1.0e2),
    CSRHSTI(1.0e-4),
    CSRHGAT(1.0e-4),
    XJUNSTI(1.0e-7),
    XJUNGAT(1.0e-7),
    CTATBOT(1.0e2),
    CTATSTI(1.0e-4),
    CTATGAT(1.0e-4),
    MEFFTATBOT(0.25),
    MEFFTATSTI(0.25),
    MEFFTATGAT(0.25),
    CBBTBOT(1.0e-12),
    CBBTSTI(1.0e-18),
    CBBTGAT(1.0e-18),
    FBBTRBOT(1.0e9),
    FBBTRSTI(1.0e9),
    FBBTRGAT(1.0e9),
    STFBBTBOT((-1.0e-3)),
    STFBBTSTI((-1.0e-3)),
    STFBBTGAT((-1.0e-3)),
    VBRBOT(10.0),
    VBRSTI(10.0),
    VBRGAT(10.0),
    PBRBOT(4.0),
    PBRSTI(4.0),
    PBRGAT(4.0),
    SWJUNEXP(0.0),
    VJUNREF(2.5),
    FJUNQ(0.03),
    IMAX_i(0.0),
    VBIRBOT_i(0.0),
    VBIRSTI_i(0.0),
    VBIRGAT_i(0.0),
    PBOT_i(0.0),
    PSTI_i(0.0),
    PGAT_i(0.0),
    CSRHBOT_i(0.0),
    CSRHSTI_i(0.0),
    CSRHGAT_i(0.0),
    CTATBOT_i(0.0),
    CTATSTI_i(0.0),
    CTATGAT_i(0.0),
    CBBTBOT_i(0.0),
    CBBTSTI_i(0.0),
    CBBTGAT_i(0.0),
    VBRBOT_i(0.0),
    VBRSTI_i(0.0),
    VBRGAT_i(0.0),
    PBRBOT_i(0.0),
    PBRSTI_i(0.0),
    PBRGAT_i(0.0),
    SWJUNEXP_i(0.0),
    VJUNREF_i(0.0),
    FJUNQ_i(0.0),
    phitr(0.0),
    phitd(0.0),
    phitdinv(0.0),
    perfc(0.0),
    berfc(0.0),
    cerfc(0.0),
    ftdbot(0.0),
    ftdsti(0.0),
    ftdgat(0.0),
    idsatbot(0.0),
    idsatsti(0.0),
    idsatgat(0.0),
    vbibot(0.0),
    vbisti(0.0),
    vbigat(0.0),
    vbiinvbot(0.0),
    vbiinvsti(0.0),
    vbiinvgat(0.0),
    one_minus_PBOT(0.0),
    one_minus_PSTI(0.0),
    one_minus_PGAT(0.0),
    one_over_one_minus_PBOT(0.0),
    one_over_one_minus_PSTI(0.0),
    one_over_one_minus_PGAT(0.0),
    cjobot(0.0),
    cjosti(0.0),
    cjogat(0.0),
    qprefbot(0.0),
    qprefsti(0.0),
    qprefgat(0.0),
    qpref2bot(0.0),
    qpref2sti(0.0),
    qpref2gat(0.0),
    wdepnulrbot(0.0),
    wdepnulrsti(0.0),
    wdepnulrgat(0.0),
    wdepnulrinvbot(0.0),
    wdepnulrinvsti(0.0),
    wdepnulrinvgat(0.0),
    VBIRBOTinv(0.0),
    VBIRSTIinv(0.0),
    VBIRGATinv(0.0),
    atatbot(0.0),
    atatsti(0.0),
    atatgat(0.0),
    btatpartbot(0.0),
    btatpartsti(0.0),
    btatpartgat(0.0),
    fbbtbot(0.0),
    fbbtsti(0.0),
    fbbtgat(0.0),
    alphaav(0.0),
    fstopbot(0.0),
    fstopsti(0.0),
    fstopgat(0.0),
    VBRinvbot(0.0),
    VBRinvsti(0.0),
    VBRinvgat(0.0),
    slopebot(0.0),
    slopesti(0.0),
    slopegat(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << "AB  =  " << (*iter)->AB << std::endl;
    os << "LS  =  " << (*iter)->LS << std::endl;
    os << "LG  =  " << (*iter)->LG << std::endl;
    os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       : 
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
/// 
/// @param[in] op Operator to apply to all instances.
/// 
/// 
void Model::forEachInstance(DeviceInstanceOp &op) const /* override */ 
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void registerDevice()
{
  Config<Traits>::addConfiguration()
    .registerDevice("d", 200)
    .registerModelType("d", 200);
}



#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_AB,
   bool instancePar_given_AB,
   AdmsSensFadType & instancePar_LS,
   bool instancePar_given_LS,
   AdmsSensFadType & instancePar_LG,
   bool instancePar_given_LG,
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_MULT_i,
   AdmsSensFadType & instanceVar_AB_i,
   AdmsSensFadType & instanceVar_LS_i,
   AdmsSensFadType & instanceVar_LG_i,
   AdmsSensFadType & instanceVar_zflagbot,
   AdmsSensFadType & instanceVar_zflagsti,
   AdmsSensFadType & instanceVar_zflaggat,
   AdmsSensFadType & instanceVar_VMAX,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd,
   AdmsSensFadType & instanceVar_vbimin,
   AdmsSensFadType & instanceVar_vch,
   AdmsSensFadType & instanceVar_vfmin,
   AdmsSensFadType & instanceVar_vbbtlim,
   AdmsSensFadType & instanceVar_xhighf1,
   AdmsSensFadType & instanceVar_expxhf1,
   AdmsSensFadType & instanceVar_xhighf2,
   AdmsSensFadType & instanceVar_expxhf2,
   AdmsSensFadType & instanceVar_xhighr,
   AdmsSensFadType & instanceVar_expxhr,
   AdmsSensFadType & instanceVar_ISATFOR1,
   AdmsSensFadType & instanceVar_MFOR1,
   AdmsSensFadType & instanceVar_ISATFOR2,
   AdmsSensFadType & instanceVar_MFOR2,
   AdmsSensFadType & instanceVar_ISATREV,
   AdmsSensFadType & instanceVar_MREV,
   AdmsSensFadType & instanceVar_m0flag,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_FREV,
   bool modelPar_given_FREV,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_alphaav,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   double admsTemperature, double adms_vt_nom, double gmin, const Instance & theInstance)
{
  AdmsSensFadType I5;
  AdmsSensFadType I4;
  AdmsSensFadType I3;
  AdmsSensFadType I2;
  AdmsSensFadType I1;
  AdmsSensFadType ijungat;
  AdmsSensFadType ijunsti;
  AdmsSensFadType ijunbot;
  double V5;
  double V4;
  AdmsSensFadType V3;
  AdmsSensFadType V2;
  AdmsSensFadType V1;
  double FRACI;
  double FRACNB;
  double FRACNA;
  AdmsSensFadType qjungat;
  AdmsSensFadType qjunsti;
  AdmsSensFadType qjunbot;
  AdmsSensFadType fbreakdown;
  AdmsSensFadType Fmaxr;
  AdmsSensFadType ibbt;
  AdmsSensFadType gammamax;
  AdmsSensFadType erfctimesexpmtat;
  AdmsSensFadType xerfc;
  AdmsSensFadType mtat;
  AdmsSensFadType ltat;
  AdmsSensFadType ktat;
  AdmsSensFadType wtat;
  AdmsSensFadType wgamma;
  AdmsSensFadType umaxpoweronepointfive;
  AdmsSensFadType sqrtumax;
  AdmsSensFadType umax;
  AdmsSensFadType umaxbeforelimiting;
  AdmsSensFadType twoatatoverthreebtat;
  AdmsSensFadType btat;
  AdmsSensFadType itat;
  AdmsSensFadType asrh;
  AdmsSensFadType wdep;
  AdmsSensFadType wsrh;
  AdmsSensFadType dwsrh;
  AdmsSensFadType wsrhstep;
  AdmsSensFadType vbi_minus_vjsrh;
  AdmsSensFadType isrh;
  AdmsSensFadType id;
  AdmsSensFadType tmp;
  AdmsSensFadType vav;
  AdmsSensFadType vbbt;
  AdmsSensFadType vjsrh;
  AdmsSensFadType vjlim;
  AdmsSensFadType two_psistar;
  AdmsSensFadType zinv;
  AdmsSensFadType z;
  AdmsSensFadType vj;
  AdmsSensFadType idmult;
  AdmsSensFadType h5;
  AdmsSensFadType h4;
  AdmsSensFadType h3;
  AdmsSensFadType h2d;
  AdmsSensFadType h2;
  AdmsSensFadType h1;
  AdmsSensFadType erfcpos;
  AdmsSensFadType terfc;
  AdmsSensFadType ysq;
  AdmsSensFadType alphaje;
  AdmsSensFadType zfrac;
  AdmsSensFadType tt2;
  AdmsSensFadType tt1;
  AdmsSensFadType tt0;
  AdmsSensFadType I5_cor;
  AdmsSensFadType I4_cor;
  AdmsSensFadType I3_cor;
  AdmsSensFadType I2_cor;
  AdmsSensFadType I1_cor;
  AdmsSensFadType mcor_rev;
  AdmsSensFadType m0_rev;
  AdmsSensFadType pmax;
  AdmsSensFadType vbigat2r;
  AdmsSensFadType vbisti2r;
  AdmsSensFadType vbibot2r;
  AdmsSensFadType pgat2;
  AdmsSensFadType psti2;
  AdmsSensFadType pbot2;
  AdmsSensFadType vbigat2;
  AdmsSensFadType vbisti2;
  AdmsSensFadType vbibot2;
  AdmsSensFadType vmaxgat;
  AdmsSensFadType vmaxsti;
  AdmsSensFadType vmaxbot;
  //Begin block initial_instance
  {
    instanceVar_AB_i = adms_ternary_op<AdmsSensFadType>((instancePar_AB>0.0),instancePar_AB,0.0);
    instanceVar_LS_i = adms_ternary_op<AdmsSensFadType>((instancePar_LS>0.0),instancePar_LS,0.0);
    instanceVar_LG_i = adms_ternary_op<AdmsSensFadType>((instancePar_LG>0.0),instancePar_LG,0.0);
    instanceVar_MULT_i = adms_ternary_op<AdmsSensFadType>((instancePar_MULT>0.0),instancePar_MULT,0.0);
    instanceVar_exp_VMAX_over_phitd = 0.0;
    if (((modelVar_idsatbot*instanceVar_AB_i)>0.0))
    {
      vmaxbot = (modelVar_phitd*log(((modelVar_IMAX_i/(modelVar_idsatbot*instanceVar_AB_i))+1.0)));
    }
    else
    {
      vmaxbot = 1.0e8;
    }
    if (((modelVar_idsatsti*instanceVar_LS_i)>0.0))
    {
      vmaxsti = (modelVar_phitd*log(((modelVar_IMAX_i/(modelVar_idsatsti*instanceVar_LS_i))+1.0)));
    }
    else
    {
      vmaxsti = 1.0e8;
    }
    if (((modelVar_idsatgat*instanceVar_LG_i)>0.0))
    {
      vmaxgat = (modelVar_phitd*log(((modelVar_IMAX_i/(modelVar_idsatgat*instanceVar_LG_i))+1.0)));
    }
    else
    {
      vmaxgat = 1.0e8;
    }
    instanceVar_VMAX = std::min(std::min(vmaxbot,vmaxsti),vmaxgat);
    if ((fabs((instanceVar_VMAX*modelVar_phitdinv))<2.3025850929940458e+02))
    {
      instanceVar_exp_VMAX_over_phitd = exp((instanceVar_VMAX*modelVar_phitdinv));
    }
    else
    {
      if (((instanceVar_VMAX*modelVar_phitdinv)<0.0))
      {
        instanceVar_exp_VMAX_over_phitd = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX*modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceVar_VMAX*modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceVar_VMAX*modelVar_phitdinv))*3.3333333333333333e-01))))))));
      }
      else
      {
        instanceVar_exp_VMAX_over_phitd = (1.0e100*(1.0+(((instanceVar_VMAX*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceVar_VMAX*modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceVar_VMAX*modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
      }
    }
    vbibot2 = modelVar_vbibot;
    vbisti2 = modelVar_vbisti;
    vbigat2 = modelVar_vbigat;
    pbot2 = modelVar_PBOT_i;
    psti2 = modelVar_PSTI_i;
    pgat2 = modelVar_PGAT_i;
    vbibot2r = modelVar_VBIRBOT_i;
    vbisti2r = modelVar_VBIRSTI_i;
    vbigat2r = modelVar_VBIRGAT_i;
    if ((instanceVar_AB_i==0.0))
    {
      vbibot2 = (modelVar_vbisti+modelVar_vbigat);
      pbot2 = (0.9*std::min(modelVar_PSTI_i,modelVar_PGAT_i));
      vbibot2r = (modelVar_VBIRSTI_i+modelVar_VBIRGAT_i);
    }
    if ((instanceVar_LS_i==0.0))
    {
      vbisti2 = (modelVar_vbibot+modelVar_vbigat);
      psti2 = (0.9*std::min(modelVar_PBOT_i,modelVar_PGAT_i));
      vbisti2r = (modelVar_VBIRBOT_i+modelVar_VBIRGAT_i);
    }
    if ((instanceVar_LG_i==0.0))
    {
      vbigat2 = (modelVar_vbibot+modelVar_vbisti);
      pgat2 = (0.9*std::min(modelVar_PBOT_i,modelVar_PSTI_i));
      vbigat2r = (modelVar_VBIRBOT_i+modelVar_VBIRSTI_i);
    }
    instanceVar_vbimin = std::min(std::min(vbibot2,vbisti2),vbigat2);
    instanceVar_vch = (instanceVar_vbimin*0.1);
    pmax = std::max(std::max(pbot2,psti2),pgat2);
    instanceVar_vfmin = (instanceVar_vbimin*(1.0-pow(2.0,((-1.0)/pmax))));
    instanceVar_vbbtlim = (std::min(std::min(vbibot2r,vbisti2r),vbigat2r)-5.0e-2);
    instanceVar_ISATFOR1 = 0.0;
    instanceVar_MFOR1 = 1.0;
    instanceVar_MFOR2 = 1.0;
    instanceVar_ISATFOR2 = 0.0;
    instanceVar_MREV = 1.0;
    instanceVar_ISATREV = 0.0;
    instanceVar_m0flag = 0.0;
    instanceVar_xhighf1 = 0.0;
    instanceVar_expxhf1 = 0.0;
    instanceVar_xhighf2 = 0.0;
    instanceVar_expxhf2 = 0.0;
    instanceVar_xhighr = 0.0;
    instanceVar_expxhr = 0.0;
    m0_rev = 0.0;
    mcor_rev = 0.0;
    I1_cor = 0.0;
    I2_cor = 0.0;
    I3_cor = 0.0;
    I4_cor = 0.0;
    I5_cor = 0.0;
    tt0 = 0.0;
    tt1 = 0.0;
    tt2 = 0.0;
    zfrac = 0.0;
    instanceVar_zflagbot = 1.0;
    instanceVar_zflagsti = 1.0;
    instanceVar_zflaggat = 1.0;
    alphaje = 0.0;
    if ((modelVar_SWJUNEXP_i==1.0))
      //Begin block JUNCAPexpressInit
    {
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType ysq;
      AdmsSensFadType terfc;
      AdmsSensFadType erfcpos;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType h1;
      AdmsSensFadType h2;
      AdmsSensFadType h2d;
      AdmsSensFadType h3;
      AdmsSensFadType h4;
      AdmsSensFadType h5;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType idmult;
      AdmsSensFadType vj;
      AdmsSensFadType z;
      AdmsSensFadType zinv;
      AdmsSensFadType two_psistar;
      AdmsSensFadType vjlim;
      AdmsSensFadType vjsrh;
      AdmsSensFadType vbbt;
      AdmsSensFadType vav;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType tmp;
      AdmsSensFadType id;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType isrh;
      AdmsSensFadType vbi_minus_vjsrh;
      AdmsSensFadType wsrhstep;
      AdmsSensFadType dwsrh;
      AdmsSensFadType wsrh;
      AdmsSensFadType wdep;
      AdmsSensFadType asrh;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType itat;
      AdmsSensFadType btat;
      AdmsSensFadType twoatatoverthreebtat;
      AdmsSensFadType umaxbeforelimiting;
      AdmsSensFadType umax;
      AdmsSensFadType sqrtumax;
      AdmsSensFadType umaxpoweronepointfive;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType wgamma;
      AdmsSensFadType wtat;
      AdmsSensFadType ktat;
      AdmsSensFadType ltat;
      AdmsSensFadType mtat;
      AdmsSensFadType xerfc;
      AdmsSensFadType erfctimesexpmtat;
      AdmsSensFadType gammamax;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType ibbt;
      AdmsSensFadType Fmaxr;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType fbreakdown;
      //End of Block-local variables
      //Block-local variables for block JUNCAPexpressInit
      AdmsSensFadType ijunbot;
      AdmsSensFadType ijunsti;
      AdmsSensFadType ijungat;
      AdmsSensFadType qjunbot;
      AdmsSensFadType qjunsti;
      AdmsSensFadType qjungat;
      //End of Block-local variables
      ysq = 0.0;
      terfc = 0.0;
      erfcpos = 0.0;
      h1 = 0.0;
      h2 = 0.0;
      h2d = 0.0;
      h3 = 0.0;
      h4 = 0.0;
      h5 = 0.0;
      idmult = 0.0;
      vj = 0.0;
      z = 0.0;
      zinv = 0.0;
      two_psistar = 0.0;
      vjlim = 0.0;
      vjsrh = 0.0;
      vbbt = 0.0;
      vav = 0.0;
      tmp = 0.0;
      id = 0.0;
      isrh = 0.0;
      vbi_minus_vjsrh = 0.0;
      wsrhstep = 0.0;
      dwsrh = 0.0;
      wsrh = 0.0;
      wdep = 0.0;
      asrh = 0.0;
      itat = 0.0;
      btat = 0.0;
      twoatatoverthreebtat = 0.0;
      umaxbeforelimiting = 0.0;
      umax = 0.0;
      sqrtumax = 0.0;
      umaxpoweronepointfive = 0.0;
      wgamma = 0.0;
      wtat = 0.0;
      ktat = 0.0;
      ltat = 0.0;
      mtat = 0.0;
      xerfc = 0.0;
      erfctimesexpmtat = 0.0;
      gammamax = 0.0;
      ibbt = 0.0;
      Fmaxr = 0.0;
      fbreakdown = 0.0;
      qjunbot = 0.0;
      qjunsti = 0.0;
      qjungat = 0.0;
      FRACNA = 0.4;
      FRACNB = 0.65;
      FRACI = 0.8;
      V1 = ((-FRACNA)*modelVar_VJUNREF_i);
      V2 = ((-FRACNB)*modelVar_VJUNREF_i);
      V3 = ((-FRACI)*modelVar_VJUNREF_i);
      V4 = 0.1;
      V5 = 0.2;
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
      {
        h1 = ((4.0*instanceVar_vch)*instanceVar_vch);
        h2 = (instanceVar_vch/instanceVar_vfmin);
        h2d = (V1+(instanceVar_vch*h2));
        h3 = (instanceVar_vfmin+h2d);
        h4 = (instanceVar_vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V1*instanceVar_vfmin)/(h3+h5)));
        if ((V1<instanceVar_VMAX))
        {
          if ((fabs((0.5*(V1*modelVar_phitdinv)))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V1*modelVar_phitdinv)));
          }
          else
          {
            if (((0.5*(V1*modelVar_phitdinv))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V1-instanceVar_VMAX)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V1>0.0))
        {
          two_psistar = (2.0*(modelVar_phitd*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V1)+(2.0*(modelVar_phitd*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (instanceVar_vbimin-two_psistar);
        vjsrh = (0.5*((V1+vjlim)-sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)))));
        vbbt = (0.5*((V1+instanceVar_vbbtlim)-sqrt((((V1-instanceVar_vbbtlim)*(V1-instanceVar_vbbtlim))+((4.0*modelVar_phitr)*modelVar_phitr)))));
        vav = (0.5*((V1)-sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((instanceVar_AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PBOT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvbot)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
        }
        qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V1-vj)));
        id = (modelVar_idsatbot*idmult);
        if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PBOT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          wdep = (modelVar_wdepnulrbot*tmp);
          asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATBOT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTBOT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
          if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtbot)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRBOT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
          {
            if ((modelVar_PBRBOT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvbot)),modelVar_PBRBOT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PSTI==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvsti)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
        }
        qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V1-vj)));
        id = (modelVar_idsatsti*idmult);
        if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PSTI_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          wdep = (modelVar_wdepnulrsti*tmp);
          asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
        }
        if ((modelVar_CTATSTI_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTSTI_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
          if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtsti)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRSTI_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
          {
            if ((modelVar_PBRSTI_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvsti)),modelVar_PBRSTI_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PGAT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvgat)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
        }
        qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V1-vj)));
        id = (modelVar_idsatgat*idmult);
        if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PGAT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          wdep = (modelVar_wdepnulrgat*tmp);
          asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATGAT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTGAT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
          if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtgat)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRGAT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
          {
            if ((modelVar_PBRGAT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvgat)),modelVar_PBRGAT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I1 = (((instanceVar_AB_i*ijunbot)+(instanceVar_LS_i*ijunsti))+(instanceVar_LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
      {
        h1 = ((4.0*instanceVar_vch)*instanceVar_vch);
        h2 = (instanceVar_vch/instanceVar_vfmin);
        h2d = (V2+(instanceVar_vch*h2));
        h3 = (instanceVar_vfmin+h2d);
        h4 = (instanceVar_vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V2*instanceVar_vfmin)/(h3+h5)));
        if ((V2<instanceVar_VMAX))
        {
          if ((fabs((0.5*(V2*modelVar_phitdinv)))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V2*modelVar_phitdinv)));
          }
          else
          {
            if (((0.5*(V2*modelVar_phitdinv))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V2-instanceVar_VMAX)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V2>0.0))
        {
          two_psistar = (2.0*(modelVar_phitd*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V2)+(2.0*(modelVar_phitd*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (instanceVar_vbimin-two_psistar);
        vjsrh = (0.5*((V2+vjlim)-sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)))));
        vbbt = (0.5*((V2+instanceVar_vbbtlim)-sqrt((((V2-instanceVar_vbbtlim)*(V2-instanceVar_vbbtlim))+((4.0*modelVar_phitr)*modelVar_phitr)))));
        vav = (0.5*((V2)-sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((instanceVar_AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PBOT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvbot)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
        }
        qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V2-vj)));
        id = (modelVar_idsatbot*idmult);
        if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PBOT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          wdep = (modelVar_wdepnulrbot*tmp);
          asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATBOT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTBOT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
          if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtbot)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRBOT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
          {
            if ((modelVar_PBRBOT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvbot)),modelVar_PBRBOT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PSTI==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvsti)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
        }
        qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V2-vj)));
        id = (modelVar_idsatsti*idmult);
        if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PSTI_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          wdep = (modelVar_wdepnulrsti*tmp);
          asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
        }
        if ((modelVar_CTATSTI_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTSTI_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
          if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtsti)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRSTI_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
          {
            if ((modelVar_PBRSTI_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvsti)),modelVar_PBRSTI_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PGAT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvgat)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
        }
        qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V2-vj)));
        id = (modelVar_idsatgat*idmult);
        if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PGAT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          wdep = (modelVar_wdepnulrgat*tmp);
          asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATGAT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTGAT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
          if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtgat)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRGAT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
          {
            if ((modelVar_PBRGAT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvgat)),modelVar_PBRGAT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I2 = (((instanceVar_AB_i*ijunbot)+(instanceVar_LS_i*ijunsti))+(instanceVar_LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
      {
        h1 = ((4.0*instanceVar_vch)*instanceVar_vch);
        h2 = (instanceVar_vch/instanceVar_vfmin);
        h2d = (V3+(instanceVar_vch*h2));
        h3 = (instanceVar_vfmin+h2d);
        h4 = (instanceVar_vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V3*instanceVar_vfmin)/(h3+h5)));
        if ((V3<instanceVar_VMAX))
        {
          if ((fabs((0.5*(V3*modelVar_phitdinv)))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V3*modelVar_phitdinv)));
          }
          else
          {
            if (((0.5*(V3*modelVar_phitdinv))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V3-instanceVar_VMAX)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V3>0.0))
        {
          two_psistar = (2.0*(modelVar_phitd*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V3)+(2.0*(modelVar_phitd*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (instanceVar_vbimin-two_psistar);
        vjsrh = (0.5*((V3+vjlim)-sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)))));
        vbbt = (0.5*((V3+instanceVar_vbbtlim)-sqrt((((V3-instanceVar_vbbtlim)*(V3-instanceVar_vbbtlim))+((4.0*modelVar_phitr)*modelVar_phitr)))));
        vav = (0.5*((V3)-sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((instanceVar_AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PBOT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvbot)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
        }
        qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V3-vj)));
        id = (modelVar_idsatbot*idmult);
        if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PBOT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          wdep = (modelVar_wdepnulrbot*tmp);
          asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATBOT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTBOT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
          if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtbot)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRBOT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
          {
            if ((modelVar_PBRBOT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvbot)),modelVar_PBRBOT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PSTI==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvsti)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
        }
        qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V3-vj)));
        id = (modelVar_idsatsti*idmult);
        if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PSTI_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          wdep = (modelVar_wdepnulrsti*tmp);
          asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
        }
        if ((modelVar_CTATSTI_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTSTI_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
          if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtsti)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRSTI_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
          {
            if ((modelVar_PBRSTI_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvsti)),modelVar_PBRSTI_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PGAT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvgat)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
        }
        qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V3-vj)));
        id = (modelVar_idsatgat*idmult);
        if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PGAT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          wdep = (modelVar_wdepnulrgat*tmp);
          asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATGAT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTGAT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
          if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtgat)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRGAT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
          {
            if ((modelVar_PBRGAT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvgat)),modelVar_PBRGAT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I3 = (((instanceVar_AB_i*ijunbot)+(instanceVar_LS_i*ijunsti))+(instanceVar_LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
      {
        h1 = ((4.0*instanceVar_vch)*instanceVar_vch);
        h2 = (instanceVar_vch/instanceVar_vfmin);
        h2d = (V4+(instanceVar_vch*h2));
        h3 = (instanceVar_vfmin+h2d);
        h4 = (instanceVar_vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V4*instanceVar_vfmin)/(h3+h5)));
        if ((V4<instanceVar_VMAX))
        {
          if ((fabs((0.5*(V4*modelVar_phitdinv)))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V4*modelVar_phitdinv)));
          }
          else
          {
            if (((0.5*(V4*modelVar_phitdinv))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V4-instanceVar_VMAX)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V4>0.0))
        {
          two_psistar = (2.0*(modelVar_phitd*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V4)+(2.0*(modelVar_phitd*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (instanceVar_vbimin-two_psistar);
        vjsrh = (0.5*((V4+vjlim)-sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)))));
        vbbt = (0.5*((V4+instanceVar_vbbtlim)-sqrt((((V4-instanceVar_vbbtlim)*(V4-instanceVar_vbbtlim))+((4.0*modelVar_phitr)*modelVar_phitr)))));
        vav = (0.5*((V4)-sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((instanceVar_AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PBOT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvbot)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
        }
        qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V4-vj)));
        id = (modelVar_idsatbot*idmult);
        if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PBOT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          wdep = (modelVar_wdepnulrbot*tmp);
          asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATBOT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTBOT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
          if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtbot)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRBOT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
          {
            if ((modelVar_PBRBOT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvbot)),modelVar_PBRBOT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PSTI==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvsti)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
        }
        qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V4-vj)));
        id = (modelVar_idsatsti*idmult);
        if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PSTI_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          wdep = (modelVar_wdepnulrsti*tmp);
          asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
        }
        if ((modelVar_CTATSTI_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTSTI_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
          if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtsti)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRSTI_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
          {
            if ((modelVar_PBRSTI_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvsti)),modelVar_PBRSTI_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PGAT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvgat)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
        }
        qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V4-vj)));
        id = (modelVar_idsatgat*idmult);
        if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PGAT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          wdep = (modelVar_wdepnulrgat*tmp);
          asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATGAT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTGAT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
          if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtgat)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRGAT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
          {
            if ((modelVar_PBRGAT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvgat)),modelVar_PBRGAT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I4 = (((instanceVar_AB_i*ijunbot)+(instanceVar_LS_i*ijunsti))+(instanceVar_LG_i*ijungat));
      vbbt = 0.0;
      two_psistar = 0.0;
      if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
      {
        h1 = ((4.0*instanceVar_vch)*instanceVar_vch);
        h2 = (instanceVar_vch/instanceVar_vfmin);
        h2d = (V5+(instanceVar_vch*h2));
        h3 = (instanceVar_vfmin+h2d);
        h4 = (instanceVar_vfmin-h2d);
        h5 = sqrt(((h4*h4)+h1));
        vj = (2.0*((V5*instanceVar_vfmin)/(h3+h5)));
        if ((V5<instanceVar_VMAX))
        {
          if ((fabs((0.5*(V5*modelVar_phitdinv)))<2.3025850929940458e+02))
          {
            zinv = exp((0.5*(V5*modelVar_phitdinv)));
          }
          else
          {
            if (((0.5*(V5*modelVar_phitdinv))<0.0))
            {
              zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
            }
            else
            {
              zinv = (1.0e100*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          idmult = (zinv*zinv);
        }
        else
        {
          idmult = ((1.0+((V5-instanceVar_VMAX)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd);
          zinv = sqrt(idmult);
        }
        idmult = (idmult-1.0);
        z = (1.0/zinv);
        if ((V5>0.0))
        {
          two_psistar = (2.0*(modelVar_phitd*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
        }
        else
        {
          two_psistar = ((-V5)+(2.0*(modelVar_phitd*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
        }
        vjlim = (instanceVar_vbimin-two_psistar);
        vjsrh = (0.5*((V5+vjlim)-sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)))));
        vbbt = (0.5*((V5+instanceVar_vbbtlim)-sqrt((((V5-instanceVar_vbbtlim)*(V5-instanceVar_vbbtlim))+((4.0*modelVar_phitr)*modelVar_phitr)))));
        vav = (0.5*((V5)-sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)))));
      }
      if ((instanceVar_AB_i==0.0))
      {
        ijunbot = 0.0;
        qjunbot = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PBOT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvbot)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
        }
        qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(V5-vj)));
        id = (modelVar_idsatbot*idmult);
        if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PBOT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          wdep = (modelVar_wdepnulrbot*tmp);
          asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATBOT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTBOT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PBOT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
          if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtbot)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRBOT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
          {
            if ((modelVar_PBRBOT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvbot)),modelVar_PBRBOT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
          }
        }
        ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LS_i==0.0))
      {
        ijunsti = 0.0;
        qjunsti = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PSTI==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvsti)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
        }
        qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(V5-vj)));
        id = (modelVar_idsatsti*idmult);
        if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PSTI_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          wdep = (modelVar_wdepnulrsti*tmp);
          asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
        }
        if ((modelVar_CTATSTI_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTSTI_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PSTI_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
          if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtsti)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRSTI_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
          {
            if ((modelVar_PBRSTI_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvsti)),modelVar_PBRSTI_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
          }
        }
        ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      if ((instanceVar_LG_i==0.0))
      {
        ijungat = 0.0;
        qjungat = 0.0;
      }
      else
      {
        if ((modelVar_one_minus_PGAT==0.5))
        {
          tmp = sqrt((1.0-(vj*modelVar_vbiinvgat)));
        }
        else
        {
          tmp = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
        }
        qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(V5-vj)));
        id = (modelVar_idsatgat*idmult);
        if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
        {
          isrh = 0.0;
        }
        else
        {
          vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
          wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
          if ((modelVar_PGAT_i==0.5))
          {
            dwsrh = 0.0;
          }
          else
          {
            dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
          }
          wsrh = (wsrhstep+dwsrh);
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          wdep = (modelVar_wdepnulrgat*tmp);
          asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
          isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
        }
        if ((modelVar_CTATGAT_i==0.0))
        {
          itat = 0.0;
        }
        else
        {
          btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
          twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
          umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
          umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
          sqrtumax = sqrt(fabs(umax));
          umaxpoweronepointfive = (umax*sqrtumax);
          if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
          {
            wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
          }
          else
          {
            wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
          }
          wtat = ((wsrh*wgamma)/(wsrh+wgamma));
          ktat = sqrt((0.375*(btat/sqrtumax)));
          ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
          mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
          xerfc = ((ltat-1.0)*ktat);
          ysq = (xerfc*xerfc);
          if ((xerfc>0.0))
          {
            terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
          }
          else
          {
            terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
          }
          if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
          {
            tmp = exp(((-ysq)+mtat));
          }
          else
          {
            tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
          }
          erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
          if ((xerfc>0.0))
          {
            erfctimesexpmtat = erfcpos;
          }
          else
          {
            if ((mtat>(-2.3025850929940458e+02)))
            {
              tmp = exp(mtat);
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
            }
            erfctimesexpmtat = ((2.0*tmp)-erfcpos);
          }
          gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
          itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
        }
        if ((modelVar_CBBTGAT_i==0.0))
        {
          ibbt = 0.0;
        }
        else
        {
          if ((modelVar_PGAT_i==0.5))
          {
            tmp = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
          }
          else
          {
            tmp = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
          }
          Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
          if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
          {
            tmp = exp(((-modelVar_fbbtgat)/Fmaxr));
          }
          else
          {
            if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
            }
            else
            {
              tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
            }
          }
          ibbt = (modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
        }
        if ((modelVar_VBRGAT_i>1.0e3))
        {
          fbreakdown = 1.0;
        }
        else
        {
          if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
          {
            if ((modelVar_PBRGAT_i==4.0))
            {
              tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
            }
            else
            {
              tmp = pow(fabs((vav*modelVar_VBRinvgat)),modelVar_PBRGAT_i);
            }
            fbreakdown = (1.0/(1.0-tmp));
          }
          else
          {
            fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
          }
        }
        ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
      }
      I5 = (((instanceVar_AB_i*ijunbot)+(instanceVar_LS_i*ijunsti))+(instanceVar_LG_i*ijungat));
      instanceVar_ISATFOR1 = (((instanceVar_AB_i*modelVar_idsatbot)+(instanceVar_LS_i*modelVar_idsatsti))+(instanceVar_LG_i*modelVar_idsatgat));
      I4_cor = (I4-(instanceVar_ISATFOR1*(exp(((V4*modelVar_phitdinv)*instanceVar_MFOR1))-1.0)));
      I5_cor = (I5-(instanceVar_ISATFOR1*(exp(((V5*modelVar_phitdinv)*instanceVar_MFOR1))-1.0)));
      if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
      {
        if (((I4>0.0)&&(I5>0.0)))
        {
          if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
          {
            alphaje = (I4_cor/I5_cor);
            instanceVar_MFOR2 = ((modelVar_phitd*log(alphaje))/(V4-V5));
            instanceVar_ISATFOR2 = (I4_cor/(exp(((V4*modelVar_phitdinv)*instanceVar_MFOR2))-1.0));
          }
        }
        I1_cor = ((I1-(instanceVar_ISATFOR1*(exp(((V1*modelVar_phitdinv)*instanceVar_MFOR1))-1.0)))-(instanceVar_ISATFOR2*(exp(((V1*modelVar_phitdinv)*instanceVar_MFOR2))-1.0)));
        I2_cor = ((I2-(instanceVar_ISATFOR1*(exp(((V2*modelVar_phitdinv)*instanceVar_MFOR1))-1.0)))-(instanceVar_ISATFOR2*(exp(((V2*modelVar_phitdinv)*instanceVar_MFOR2))-1.0)));
        I3_cor = ((I3-(instanceVar_ISATFOR1*(exp(((V3*modelVar_phitdinv)*instanceVar_MFOR1))-1.0)))-(instanceVar_ISATFOR2*(exp(((V3*modelVar_phitdinv)*instanceVar_MFOR2))-1.0)));
        if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
        {
          if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
          {
            alphaje = (I1_cor/I2_cor);
            m0_rev = (((-modelVar_phitd)*log(alphaje))/(V1-V2));
            tt0 = (V2/(V2-V1));
            tt1 = ((modelVar_phitd*(alphaje-1.0))*(pow(alphaje,tt0)-1.0));
            tt0 = (V1/(V1-V2));
            tt2 = (((pow(alphaje,tt0)*(V2-V1))+(alphaje*V1))-V2);
            mcor_rev = (tt1/tt2);
            instanceVar_MREV = (m0_rev+mcor_rev);
            if ((fabs(((V3*modelVar_phitdinv)*instanceVar_MREV))<1.0e-6))
            {
              instanceVar_m0flag = 1.0;
              instanceVar_ISATREV = (I3_cor*((1.0/V3)+((0.5*modelVar_phitdinv)*instanceVar_MREV)));
              instanceVar_MREV = (((((-0.5)*I3_cor)*instanceVar_MREV)*modelVar_phitdinv)/V3);
            }
            else
            {
              instanceVar_m0flag = 0.0;
              instanceVar_ISATREV = ((-I3_cor)/(exp((((-V3)*modelVar_phitdinv)*instanceVar_MREV))-1.0));
            }
          }
        }
      }
      zfrac = (modelVar_FJUNQ_i*(((instanceVar_AB_i*modelVar_cjobot)+(instanceVar_LS_i*modelVar_cjosti))+(instanceVar_LG_i*modelVar_cjogat)));
      if (((instanceVar_AB_i*modelVar_cjobot)<=zfrac))
      {
        instanceVar_zflagbot = 0.0;
      }
      if (((instanceVar_LS_i*modelVar_cjosti)<=zfrac))
      {
        instanceVar_zflagsti = 0.0;
      }
      if (((instanceVar_LG_i*modelVar_cjogat)<=zfrac))
      {
        instanceVar_zflaggat = 0.0;
      }
      if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
      {
        instanceVar_xhighf1 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR1+1.0e-21)));
        instanceVar_xhighf2 = log(((0.5*modelVar_IMAX_i)/(instanceVar_ISATFOR2+1.0e-21)));
        instanceVar_xhighr = log(((0.5*modelVar_IMAX_i)/(fabs(instanceVar_ISATREV)+1.0e-21)));
      }
      instanceVar_xhighf1 = std::min(instanceVar_xhighf1,static_cast<double>(2.3025850929940458e+02));
      instanceVar_expxhf1 = exp(instanceVar_xhighf1);
      instanceVar_xhighf2 = std::min(instanceVar_xhighf2,static_cast<double>(2.3025850929940458e+02));
      instanceVar_expxhf2 = exp(instanceVar_xhighf2);
      instanceVar_xhighr = std::min(instanceVar_xhighr,static_cast<double>(2.3025850929940458e+02));
      instanceVar_expxhr = exp(instanceVar_xhighr);
    }
    // End block JUNCAPexpressInit
  }
  // End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_FREV,
   bool modelPar_given_FREV,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_alphaav,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   double admsTemperature, double gmin, const Instance & theInstance)
{
  AdmsSensFadType deltaEgat;
  AdmsSensFadType deltaEsti;
  AdmsSensFadType deltaEbot;
  AdmsSensFadType ubigat;
  AdmsSensFadType ubisti;
  AdmsSensFadType ubibot;
  AdmsSensFadType phigdgat;
  AdmsSensFadType phigdsti;
  AdmsSensFadType phigdbot;
  AdmsSensFadType deltaphigd;
  AdmsSensFadType phigrgat;
  AdmsSensFadType phigrsti;
  AdmsSensFadType phigrbot;
  AdmsSensFadType deltaphigr;
  AdmsSensFadType phitrinv;
  double KBOL_over_QELE;
  AdmsSensFadType auxt;
  AdmsSensFadType tkd;
  AdmsSensFadType tkr;
  AdmsSensFadType STFBBTGAT_i;
  AdmsSensFadType STFBBTSTI_i;
  AdmsSensFadType STFBBTBOT_i;
  AdmsSensFadType FBBTRGAT_i;
  AdmsSensFadType FBBTRSTI_i;
  AdmsSensFadType FBBTRBOT_i;
  AdmsSensFadType MEFFTATGAT_i;
  AdmsSensFadType MEFFTATSTI_i;
  AdmsSensFadType MEFFTATBOT_i;
  AdmsSensFadType XJUNGAT_i;
  AdmsSensFadType XJUNSTI_i;
  AdmsSensFadType IDSATRGAT_i;
  AdmsSensFadType IDSATRSTI_i;
  AdmsSensFadType IDSATRBOT_i;
  AdmsSensFadType PHIGGAT_i;
  AdmsSensFadType PHIGSTI_i;
  AdmsSensFadType PHIGBOT_i;
  AdmsSensFadType CJORGAT_i;
  AdmsSensFadType CJORSTI_i;
  AdmsSensFadType CJORBOT_i;
  AdmsSensFadType FREV_i;
  AdmsSensFadType TRJ_i;
  double EPSSI;
  //Begin block initial_model
  {
    EPSSI = (8.8541878176E-12*11.8);
    TRJ_i = adms_ternary_op<AdmsSensFadType>((modelPar_TRJ>(-2.5e2)),modelPar_TRJ,(-2.5e2));
    modelVar_IMAX_i = adms_ternary_op<AdmsSensFadType>((modelPar_IMAX>1.0e-12),modelPar_IMAX,1.0e-12);
    FREV_i = adms_ternary_op<AdmsSensFadType>((modelPar_FREV>1.0e1),adms_ternary_op<AdmsSensFadType>((modelPar_FREV<1.0e10),modelPar_FREV,1.0e10),1.0e1);
    CJORBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORBOT>1.0e-12),modelPar_CJORBOT,1.0e-12);
    CJORSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORSTI>1.0e-18),modelPar_CJORSTI,1.0e-18);
    CJORGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CJORGAT>1.0e-18),modelPar_CJORGAT,1.0e-18);
    modelVar_VBIRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRBOT>5.0e-2),modelPar_VBIRBOT,5.0e-2);
    modelVar_VBIRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRSTI>5.0e-2),modelPar_VBIRSTI,5.0e-2);
    modelVar_VBIRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBIRGAT>5.0e-2),modelPar_VBIRGAT,5.0e-2);
    modelVar_PBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBOT>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PBOT<0.95),modelPar_PBOT,0.95),5.0e-2);
    modelVar_PSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_PSTI>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PSTI<0.95),modelPar_PSTI,0.95),5.0e-2);
    modelVar_PGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PGAT>5.0e-2),adms_ternary_op<AdmsSensFadType>((modelPar_PGAT<0.95),modelPar_PGAT,0.95),5.0e-2);
    PHIGBOT_i = modelPar_PHIGBOT;
    PHIGSTI_i = modelPar_PHIGSTI;
    PHIGGAT_i = modelPar_PHIGGAT;
    IDSATRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRBOT>0.0),modelPar_IDSATRBOT,0.0);
    IDSATRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRSTI>0.0),modelPar_IDSATRSTI,0.0);
    IDSATRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_IDSATRGAT>0.0),modelPar_IDSATRGAT,0.0);
    modelVar_CSRHBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHBOT>0.0),modelPar_CSRHBOT,0.0);
    modelVar_CSRHSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHSTI>0.0),modelPar_CSRHSTI,0.0);
    modelVar_CSRHGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CSRHGAT>0.0),modelPar_CSRHGAT,0.0);
    XJUNSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNSTI>1.0e-9),modelPar_XJUNSTI,1.0e-9);
    XJUNGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_XJUNGAT>1.0e-9),modelPar_XJUNGAT,1.0e-9);
    modelVar_CTATBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATBOT>0.0),modelPar_CTATBOT,0.0);
    modelVar_CTATSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATSTI>0.0),modelPar_CTATSTI,0.0);
    modelVar_CTATGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CTATGAT>0.0),modelPar_CTATGAT,0.0);
    MEFFTATBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATBOT>1.0e-2),modelPar_MEFFTATBOT,1.0e-2);
    MEFFTATSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATSTI>1.0e-2),modelPar_MEFFTATSTI,1.0e-2);
    MEFFTATGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_MEFFTATGAT>1.0e-2),modelPar_MEFFTATGAT,1.0e-2);
    modelVar_CBBTBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTBOT>0.0),modelPar_CBBTBOT,0.0);
    modelVar_CBBTSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTSTI>0.0),modelPar_CBBTSTI,0.0);
    modelVar_CBBTGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_CBBTGAT>0.0),modelPar_CBBTGAT,0.0);
    FBBTRBOT_i = modelPar_FBBTRBOT;
    FBBTRSTI_i = modelPar_FBBTRSTI;
    FBBTRGAT_i = modelPar_FBBTRGAT;
    STFBBTBOT_i = modelPar_STFBBTBOT;
    STFBBTSTI_i = modelPar_STFBBTSTI;
    STFBBTGAT_i = modelPar_STFBBTGAT;
    modelVar_VBRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRBOT>0.1),modelPar_VBRBOT,0.1);
    modelVar_VBRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRSTI>0.1),modelPar_VBRSTI,0.1);
    modelVar_VBRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_VBRGAT>0.1),modelPar_VBRGAT,0.1);
    modelVar_PBRBOT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRBOT>0.1),modelPar_PBRBOT,0.1);
    modelVar_PBRSTI_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRSTI>0.1),modelPar_PBRSTI,0.1);
    modelVar_PBRGAT_i = adms_ternary_op<AdmsSensFadType>((modelPar_PBRGAT>0.1),modelPar_PBRGAT,0.1);
    modelVar_SWJUNEXP_i = 0.0;
    if ((modelPar_SWJUNEXP>0.5))
    {
      modelVar_SWJUNEXP_i = 1.0;
    }
    else
    {
      modelVar_SWJUNEXP_i = 0.0;
    }
    modelVar_VJUNREF_i = adms_ternary_op<AdmsSensFadType>((modelPar_VJUNREF>0.5),modelPar_VJUNREF,0.5);
    modelVar_FJUNQ_i = adms_ternary_op<AdmsSensFadType>((modelPar_FJUNQ>0.0),modelPar_FJUNQ,0.0);
    tkr = (273.15+TRJ_i);
    tkd = std::max((admsTemperature+modelPar_DTA),(273.15+(-2.5e2)));
    auxt = (tkd/tkr);
    KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
    modelVar_phitr = (KBOL_over_QELE*tkr);
    phitrinv = (1.0/modelVar_phitr);
    modelVar_phitd = (KBOL_over_QELE*tkd);
    modelVar_phitdinv = (1.0/modelVar_phitd);
    deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
    phigrbot = (PHIGBOT_i+deltaphigr);
    phigrsti = (PHIGSTI_i+deltaphigr);
    phigrgat = (PHIGGAT_i+deltaphigr);
    deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
    phigdbot = (PHIGBOT_i+deltaphigd);
    phigdsti = (PHIGSTI_i+deltaphigd);
    phigdgat = (PHIGGAT_i+deltaphigd);
    modelVar_ftdbot = (pow(auxt,1.5)*exp((0.5*((phigrbot*phitrinv)-(phigdbot*modelVar_phitdinv)))));
    modelVar_ftdsti = (pow(auxt,1.5)*exp((0.5*((phigrsti*phitrinv)-(phigdsti*modelVar_phitdinv)))));
    modelVar_ftdgat = (pow(auxt,1.5)*exp((0.5*((phigrgat*phitrinv)-(phigdgat*modelVar_phitdinv)))));
    modelVar_idsatbot = ((IDSATRBOT_i*modelVar_ftdbot)*modelVar_ftdbot);
    modelVar_idsatsti = ((IDSATRSTI_i*modelVar_ftdsti)*modelVar_ftdsti);
    modelVar_idsatgat = ((IDSATRGAT_i*modelVar_ftdgat)*modelVar_ftdgat);
    ubibot = ((modelVar_VBIRBOT_i*auxt)-((2.0*modelVar_phitd)*log(modelVar_ftdbot)));
    ubisti = ((modelVar_VBIRSTI_i*auxt)-((2.0*modelVar_phitd)*log(modelVar_ftdsti)));
    ubigat = ((modelVar_VBIRGAT_i*auxt)-((2.0*modelVar_phitd)*log(modelVar_ftdgat)));
    modelVar_vbibot = (ubibot+(modelVar_phitd*log((1+exp(((5.0e-2-ubibot)*modelVar_phitdinv))))));
    modelVar_vbisti = (ubisti+(modelVar_phitd*log((1+exp(((5.0e-2-ubisti)*modelVar_phitdinv))))));
    modelVar_vbigat = (ubigat+(modelVar_phitd*log((1+exp(((5.0e-2-ubigat)*modelVar_phitdinv))))));
    modelVar_vbiinvbot = (1.0/modelVar_vbibot);
    modelVar_vbiinvsti = (1.0/modelVar_vbisti);
    modelVar_vbiinvgat = (1.0/modelVar_vbigat);
    modelVar_one_minus_PBOT = (1.0-modelVar_PBOT_i);
    modelVar_one_minus_PSTI = (1.0-modelVar_PSTI_i);
    modelVar_one_minus_PGAT = (1.0-modelVar_PGAT_i);
    modelVar_one_over_one_minus_PBOT = (1.0/modelVar_one_minus_PBOT);
    modelVar_one_over_one_minus_PSTI = (1.0/modelVar_one_minus_PSTI);
    modelVar_one_over_one_minus_PGAT = (1.0/modelVar_one_minus_PGAT);
    modelVar_cjobot = (CJORBOT_i*pow((modelVar_VBIRBOT_i*modelVar_vbiinvbot),modelVar_PBOT_i));
    modelVar_cjosti = (CJORSTI_i*pow((modelVar_VBIRSTI_i*modelVar_vbiinvsti),modelVar_PSTI_i));
    modelVar_cjogat = (CJORGAT_i*pow((modelVar_VBIRGAT_i*modelVar_vbiinvgat),modelVar_PGAT_i));
    modelVar_qprefbot = ((modelVar_cjobot*modelVar_vbibot)*modelVar_one_over_one_minus_PBOT);
    modelVar_qprefsti = ((modelVar_cjosti*modelVar_vbisti)*modelVar_one_over_one_minus_PSTI);
    modelVar_qprefgat = ((modelVar_cjogat*modelVar_vbigat)*modelVar_one_over_one_minus_PGAT);
    modelVar_qpref2bot = (2.0*modelVar_cjobot);
    modelVar_qpref2sti = (2.0*modelVar_cjosti);
    modelVar_qpref2gat = (2.0*modelVar_cjogat);
    modelVar_wdepnulrbot = (EPSSI/CJORBOT_i);
    modelVar_wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
    modelVar_wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
    modelVar_wdepnulrinvbot = (1.0/modelVar_wdepnulrbot);
    modelVar_wdepnulrinvsti = (1.0/modelVar_wdepnulrsti);
    modelVar_wdepnulrinvgat = (1.0/modelVar_wdepnulrgat);
    modelVar_VBIRBOTinv = (1.0/modelVar_VBIRBOT_i);
    modelVar_VBIRSTIinv = (1.0/modelVar_VBIRSTI_i);
    modelVar_VBIRGATinv = (1.0/modelVar_VBIRGAT_i);
    modelVar_perfc = (1.77245385090551603*0.29214664);
    modelVar_berfc = (((((-5.0)*0.29214664)+6.0)-pow(modelVar_perfc,(-2.0)))/3.0);
    modelVar_cerfc = ((1.0-0.29214664)-modelVar_berfc);
    deltaEbot = std::max((0.5*phigdbot),modelVar_phitd);
    deltaEsti = std::max((0.5*phigdsti),modelVar_phitd);
    deltaEgat = std::max((0.5*phigdgat),modelVar_phitd);
    modelVar_atatbot = (deltaEbot*modelVar_phitdinv);
    modelVar_atatsti = (deltaEsti*modelVar_phitdinv);
    modelVar_atatgat = (deltaEgat*modelVar_phitdinv);
    modelVar_btatpartbot = (sqrt(((((32.0*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)))/(3.0*1.05457168E-34));
    modelVar_btatpartsti = (sqrt(((((32.0*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)))/(3.0*1.05457168E-34));
    modelVar_btatpartgat = (sqrt(((((32.0*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)))/(3.0*1.05457168E-34));
    modelVar_fbbtbot = (FBBTRBOT_i*(1.0+(STFBBTBOT_i*(tkd-tkr))));
    modelVar_fbbtsti = (FBBTRSTI_i*(1.0+(STFBBTSTI_i*(tkd-tkr))));
    modelVar_fbbtgat = (FBBTRGAT_i*(1.0+(STFBBTGAT_i*(tkd-tkr))));
    modelVar_fbbtbot = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtbot>0.0),modelVar_fbbtbot,0.0);
    modelVar_fbbtsti = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtsti>0.0),modelVar_fbbtsti,0.0);
    modelVar_fbbtgat = adms_ternary_op<AdmsSensFadType>((modelVar_fbbtgat>0.0),modelVar_fbbtgat,0.0);
    modelVar_alphaav = (1.0-(1.0/FREV_i));
    modelVar_fstopbot = (1.0/(1.0-pow(modelVar_alphaav,modelVar_PBRBOT_i)));
    modelVar_fstopsti = (1.0/(1.0-pow(modelVar_alphaav,modelVar_PBRSTI_i)));
    modelVar_fstopgat = (1.0/(1.0-pow(modelVar_alphaav,modelVar_PBRGAT_i)));
    modelVar_VBRinvbot = (1.0/modelVar_VBRBOT_i);
    modelVar_VBRinvsti = (1.0/modelVar_VBRSTI_i);
    modelVar_VBRinvgat = (1.0/modelVar_VBRGAT_i);
    modelVar_slopebot = (((-((modelVar_fstopbot*modelVar_fstopbot)*pow(modelVar_alphaav,(modelVar_PBRBOT_i-1.0))))*modelVar_PBRBOT_i)*modelVar_VBRinvbot);
    modelVar_slopesti = (((-((modelVar_fstopsti*modelVar_fstopsti)*pow(modelVar_alphaav,(modelVar_PBRSTI_i-1.0))))*modelVar_PBRSTI_i)*modelVar_VBRinvsti);
    modelVar_slopegat = (((-((modelVar_fstopgat*modelVar_fstopgat)*pow(modelVar_alphaav,(modelVar_PBRGAT_i-1.0))))*modelVar_PBRGAT_i)*modelVar_VBRinvgat);
  }
  // End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_A_K,
   // node constants
   const int admsNodeID_A,
   const int admsNodeID_K,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_AB,
   bool instancePar_given_AB,
   AdmsSensFadType & instancePar_LS,
   bool instancePar_given_LS,
   AdmsSensFadType & instancePar_LG,
   bool instancePar_given_LG,
   AdmsSensFadType & instancePar_MULT,
   bool instancePar_given_MULT,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_MULT_i,
   AdmsSensFadType & instanceVar_AB_i,
   AdmsSensFadType & instanceVar_LS_i,
   AdmsSensFadType & instanceVar_LG_i,
   AdmsSensFadType & instanceVar_zflagbot,
   AdmsSensFadType & instanceVar_zflagsti,
   AdmsSensFadType & instanceVar_zflaggat,
   AdmsSensFadType & instanceVar_VMAX,
   AdmsSensFadType & instanceVar_exp_VMAX_over_phitd,
   AdmsSensFadType & instanceVar_vbimin,
   AdmsSensFadType & instanceVar_vch,
   AdmsSensFadType & instanceVar_vfmin,
   AdmsSensFadType & instanceVar_vbbtlim,
   AdmsSensFadType & instanceVar_xhighf1,
   AdmsSensFadType & instanceVar_expxhf1,
   AdmsSensFadType & instanceVar_xhighf2,
   AdmsSensFadType & instanceVar_expxhf2,
   AdmsSensFadType & instanceVar_xhighr,
   AdmsSensFadType & instanceVar_expxhr,
   AdmsSensFadType & instanceVar_ISATFOR1,
   AdmsSensFadType & instanceVar_MFOR1,
   AdmsSensFadType & instanceVar_ISATFOR2,
   AdmsSensFadType & instanceVar_MFOR2,
   AdmsSensFadType & instanceVar_ISATREV,
   AdmsSensFadType & instanceVar_MREV,
   AdmsSensFadType & instanceVar_m0flag,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_DTA,
   bool modelPar_given_DTA,
   AdmsSensFadType & modelPar_IMAX,
   bool modelPar_given_IMAX,
   AdmsSensFadType & modelPar_TRJ,
   bool modelPar_given_TRJ,
   AdmsSensFadType & modelPar_FREV,
   bool modelPar_given_FREV,
   AdmsSensFadType & modelPar_CJORBOT,
   bool modelPar_given_CJORBOT,
   AdmsSensFadType & modelPar_CJORSTI,
   bool modelPar_given_CJORSTI,
   AdmsSensFadType & modelPar_CJORGAT,
   bool modelPar_given_CJORGAT,
   AdmsSensFadType & modelPar_VBIRBOT,
   bool modelPar_given_VBIRBOT,
   AdmsSensFadType & modelPar_VBIRSTI,
   bool modelPar_given_VBIRSTI,
   AdmsSensFadType & modelPar_VBIRGAT,
   bool modelPar_given_VBIRGAT,
   AdmsSensFadType & modelPar_PBOT,
   bool modelPar_given_PBOT,
   AdmsSensFadType & modelPar_PSTI,
   bool modelPar_given_PSTI,
   AdmsSensFadType & modelPar_PGAT,
   bool modelPar_given_PGAT,
   AdmsSensFadType & modelPar_PHIGBOT,
   bool modelPar_given_PHIGBOT,
   AdmsSensFadType & modelPar_PHIGSTI,
   bool modelPar_given_PHIGSTI,
   AdmsSensFadType & modelPar_PHIGGAT,
   bool modelPar_given_PHIGGAT,
   AdmsSensFadType & modelPar_IDSATRBOT,
   bool modelPar_given_IDSATRBOT,
   AdmsSensFadType & modelPar_IDSATRSTI,
   bool modelPar_given_IDSATRSTI,
   AdmsSensFadType & modelPar_IDSATRGAT,
   bool modelPar_given_IDSATRGAT,
   AdmsSensFadType & modelPar_CSRHBOT,
   bool modelPar_given_CSRHBOT,
   AdmsSensFadType & modelPar_CSRHSTI,
   bool modelPar_given_CSRHSTI,
   AdmsSensFadType & modelPar_CSRHGAT,
   bool modelPar_given_CSRHGAT,
   AdmsSensFadType & modelPar_XJUNSTI,
   bool modelPar_given_XJUNSTI,
   AdmsSensFadType & modelPar_XJUNGAT,
   bool modelPar_given_XJUNGAT,
   AdmsSensFadType & modelPar_CTATBOT,
   bool modelPar_given_CTATBOT,
   AdmsSensFadType & modelPar_CTATSTI,
   bool modelPar_given_CTATSTI,
   AdmsSensFadType & modelPar_CTATGAT,
   bool modelPar_given_CTATGAT,
   AdmsSensFadType & modelPar_MEFFTATBOT,
   bool modelPar_given_MEFFTATBOT,
   AdmsSensFadType & modelPar_MEFFTATSTI,
   bool modelPar_given_MEFFTATSTI,
   AdmsSensFadType & modelPar_MEFFTATGAT,
   bool modelPar_given_MEFFTATGAT,
   AdmsSensFadType & modelPar_CBBTBOT,
   bool modelPar_given_CBBTBOT,
   AdmsSensFadType & modelPar_CBBTSTI,
   bool modelPar_given_CBBTSTI,
   AdmsSensFadType & modelPar_CBBTGAT,
   bool modelPar_given_CBBTGAT,
   AdmsSensFadType & modelPar_FBBTRBOT,
   bool modelPar_given_FBBTRBOT,
   AdmsSensFadType & modelPar_FBBTRSTI,
   bool modelPar_given_FBBTRSTI,
   AdmsSensFadType & modelPar_FBBTRGAT,
   bool modelPar_given_FBBTRGAT,
   AdmsSensFadType & modelPar_STFBBTBOT,
   bool modelPar_given_STFBBTBOT,
   AdmsSensFadType & modelPar_STFBBTSTI,
   bool modelPar_given_STFBBTSTI,
   AdmsSensFadType & modelPar_STFBBTGAT,
   bool modelPar_given_STFBBTGAT,
   AdmsSensFadType & modelPar_VBRBOT,
   bool modelPar_given_VBRBOT,
   AdmsSensFadType & modelPar_VBRSTI,
   bool modelPar_given_VBRSTI,
   AdmsSensFadType & modelPar_VBRGAT,
   bool modelPar_given_VBRGAT,
   AdmsSensFadType & modelPar_PBRBOT,
   bool modelPar_given_PBRBOT,
   AdmsSensFadType & modelPar_PBRSTI,
   bool modelPar_given_PBRSTI,
   AdmsSensFadType & modelPar_PBRGAT,
   bool modelPar_given_PBRGAT,
   AdmsSensFadType & modelPar_SWJUNEXP,
   bool modelPar_given_SWJUNEXP,
   AdmsSensFadType & modelPar_VJUNREF,
   bool modelPar_given_VJUNREF,
   AdmsSensFadType & modelPar_FJUNQ,
   bool modelPar_given_FJUNQ,
   // non-reals (including hidden)
   int modelPar_LEVEL,
   bool modelPar_given_LEVEL,
   int modelPar_TYPE,
   bool modelPar_given_TYPE// model variables
   ,
   // reals
   AdmsSensFadType & modelVar_IMAX_i,
   AdmsSensFadType & modelVar_VBIRBOT_i,
   AdmsSensFadType & modelVar_VBIRSTI_i,
   AdmsSensFadType & modelVar_VBIRGAT_i,
   AdmsSensFadType & modelVar_PBOT_i,
   AdmsSensFadType & modelVar_PSTI_i,
   AdmsSensFadType & modelVar_PGAT_i,
   AdmsSensFadType & modelVar_CSRHBOT_i,
   AdmsSensFadType & modelVar_CSRHSTI_i,
   AdmsSensFadType & modelVar_CSRHGAT_i,
   AdmsSensFadType & modelVar_CTATBOT_i,
   AdmsSensFadType & modelVar_CTATSTI_i,
   AdmsSensFadType & modelVar_CTATGAT_i,
   AdmsSensFadType & modelVar_CBBTBOT_i,
   AdmsSensFadType & modelVar_CBBTSTI_i,
   AdmsSensFadType & modelVar_CBBTGAT_i,
   AdmsSensFadType & modelVar_VBRBOT_i,
   AdmsSensFadType & modelVar_VBRSTI_i,
   AdmsSensFadType & modelVar_VBRGAT_i,
   AdmsSensFadType & modelVar_PBRBOT_i,
   AdmsSensFadType & modelVar_PBRSTI_i,
   AdmsSensFadType & modelVar_PBRGAT_i,
   AdmsSensFadType & modelVar_SWJUNEXP_i,
   AdmsSensFadType & modelVar_VJUNREF_i,
   AdmsSensFadType & modelVar_FJUNQ_i,
   AdmsSensFadType & modelVar_phitr,
   AdmsSensFadType & modelVar_phitd,
   AdmsSensFadType & modelVar_phitdinv,
   AdmsSensFadType & modelVar_perfc,
   AdmsSensFadType & modelVar_berfc,
   AdmsSensFadType & modelVar_cerfc,
   AdmsSensFadType & modelVar_ftdbot,
   AdmsSensFadType & modelVar_ftdsti,
   AdmsSensFadType & modelVar_ftdgat,
   AdmsSensFadType & modelVar_idsatbot,
   AdmsSensFadType & modelVar_idsatsti,
   AdmsSensFadType & modelVar_idsatgat,
   AdmsSensFadType & modelVar_vbibot,
   AdmsSensFadType & modelVar_vbisti,
   AdmsSensFadType & modelVar_vbigat,
   AdmsSensFadType & modelVar_vbiinvbot,
   AdmsSensFadType & modelVar_vbiinvsti,
   AdmsSensFadType & modelVar_vbiinvgat,
   AdmsSensFadType & modelVar_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_minus_PGAT,
   AdmsSensFadType & modelVar_one_over_one_minus_PBOT,
   AdmsSensFadType & modelVar_one_over_one_minus_PSTI,
   AdmsSensFadType & modelVar_one_over_one_minus_PGAT,
   AdmsSensFadType & modelVar_cjobot,
   AdmsSensFadType & modelVar_cjosti,
   AdmsSensFadType & modelVar_cjogat,
   AdmsSensFadType & modelVar_qprefbot,
   AdmsSensFadType & modelVar_qprefsti,
   AdmsSensFadType & modelVar_qprefgat,
   AdmsSensFadType & modelVar_qpref2bot,
   AdmsSensFadType & modelVar_qpref2sti,
   AdmsSensFadType & modelVar_qpref2gat,
   AdmsSensFadType & modelVar_wdepnulrbot,
   AdmsSensFadType & modelVar_wdepnulrsti,
   AdmsSensFadType & modelVar_wdepnulrgat,
   AdmsSensFadType & modelVar_wdepnulrinvbot,
   AdmsSensFadType & modelVar_wdepnulrinvsti,
   AdmsSensFadType & modelVar_wdepnulrinvgat,
   AdmsSensFadType & modelVar_VBIRBOTinv,
   AdmsSensFadType & modelVar_VBIRSTIinv,
   AdmsSensFadType & modelVar_VBIRGATinv,
   AdmsSensFadType & modelVar_atatbot,
   AdmsSensFadType & modelVar_atatsti,
   AdmsSensFadType & modelVar_atatgat,
   AdmsSensFadType & modelVar_btatpartbot,
   AdmsSensFadType & modelVar_btatpartsti,
   AdmsSensFadType & modelVar_btatpartgat,
   AdmsSensFadType & modelVar_fbbtbot,
   AdmsSensFadType & modelVar_fbbtsti,
   AdmsSensFadType & modelVar_fbbtgat,
   AdmsSensFadType & modelVar_alphaav,
   AdmsSensFadType & modelVar_fstopbot,
   AdmsSensFadType & modelVar_fstopsti,
   AdmsSensFadType & modelVar_fstopgat,
   AdmsSensFadType & modelVar_VBRinvbot,
   AdmsSensFadType & modelVar_VBRinvsti,
   AdmsSensFadType & modelVar_VBRinvgat,
   AdmsSensFadType & modelVar_slopebot,
   AdmsSensFadType & modelVar_slopesti,
   AdmsSensFadType & modelVar_slopegat,
   // basic variables
   double admsTemperature, double adms_vt_nom, double gmin, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance)
{

  // Local variables
  AdmsSensFadType h1;
  AdmsSensFadType h2;
  AdmsSensFadType h2d;
  AdmsSensFadType h3;
  AdmsSensFadType h4;
  AdmsSensFadType h5;
  AdmsSensFadType ijunrev;
  AdmsSensFadType ijunfor2;
  AdmsSensFadType ijunfor1;
  AdmsSensFadType tm1;
  AdmsSensFadType tm0;
  AdmsSensFadType fbreakdown;
  AdmsSensFadType ibbt;
  AdmsSensFadType Fmaxr;
  AdmsSensFadType itat;
  AdmsSensFadType gammamax;
  AdmsSensFadType erfctimesexpmtat;
  AdmsSensFadType erfcpos;
  AdmsSensFadType terfc;
  AdmsSensFadType ysq;
  AdmsSensFadType xerfc;
  AdmsSensFadType mtat;
  AdmsSensFadType ltat;
  AdmsSensFadType ktat;
  AdmsSensFadType wtat;
  AdmsSensFadType wgamma;
  AdmsSensFadType umaxpoweronepointfive;
  AdmsSensFadType sqrtumax;
  AdmsSensFadType umax;
  AdmsSensFadType umaxbeforelimiting;
  AdmsSensFadType twoatatoverthreebtat;
  AdmsSensFadType btat;
  AdmsSensFadType isrh;
  AdmsSensFadType asrh;
  AdmsSensFadType wdep;
  AdmsSensFadType wsrh;
  AdmsSensFadType dwsrh;
  AdmsSensFadType wsrhstep;
  AdmsSensFadType vbi_minus_vjsrh;
  AdmsSensFadType id;
  AdmsSensFadType tmp;
  AdmsSensFadType vav;
  AdmsSensFadType vjsrh;
  AdmsSensFadType vjlim;
  AdmsSensFadType z;
  AdmsSensFadType idmult;
  AdmsSensFadType zinv;
  AdmsSensFadType vj;
  AdmsSensFadType two_psistar;
  AdmsSensFadType vbbt;
  AdmsSensFadType vbisgat;
  AdmsSensFadType vbissti;
  AdmsSensFadType vbisbot;
  AdmsSensFadType cjosgat;
  AdmsSensFadType cjossti;
  AdmsSensFadType cjosbot;
  AdmsSensFadType si;
  AdmsSensFadType ij;
  AdmsSensFadType idsatsgat;
  AdmsSensFadType idsatssti;
  AdmsSensFadType idsatsbot;
  AdmsSensFadType ijsti;
  AdmsSensFadType ijgat;
  AdmsSensFadType ijbot;
  AdmsSensFadType vak;


  // -- code converted from analog/code block
  //Begin block evaluateblock
  {
    //Block-local variables for block evaluateblock
    AdmsSensFadType ijunbot;
    AdmsSensFadType qjunbot;
    AdmsSensFadType ijunsti;
    AdmsSensFadType qjunsti;
    AdmsSensFadType ijungat;
    AdmsSensFadType qjungat;
    AdmsSensFadType ijun;
    AdmsSensFadType qjun;
    AdmsSensFadType jnoise;
    AdmsSensFadType VAK;
    //End of Block-local variables
    ijun = 0.0;
    ijunbot = 0.0;
    ijunsti = 0.0;
    ijungat = 0.0;
    //Begin block evaluateStaticDynamic
    {
      VAK = (modelPar_TYPE*(probeVars[admsProbeID_V_A_K]));
      if ((modelVar_SWJUNEXP_i==1.0))
      {
        tm0 = ((VAK*modelVar_phitdinv)*instanceVar_MFOR1);
        tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf1),(instanceVar_expxhf1*((tm0-instanceVar_xhighf1)+1.0)),exp(tm0)));
        ijunfor1 = (instanceVar_ISATFOR1*(tm1-1.0));
        tm0 = ((VAK*modelVar_phitdinv)*instanceVar_MFOR2);
        tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighf2),(instanceVar_expxhf2*((tm0-instanceVar_xhighf2)+1.0)),exp(tm0)));
        ijunfor2 = (instanceVar_ISATFOR2*(tm1-1.0));
        ijunrev = 0.0;
        if ((instanceVar_m0flag>0.0))
        {
          ijunrev = (VAK*(instanceVar_ISATREV+(VAK*instanceVar_MREV)));
        }
        else
        {
          tm0 = (((-VAK)*modelVar_phitdinv)*instanceVar_MREV);
          tm1 = adms_ternary_op<AdmsSensFadType>((tm0<(-2.3025850929940458e+02)),(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)),adms_ternary_op<AdmsSensFadType>((tm0>instanceVar_xhighr),(instanceVar_expxhr*((tm0-instanceVar_xhighr)+1.0)),exp(tm0)));
          ijunrev = ((-instanceVar_ISATREV)*(tm1-1.0));
        }
        ijun = ((ijunfor1+ijunfor2)+ijunrev);
        //Begin block evaluateDynamic
        {
          //Block-local variables for block evaluateDynamic
          AdmsSensFadType tmpv;
          AdmsSensFadType vjv;
          //End of Block-local variables
          tmpv = 0.0;
          vjv = 0.0;
          h1 = ((4.0*instanceVar_vch)*instanceVar_vch);
          h2 = (instanceVar_vch/instanceVar_vfmin);
          h2d = (VAK+(instanceVar_vch*h2));
          h3 = (instanceVar_vfmin+h2d);
          h4 = (instanceVar_vfmin-h2d);
          h5 = sqrt(((h4*h4)+h1));
          vjv = (2.0*((VAK*instanceVar_vfmin)/(h3+h5)));
          if ((instanceVar_zflagbot>0.5))
          {
            if ((modelVar_one_minus_PBOT==0.5))
            {
              tmpv = sqrt((1.0-(vjv*modelVar_vbiinvbot)));
            }
            else
            {
              tmpv = pow((1.0-(vjv*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
            }
            qjunbot = ((modelVar_qprefbot*(1.0-tmpv))+(modelVar_qpref2bot*(VAK-vjv)));
          }
          if ((instanceVar_zflagsti>0.5))
          {
            if ((modelVar_one_minus_PSTI==0.5))
            {
              tmpv = sqrt((1.0-(vjv*modelVar_vbiinvsti)));
            }
            else
            {
              tmpv = pow((1.0-(vjv*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
            }
            qjunsti = ((modelVar_qprefsti*(1.0-tmpv))+(modelVar_qpref2sti*(VAK-vjv)));
          }
          if ((instanceVar_zflaggat>0.5))
          {
            if ((modelVar_one_minus_PGAT==0.5))
            {
              tmpv = sqrt((1.0-(vjv*modelVar_vbiinvgat)));
            }
            else
            {
              tmpv = pow((1.0-(vjv*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
            }
            qjungat = ((modelVar_qprefgat*(1.0-tmpv))+(modelVar_qpref2gat*(VAK-vjv)));
          }
        }
        // End block evaluateDynamic
      }
      else
      {
        vbbt = 0.0;
        two_psistar = 0.0;
        if ((!(((instanceVar_AB_i==0.0)&&(instanceVar_LS_i==0.0))&&(instanceVar_LG_i==0.0))))
        {
          h1 = ((4.0*instanceVar_vch)*instanceVar_vch);
          h2 = (instanceVar_vch/instanceVar_vfmin);
          h2d = (VAK+(instanceVar_vch*h2));
          h3 = (instanceVar_vfmin+h2d);
          h4 = (instanceVar_vfmin-h2d);
          h5 = sqrt(((h4*h4)+h1));
          vj = (2.0*((VAK*instanceVar_vfmin)/(h3+h5)));
          if ((VAK<instanceVar_VMAX))
          {
            if ((fabs((0.5*(VAK*modelVar_phitdinv)))<2.3025850929940458e+02))
            {
              zinv = exp((0.5*(VAK*modelVar_phitdinv)));
            }
            else
            {
              if (((0.5*(VAK*modelVar_phitdinv))<0.0))
              {
                zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(VAK*modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*modelVar_phitdinv)))*3.3333333333333333e-01))))))));
              }
              else
              {
                zinv = (1.0e100*(1.0+(((0.5*(VAK*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(VAK*modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(VAK*modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            idmult = (zinv*zinv);
          }
          else
          {
            idmult = ((1.0+((VAK-instanceVar_VMAX)*modelVar_phitdinv))*instanceVar_exp_VMAX_over_phitd);
            zinv = sqrt(idmult);
          }
          idmult = (idmult-1.0);
          z = (1.0/zinv);
          if ((VAK>0.0))
          {
            two_psistar = (2.0*(modelVar_phitd*log(((2.0+z)+sqrt(((z+1.0)*(z+3.0)))))));
          }
          else
          {
            two_psistar = ((-VAK)+(2.0*(modelVar_phitd*log((((2.0*zinv)+1.0)+sqrt(((1.0+zinv)*(1.0+(3.0*zinv)))))))));
          }
          vjlim = (instanceVar_vbimin-two_psistar);
          vjsrh = (0.5*((VAK+vjlim)-sqrt((((VAK-vjlim)*(VAK-vjlim))+((4.0*modelVar_phitd)*modelVar_phitd)))));
          vbbt = (0.5*((VAK+instanceVar_vbbtlim)-sqrt((((VAK-instanceVar_vbbtlim)*(VAK-instanceVar_vbbtlim))+((4.0*modelVar_phitr)*modelVar_phitr)))));
          vav = (0.5*((VAK)-sqrt((((VAK)*(VAK))+((4.0*1.0e-6)*1.0e-6)))));
        }
        if ((instanceVar_AB_i==0.0))
        {
          ijunbot = 0.0;
          qjunbot = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PBOT==0.5))
          {
            tmp = sqrt((1.0-(vj*modelVar_vbiinvbot)));
          }
          else
          {
            tmp = pow((1.0-(vj*modelVar_vbiinvbot)),modelVar_one_minus_PBOT);
          }
          qjunbot = ((modelVar_qprefbot*(1.0-tmp))+(modelVar_qpref2bot*(VAK-vj)));
          id = (modelVar_idsatbot*idmult);
          if (((modelVar_CSRHBOT_i==0.0)&&(modelVar_CTATBOT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbibot-vjsrh);
            wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
            if ((modelVar_PBOT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PBOT_i)));
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PBOT_i==0.5))
            {
              tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRBOTinv));
            }
            else
            {
              tmp = pow((vbi_minus_vjsrh*modelVar_VBIRBOTinv),modelVar_PBOT_i);
            }
            wdep = (modelVar_wdepnulrbot*tmp);
            asrh = (modelVar_ftdbot*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHBOT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATBOT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartbot*((wdep*modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatbot)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
            sqrtumax = sqrt(fabs(umax));
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PBOT_i)*modelVar_one_over_one_minus_PBOT));
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            ktat = sqrt((0.375*(btat/sqrtumax)));
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              tmp = exp(((-ysq)+mtat));
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                tmp = exp(mtat);
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatbot*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTBOT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PBOT_i==0.5))
            {
              tmp = sqrt(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv));
            }
            else
            {
              tmp = pow(((modelVar_VBIRBOT_i-vbbt)*modelVar_VBIRBOTinv),modelVar_PBOT_i);
            }
            Fmaxr = (modelVar_one_over_one_minus_PBOT*(((modelVar_VBIRBOT_i-vbbt)*modelVar_wdepnulrinvbot)/tmp));
            if ((fabs(((-modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
            {
              tmp = exp(((-modelVar_fbbtbot)/Fmaxr));
            }
            else
            {
              if ((((-modelVar_fbbtbot)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTBOT_i*(((VAK*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRBOT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRBOT_i)))
            {
              if ((modelVar_PBRBOT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvbot)*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot))*(vav*modelVar_VBRinvbot));
              }
              else
              {
                tmp = pow(fabs((vav*modelVar_VBRinvbot)),modelVar_PBRBOT_i);
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopbot+((vav+(modelVar_alphaav*modelVar_VBRBOT_i))*modelVar_slopebot));
            }
          }
          ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LS_i==0.0))
        {
          ijunsti = 0.0;
          qjunsti = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PSTI==0.5))
          {
            tmp = sqrt((1.0-(vj*modelVar_vbiinvsti)));
          }
          else
          {
            tmp = pow((1.0-(vj*modelVar_vbiinvsti)),modelVar_one_minus_PSTI);
          }
          qjunsti = ((modelVar_qprefsti*(1.0-tmp))+(modelVar_qpref2sti*(VAK-vj)));
          id = (modelVar_idsatsti*idmult);
          if (((modelVar_CSRHSTI_i==0.0)&&(modelVar_CTATSTI_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbisti-vjsrh);
            wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
            if ((modelVar_PSTI_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PSTI_i)));
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PSTI_i==0.5))
            {
              tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRSTIinv));
            }
            else
            {
              tmp = pow((vbi_minus_vjsrh*modelVar_VBIRSTIinv),modelVar_PSTI_i);
            }
            wdep = (modelVar_wdepnulrsti*tmp);
            asrh = (modelVar_ftdsti*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHSTI_i*(asrh*wsrh));
          }
          if ((modelVar_CTATSTI_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartsti*((wdep*modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatsti)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
            sqrtumax = sqrt(fabs(umax));
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PSTI_i)*modelVar_one_over_one_minus_PSTI));
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            ktat = sqrt((0.375*(btat/sqrtumax)));
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              tmp = exp(((-ysq)+mtat));
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                tmp = exp(mtat);
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatsti*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTSTI_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PSTI_i==0.5))
            {
              tmp = sqrt(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv));
            }
            else
            {
              tmp = pow(((modelVar_VBIRSTI_i-vbbt)*modelVar_VBIRSTIinv),modelVar_PSTI_i);
            }
            Fmaxr = (modelVar_one_over_one_minus_PSTI*(((modelVar_VBIRSTI_i-vbbt)*modelVar_wdepnulrinvsti)/tmp));
            if ((fabs(((-modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
            {
              tmp = exp(((-modelVar_fbbtsti)/Fmaxr));
            }
            else
            {
              if ((((-modelVar_fbbtsti)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTSTI_i*(((VAK*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRSTI_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRSTI_i)))
            {
              if ((modelVar_PBRSTI_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvsti)*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti))*(vav*modelVar_VBRinvsti));
              }
              else
              {
                tmp = pow(fabs((vav*modelVar_VBRinvsti)),modelVar_PBRSTI_i);
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopsti+((vav+(modelVar_alphaav*modelVar_VBRSTI_i))*modelVar_slopesti));
            }
          }
          ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        if ((instanceVar_LG_i==0.0))
        {
          ijungat = 0.0;
          qjungat = 0.0;
        }
        else
        {
          if ((modelVar_one_minus_PGAT==0.5))
          {
            tmp = sqrt((1.0-(vj*modelVar_vbiinvgat)));
          }
          else
          {
            tmp = pow((1.0-(vj*modelVar_vbiinvgat)),modelVar_one_minus_PGAT);
          }
          qjungat = ((modelVar_qprefgat*(1.0-tmp))+(modelVar_qpref2gat*(VAK-vj)));
          id = (modelVar_idsatgat*idmult);
          if (((modelVar_CSRHGAT_i==0.0)&&(modelVar_CTATGAT_i==0.0)))
          {
            isrh = 0.0;
          }
          else
          {
            vbi_minus_vjsrh = (modelVar_vbigat-vjsrh);
            wsrhstep = (1.0-sqrt((1.0-(two_psistar/vbi_minus_vjsrh))));
            if ((modelVar_PGAT_i==0.5))
            {
              dwsrh = 0.0;
            }
            else
            {
              dwsrh = (((((wsrhstep*wsrhstep)*log(wsrhstep))/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelVar_PGAT_i)));
            }
            wsrh = (wsrhstep+dwsrh);
            if ((modelVar_PGAT_i==0.5))
            {
              tmp = sqrt((vbi_minus_vjsrh*modelVar_VBIRGATinv));
            }
            else
            {
              tmp = pow((vbi_minus_vjsrh*modelVar_VBIRGATinv),modelVar_PGAT_i);
            }
            wdep = (modelVar_wdepnulrgat*tmp);
            asrh = (modelVar_ftdgat*((zinv-1.0)*wdep));
            isrh = (modelVar_CSRHGAT_i*(asrh*wsrh));
          }
          if ((modelVar_CTATGAT_i==0.0))
          {
            itat = 0.0;
          }
          else
          {
            btat = (modelVar_btatpartgat*((wdep*modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
            twoatatoverthreebtat = ((0.666666666666667*modelVar_atatgat)/btat);
            umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
            umax = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
            sqrtumax = sqrt(fabs(umax));
            umaxpoweronepointfive = (umax*sqrtumax);
            if ((((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT)==(-1.0)))
            {
              wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
            }
            else
            {
              wgamma = pow((1.0+(btat*umaxpoweronepointfive)),((-modelVar_PGAT_i)*modelVar_one_over_one_minus_PGAT));
            }
            wtat = ((wsrh*wgamma)/(wsrh+wgamma));
            ktat = sqrt((0.375*(btat/sqrtumax)));
            ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
            mtat = ((((modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
            xerfc = ((ltat-1.0)*ktat);
            ysq = (xerfc*xerfc);
            if ((xerfc>0.0))
            {
              terfc = (1.0/(1.0+(modelVar_perfc*xerfc)));
            }
            else
            {
              terfc = (1.0/(1.0-(modelVar_perfc*xerfc)));
            }
            if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
            {
              tmp = exp(((-ysq)+mtat));
            }
            else
            {
              tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
            }
            erfcpos = ((((0.29214664*terfc)+(modelVar_berfc*(terfc*terfc)))+(modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
            if ((xerfc>0.0))
            {
              erfctimesexpmtat = erfcpos;
            }
            else
            {
              if ((mtat>(-2.3025850929940458e+02)))
              {
                tmp = exp(mtat);
              }
              else
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
              }
              erfctimesexpmtat = ((2.0*tmp)-erfcpos);
            }
            gammamax = ((1.77245385090551603*0.5)*((modelVar_atatgat*erfctimesexpmtat)/ktat));
            itat = (modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
          }
          if ((modelVar_CBBTGAT_i==0.0))
          {
            ibbt = 0.0;
          }
          else
          {
            if ((modelVar_PGAT_i==0.5))
            {
              tmp = sqrt(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv));
            }
            else
            {
              tmp = pow(((modelVar_VBIRGAT_i-vbbt)*modelVar_VBIRGATinv),modelVar_PGAT_i);
            }
            Fmaxr = (modelVar_one_over_one_minus_PGAT*(((modelVar_VBIRGAT_i-vbbt)*modelVar_wdepnulrinvgat)/tmp));
            if ((fabs(((-modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
            {
              tmp = exp(((-modelVar_fbbtgat)/Fmaxr));
            }
            else
            {
              if ((((-modelVar_fbbtgat)/Fmaxr)<0.0))
              {
                tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
              }
              else
              {
                tmp = (1.0e100*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
              }
            }
            ibbt = (modelVar_CBBTGAT_i*(((VAK*Fmaxr)*Fmaxr)*tmp));
          }
          if ((modelVar_VBRGAT_i>1.0e3))
          {
            fbreakdown = 1.0;
          }
          else
          {
            if ((vav>((-modelVar_alphaav)*modelVar_VBRGAT_i)))
            {
              if ((modelVar_PBRGAT_i==4.0))
              {
                tmp = ((((vav*modelVar_VBRinvgat)*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat))*(vav*modelVar_VBRinvgat));
              }
              else
              {
                tmp = pow(fabs((vav*modelVar_VBRinvgat)),modelVar_PBRGAT_i);
              }
              fbreakdown = (1.0/(1.0-tmp));
            }
            else
            {
              fbreakdown = (modelVar_fstopgat+((vav+(modelVar_alphaav*modelVar_VBRGAT_i))*modelVar_slopegat));
            }
          }
          ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
        }
        ijun = (((instanceVar_AB_i*ijunbot)+(instanceVar_LS_i*ijunsti))+(instanceVar_LG_i*ijungat));
      }
      qjun = (((instanceVar_AB_i*qjunbot)+(instanceVar_LS_i*qjunsti))+(instanceVar_LG_i*qjungat));
    }
    // End block evaluateStaticDynamic
    //Begin block loadStatic
    {
      // I(A,K) <+ (((TYPE*MULT_i)*ijun))
      staticContributions[admsNodeID_A] += ((modelPar_TYPE*instanceVar_MULT_i)*ijun);
      staticContributions[admsNodeID_K] -= ((modelPar_TYPE*instanceVar_MULT_i)*ijun);
    }
    // End block loadStatic
    //Begin block loadDynamic
    {
      // I(A,K) <+ (ddt(((TYPE*MULT_i)*qjun)))
      dynamicContributions[admsNodeID_A] += (((modelPar_TYPE*instanceVar_MULT_i)*qjun));
      dynamicContributions[admsNodeID_K] -= (((modelPar_TYPE*instanceVar_MULT_i)*qjun));
    }
    // End block loadDynamic
    //Begin block noise
    {
      jnoise = ((2*1.6021918E-19)*fabs(ijun));
      // I(A,K) <+ (white_noise((MULT_i*jnoise),"shot"))
    }
    // End block noise
    //Begin block OPinfo
    {
      vak = VAK;
      if ((modelVar_SWJUNEXP_i==1.0))
      {
        ijbot = 0.0;
        ijgat = 0.0;
        ijsti = 0.0;
        idsatsbot = 0.0;
        idsatssti = 0.0;
        idsatsgat = 0.0;
      }
      else
      {
        ijbot = ((instanceVar_MULT_i*instanceVar_AB_i)*ijunbot);
        ijgat = ((instanceVar_MULT_i*instanceVar_LG_i)*ijungat);
        ijsti = ((instanceVar_MULT_i*instanceVar_LS_i)*ijunsti);
        idsatsbot = ((instanceVar_MULT_i*instanceVar_AB_i)*modelVar_idsatbot);
        idsatssti = ((instanceVar_MULT_i*instanceVar_LS_i)*modelVar_idsatsti);
        idsatsgat = ((instanceVar_MULT_i*instanceVar_LG_i)*modelVar_idsatgat);
      }
      ij = (instanceVar_MULT_i*ijun);
      si = (instanceVar_MULT_i*jnoise);
      cjosbot = ((instanceVar_MULT_i*instanceVar_AB_i)*modelVar_cjobot);
      cjossti = ((instanceVar_MULT_i*instanceVar_LS_i)*modelVar_cjosti);
      cjosgat = ((instanceVar_MULT_i*instanceVar_LG_i)*modelVar_cjogat);
      vbisbot = modelVar_vbibot;
      vbissti = modelVar_vbisti;
      vbisgat = modelVar_vbigat;
    }
    // End block OPinfo
  }
  // End block evaluateblock
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void InstanceSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Instance & in = *(dynamic_cast<const Instance *> (e1));
  const Model & mod =in.model_;

  dfdp.resize(2+0);
  dqdp.resize(2+0);
  Findices.resize(2+0);
  Qindices.resize(2+0);

  std::vector <double> probeVars(1);
  std::vector <AdmsSensFadType> staticContributions(2+0);
  std::vector <AdmsSensFadType> dynamicContributions(2+0);


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 2+0 ; ++i)
  {
    staticContributions[i]=0;
    dynamicContributions[i]=0;
  }

  // Copy out all the model parameters (doubles) into FAD types
  //reals
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  AdmsSensFadType modelPar_IMAX=mod.IMAX;
  bool modelPar_given_IMAX=mod.given("IMAX");
  AdmsSensFadType modelPar_TRJ=mod.TRJ;
  bool modelPar_given_TRJ=mod.given("TRJ");
  AdmsSensFadType modelPar_FREV=mod.FREV;
  bool modelPar_given_FREV=mod.given("FREV");
  AdmsSensFadType modelPar_CJORBOT=mod.CJORBOT;
  bool modelPar_given_CJORBOT=mod.given("CJORBOT");
  AdmsSensFadType modelPar_CJORSTI=mod.CJORSTI;
  bool modelPar_given_CJORSTI=mod.given("CJORSTI");
  AdmsSensFadType modelPar_CJORGAT=mod.CJORGAT;
  bool modelPar_given_CJORGAT=mod.given("CJORGAT");
  AdmsSensFadType modelPar_VBIRBOT=mod.VBIRBOT;
  bool modelPar_given_VBIRBOT=mod.given("VBIRBOT");
  AdmsSensFadType modelPar_VBIRSTI=mod.VBIRSTI;
  bool modelPar_given_VBIRSTI=mod.given("VBIRSTI");
  AdmsSensFadType modelPar_VBIRGAT=mod.VBIRGAT;
  bool modelPar_given_VBIRGAT=mod.given("VBIRGAT");
  AdmsSensFadType modelPar_PBOT=mod.PBOT;
  bool modelPar_given_PBOT=mod.given("PBOT");
  AdmsSensFadType modelPar_PSTI=mod.PSTI;
  bool modelPar_given_PSTI=mod.given("PSTI");
  AdmsSensFadType modelPar_PGAT=mod.PGAT;
  bool modelPar_given_PGAT=mod.given("PGAT");
  AdmsSensFadType modelPar_PHIGBOT=mod.PHIGBOT;
  bool modelPar_given_PHIGBOT=mod.given("PHIGBOT");
  AdmsSensFadType modelPar_PHIGSTI=mod.PHIGSTI;
  bool modelPar_given_PHIGSTI=mod.given("PHIGSTI");
  AdmsSensFadType modelPar_PHIGGAT=mod.PHIGGAT;
  bool modelPar_given_PHIGGAT=mod.given("PHIGGAT");
  AdmsSensFadType modelPar_IDSATRBOT=mod.IDSATRBOT;
  bool modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
  AdmsSensFadType modelPar_IDSATRSTI=mod.IDSATRSTI;
  bool modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
  AdmsSensFadType modelPar_IDSATRGAT=mod.IDSATRGAT;
  bool modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
  AdmsSensFadType modelPar_CSRHBOT=mod.CSRHBOT;
  bool modelPar_given_CSRHBOT=mod.given("CSRHBOT");
  AdmsSensFadType modelPar_CSRHSTI=mod.CSRHSTI;
  bool modelPar_given_CSRHSTI=mod.given("CSRHSTI");
  AdmsSensFadType modelPar_CSRHGAT=mod.CSRHGAT;
  bool modelPar_given_CSRHGAT=mod.given("CSRHGAT");
  AdmsSensFadType modelPar_XJUNSTI=mod.XJUNSTI;
  bool modelPar_given_XJUNSTI=mod.given("XJUNSTI");
  AdmsSensFadType modelPar_XJUNGAT=mod.XJUNGAT;
  bool modelPar_given_XJUNGAT=mod.given("XJUNGAT");
  AdmsSensFadType modelPar_CTATBOT=mod.CTATBOT;
  bool modelPar_given_CTATBOT=mod.given("CTATBOT");
  AdmsSensFadType modelPar_CTATSTI=mod.CTATSTI;
  bool modelPar_given_CTATSTI=mod.given("CTATSTI");
  AdmsSensFadType modelPar_CTATGAT=mod.CTATGAT;
  bool modelPar_given_CTATGAT=mod.given("CTATGAT");
  AdmsSensFadType modelPar_MEFFTATBOT=mod.MEFFTATBOT;
  bool modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
  AdmsSensFadType modelPar_MEFFTATSTI=mod.MEFFTATSTI;
  bool modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
  AdmsSensFadType modelPar_MEFFTATGAT=mod.MEFFTATGAT;
  bool modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
  AdmsSensFadType modelPar_CBBTBOT=mod.CBBTBOT;
  bool modelPar_given_CBBTBOT=mod.given("CBBTBOT");
  AdmsSensFadType modelPar_CBBTSTI=mod.CBBTSTI;
  bool modelPar_given_CBBTSTI=mod.given("CBBTSTI");
  AdmsSensFadType modelPar_CBBTGAT=mod.CBBTGAT;
  bool modelPar_given_CBBTGAT=mod.given("CBBTGAT");
  AdmsSensFadType modelPar_FBBTRBOT=mod.FBBTRBOT;
  bool modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
  AdmsSensFadType modelPar_FBBTRSTI=mod.FBBTRSTI;
  bool modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
  AdmsSensFadType modelPar_FBBTRGAT=mod.FBBTRGAT;
  bool modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
  AdmsSensFadType modelPar_STFBBTBOT=mod.STFBBTBOT;
  bool modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
  AdmsSensFadType modelPar_STFBBTSTI=mod.STFBBTSTI;
  bool modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
  AdmsSensFadType modelPar_STFBBTGAT=mod.STFBBTGAT;
  bool modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
  AdmsSensFadType modelPar_VBRBOT=mod.VBRBOT;
  bool modelPar_given_VBRBOT=mod.given("VBRBOT");
  AdmsSensFadType modelPar_VBRSTI=mod.VBRSTI;
  bool modelPar_given_VBRSTI=mod.given("VBRSTI");
  AdmsSensFadType modelPar_VBRGAT=mod.VBRGAT;
  bool modelPar_given_VBRGAT=mod.given("VBRGAT");
  AdmsSensFadType modelPar_PBRBOT=mod.PBRBOT;
  bool modelPar_given_PBRBOT=mod.given("PBRBOT");
  AdmsSensFadType modelPar_PBRSTI=mod.PBRSTI;
  bool modelPar_given_PBRSTI=mod.given("PBRSTI");
  AdmsSensFadType modelPar_PBRGAT=mod.PBRGAT;
  bool modelPar_given_PBRGAT=mod.given("PBRGAT");
  AdmsSensFadType modelPar_SWJUNEXP=mod.SWJUNEXP;
  bool modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
  AdmsSensFadType modelPar_VJUNREF=mod.VJUNREF;
  bool modelPar_given_VJUNREF=mod.given("VJUNREF");
  AdmsSensFadType modelPar_FJUNQ=mod.FJUNQ;
  bool modelPar_given_FJUNQ=mod.given("FJUNQ");


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");



  // Copy out all the instance parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> inParamMap;

  // reals
  AdmsSensFadType instancePar_AB=in.AB;
  bool instancePar_given_AB=in.given("AB");
  inParamMap["AB"] = &instancePar_AB;
  AdmsSensFadType instancePar_LS=in.LS;
  bool instancePar_given_LS=in.given("LS");
  inParamMap["LS"] = &instancePar_LS;
  AdmsSensFadType instancePar_LG=in.LG;
  bool instancePar_given_LG=in.given("LG");
  inParamMap["LG"] = &instancePar_LG;
  AdmsSensFadType instancePar_MULT=in.MULT;
  bool instancePar_given_MULT=in.given("MULT");
  inParamMap["MULT"] = &instancePar_MULT;


  // Copy all the real hidden instance params into fad types



  // Copy all the non-real instance params into vars of their appropriate type:


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check the name first, otherwise segfault on invalid name!
  inParamMap[name]->diff(0,1);

  //make local copies of all instance vars
  //reals
  AdmsSensFadType instanceVar_MULT_i=in.MULT_i;
  AdmsSensFadType instanceVar_AB_i=in.AB_i;
  AdmsSensFadType instanceVar_LS_i=in.LS_i;
  AdmsSensFadType instanceVar_LG_i=in.LG_i;
  AdmsSensFadType instanceVar_zflagbot=in.zflagbot;
  AdmsSensFadType instanceVar_zflagsti=in.zflagsti;
  AdmsSensFadType instanceVar_zflaggat=in.zflaggat;
  AdmsSensFadType instanceVar_VMAX=in.VMAX;
  AdmsSensFadType instanceVar_exp_VMAX_over_phitd=in.exp_VMAX_over_phitd;
  AdmsSensFadType instanceVar_vbimin=in.vbimin;
  AdmsSensFadType instanceVar_vch=in.vch;
  AdmsSensFadType instanceVar_vfmin=in.vfmin;
  AdmsSensFadType instanceVar_vbbtlim=in.vbbtlim;
  AdmsSensFadType instanceVar_xhighf1=in.xhighf1;
  AdmsSensFadType instanceVar_expxhf1=in.expxhf1;
  AdmsSensFadType instanceVar_xhighf2=in.xhighf2;
  AdmsSensFadType instanceVar_expxhf2=in.expxhf2;
  AdmsSensFadType instanceVar_xhighr=in.xhighr;
  AdmsSensFadType instanceVar_expxhr=in.expxhr;
  AdmsSensFadType instanceVar_ISATFOR1=in.ISATFOR1;
  AdmsSensFadType instanceVar_MFOR1=in.MFOR1;
  AdmsSensFadType instanceVar_ISATFOR2=in.ISATFOR2;
  AdmsSensFadType instanceVar_MFOR2=in.MFOR2;
  AdmsSensFadType instanceVar_ISATREV=in.ISATREV;
  AdmsSensFadType instanceVar_MREV=in.MREV;
  AdmsSensFadType instanceVar_m0flag=in.m0flag;


  //non-reals


  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_IMAX_i=mod.IMAX_i;
  AdmsSensFadType modelVar_VBIRBOT_i=mod.VBIRBOT_i;
  AdmsSensFadType modelVar_VBIRSTI_i=mod.VBIRSTI_i;
  AdmsSensFadType modelVar_VBIRGAT_i=mod.VBIRGAT_i;
  AdmsSensFadType modelVar_PBOT_i=mod.PBOT_i;
  AdmsSensFadType modelVar_PSTI_i=mod.PSTI_i;
  AdmsSensFadType modelVar_PGAT_i=mod.PGAT_i;
  AdmsSensFadType modelVar_CSRHBOT_i=mod.CSRHBOT_i;
  AdmsSensFadType modelVar_CSRHSTI_i=mod.CSRHSTI_i;
  AdmsSensFadType modelVar_CSRHGAT_i=mod.CSRHGAT_i;
  AdmsSensFadType modelVar_CTATBOT_i=mod.CTATBOT_i;
  AdmsSensFadType modelVar_CTATSTI_i=mod.CTATSTI_i;
  AdmsSensFadType modelVar_CTATGAT_i=mod.CTATGAT_i;
  AdmsSensFadType modelVar_CBBTBOT_i=mod.CBBTBOT_i;
  AdmsSensFadType modelVar_CBBTSTI_i=mod.CBBTSTI_i;
  AdmsSensFadType modelVar_CBBTGAT_i=mod.CBBTGAT_i;
  AdmsSensFadType modelVar_VBRBOT_i=mod.VBRBOT_i;
  AdmsSensFadType modelVar_VBRSTI_i=mod.VBRSTI_i;
  AdmsSensFadType modelVar_VBRGAT_i=mod.VBRGAT_i;
  AdmsSensFadType modelVar_PBRBOT_i=mod.PBRBOT_i;
  AdmsSensFadType modelVar_PBRSTI_i=mod.PBRSTI_i;
  AdmsSensFadType modelVar_PBRGAT_i=mod.PBRGAT_i;
  AdmsSensFadType modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
  AdmsSensFadType modelVar_VJUNREF_i=mod.VJUNREF_i;
  AdmsSensFadType modelVar_FJUNQ_i=mod.FJUNQ_i;
  AdmsSensFadType modelVar_phitr=mod.phitr;
  AdmsSensFadType modelVar_phitd=mod.phitd;
  AdmsSensFadType modelVar_phitdinv=mod.phitdinv;
  AdmsSensFadType modelVar_perfc=mod.perfc;
  AdmsSensFadType modelVar_berfc=mod.berfc;
  AdmsSensFadType modelVar_cerfc=mod.cerfc;
  AdmsSensFadType modelVar_ftdbot=mod.ftdbot;
  AdmsSensFadType modelVar_ftdsti=mod.ftdsti;
  AdmsSensFadType modelVar_ftdgat=mod.ftdgat;
  AdmsSensFadType modelVar_idsatbot=mod.idsatbot;
  AdmsSensFadType modelVar_idsatsti=mod.idsatsti;
  AdmsSensFadType modelVar_idsatgat=mod.idsatgat;
  AdmsSensFadType modelVar_vbibot=mod.vbibot;
  AdmsSensFadType modelVar_vbisti=mod.vbisti;
  AdmsSensFadType modelVar_vbigat=mod.vbigat;
  AdmsSensFadType modelVar_vbiinvbot=mod.vbiinvbot;
  AdmsSensFadType modelVar_vbiinvsti=mod.vbiinvsti;
  AdmsSensFadType modelVar_vbiinvgat=mod.vbiinvgat;
  AdmsSensFadType modelVar_one_minus_PBOT=mod.one_minus_PBOT;
  AdmsSensFadType modelVar_one_minus_PSTI=mod.one_minus_PSTI;
  AdmsSensFadType modelVar_one_minus_PGAT=mod.one_minus_PGAT;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
  AdmsSensFadType modelVar_cjobot=mod.cjobot;
  AdmsSensFadType modelVar_cjosti=mod.cjosti;
  AdmsSensFadType modelVar_cjogat=mod.cjogat;
  AdmsSensFadType modelVar_qprefbot=mod.qprefbot;
  AdmsSensFadType modelVar_qprefsti=mod.qprefsti;
  AdmsSensFadType modelVar_qprefgat=mod.qprefgat;
  AdmsSensFadType modelVar_qpref2bot=mod.qpref2bot;
  AdmsSensFadType modelVar_qpref2sti=mod.qpref2sti;
  AdmsSensFadType modelVar_qpref2gat=mod.qpref2gat;
  AdmsSensFadType modelVar_wdepnulrbot=mod.wdepnulrbot;
  AdmsSensFadType modelVar_wdepnulrsti=mod.wdepnulrsti;
  AdmsSensFadType modelVar_wdepnulrgat=mod.wdepnulrgat;
  AdmsSensFadType modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
  AdmsSensFadType modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
  AdmsSensFadType modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
  AdmsSensFadType modelVar_VBIRBOTinv=mod.VBIRBOTinv;
  AdmsSensFadType modelVar_VBIRSTIinv=mod.VBIRSTIinv;
  AdmsSensFadType modelVar_VBIRGATinv=mod.VBIRGATinv;
  AdmsSensFadType modelVar_atatbot=mod.atatbot;
  AdmsSensFadType modelVar_atatsti=mod.atatsti;
  AdmsSensFadType modelVar_atatgat=mod.atatgat;
  AdmsSensFadType modelVar_btatpartbot=mod.btatpartbot;
  AdmsSensFadType modelVar_btatpartsti=mod.btatpartsti;
  AdmsSensFadType modelVar_btatpartgat=mod.btatpartgat;
  AdmsSensFadType modelVar_fbbtbot=mod.fbbtbot;
  AdmsSensFadType modelVar_fbbtsti=mod.fbbtsti;
  AdmsSensFadType modelVar_fbbtgat=mod.fbbtgat;
  AdmsSensFadType modelVar_alphaav=mod.alphaav;
  AdmsSensFadType modelVar_fstopbot=mod.fstopbot;
  AdmsSensFadType modelVar_fstopsti=mod.fstopsti;
  AdmsSensFadType modelVar_fstopgat=mod.fstopgat;
  AdmsSensFadType modelVar_VBRinvbot=mod.VBRinvbot;
  AdmsSensFadType modelVar_VBRinvsti=mod.VBRinvsti;
  AdmsSensFadType modelVar_VBRinvgat=mod.VBRinvgat;
  AdmsSensFadType modelVar_slopebot=mod.slopebot;
  AdmsSensFadType modelVar_slopesti=mod.slopesti;
  AdmsSensFadType modelVar_slopegat=mod.slopegat;


  // non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables and set as Fad independent variables.
  probeVars[in.admsProbeID_V_A_K] = (*solVectorPtr)[in.li_A]- (*solVectorPtr)[in.li_K];



  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
  evaluateInitialModel(
     // model parameters
     // reals
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_FREV,
     modelPar_given_FREV,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE// model variables
     ,
     // reals
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_alphaav,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     mod.admsModTemp,in.getDeviceOptions().gmin,in);
  evaluateInitialInstance(
     // instance parameters
     // reals
     instancePar_AB,
     instancePar_given_AB,
     instancePar_LS,
     instancePar_given_LS,
     instancePar_LG,
     instancePar_given_LG,
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_MULT_i,
     instanceVar_AB_i,
     instanceVar_LS_i,
     instanceVar_LG_i,
     instanceVar_zflagbot,
     instanceVar_zflagsti,
     instanceVar_zflaggat,
     instanceVar_VMAX,
     instanceVar_exp_VMAX_over_phitd,
     instanceVar_vbimin,
     instanceVar_vch,
     instanceVar_vfmin,
     instanceVar_vbbtlim,
     instanceVar_xhighf1,
     instanceVar_expxhf1,
     instanceVar_xhighf2,
     instanceVar_expxhf2,
     instanceVar_xhighr,
     instanceVar_expxhr,
     instanceVar_ISATFOR1,
     instanceVar_MFOR1,
     instanceVar_ISATFOR2,
     instanceVar_MFOR2,
     instanceVar_ISATREV,
     instanceVar_MREV,
     instanceVar_m0flag,
     // model parameters
     // reals
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_FREV,
     modelPar_given_FREV,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE// model variables
     ,
     // reals
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_alphaav,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


  // Now call  the function that does the heavy lifting.
  evaluateModelEquations(
     probeVars,
     // probe constants
     in.admsProbeID_V_A_K,

     // node constants
     in.admsNodeID_A,
     in.admsNodeID_K,
     // instance parameters
     // reals
     instancePar_AB,
     instancePar_given_AB,
     instancePar_LS,
     instancePar_given_LS,
     instancePar_LG,
     instancePar_given_LG,
     instancePar_MULT,
     instancePar_given_MULT,
     // instance variables
     // reals
     instanceVar_MULT_i,
     instanceVar_AB_i,
     instanceVar_LS_i,
     instanceVar_LG_i,
     instanceVar_zflagbot,
     instanceVar_zflagsti,
     instanceVar_zflaggat,
     instanceVar_VMAX,
     instanceVar_exp_VMAX_over_phitd,
     instanceVar_vbimin,
     instanceVar_vch,
     instanceVar_vfmin,
     instanceVar_vbbtlim,
     instanceVar_xhighf1,
     instanceVar_expxhf1,
     instanceVar_xhighf2,
     instanceVar_expxhf2,
     instanceVar_xhighr,
     instanceVar_expxhr,
     instanceVar_ISATFOR1,
     instanceVar_MFOR1,
     instanceVar_ISATFOR2,
     instanceVar_MFOR2,
     instanceVar_ISATREV,
     instanceVar_MREV,
     instanceVar_m0flag,
     // model parameters
     // reals
     modelPar_DTA,
     modelPar_given_DTA,
     modelPar_IMAX,
     modelPar_given_IMAX,
     modelPar_TRJ,
     modelPar_given_TRJ,
     modelPar_FREV,
     modelPar_given_FREV,
     modelPar_CJORBOT,
     modelPar_given_CJORBOT,
     modelPar_CJORSTI,
     modelPar_given_CJORSTI,
     modelPar_CJORGAT,
     modelPar_given_CJORGAT,
     modelPar_VBIRBOT,
     modelPar_given_VBIRBOT,
     modelPar_VBIRSTI,
     modelPar_given_VBIRSTI,
     modelPar_VBIRGAT,
     modelPar_given_VBIRGAT,
     modelPar_PBOT,
     modelPar_given_PBOT,
     modelPar_PSTI,
     modelPar_given_PSTI,
     modelPar_PGAT,
     modelPar_given_PGAT,
     modelPar_PHIGBOT,
     modelPar_given_PHIGBOT,
     modelPar_PHIGSTI,
     modelPar_given_PHIGSTI,
     modelPar_PHIGGAT,
     modelPar_given_PHIGGAT,
     modelPar_IDSATRBOT,
     modelPar_given_IDSATRBOT,
     modelPar_IDSATRSTI,
     modelPar_given_IDSATRSTI,
     modelPar_IDSATRGAT,
     modelPar_given_IDSATRGAT,
     modelPar_CSRHBOT,
     modelPar_given_CSRHBOT,
     modelPar_CSRHSTI,
     modelPar_given_CSRHSTI,
     modelPar_CSRHGAT,
     modelPar_given_CSRHGAT,
     modelPar_XJUNSTI,
     modelPar_given_XJUNSTI,
     modelPar_XJUNGAT,
     modelPar_given_XJUNGAT,
     modelPar_CTATBOT,
     modelPar_given_CTATBOT,
     modelPar_CTATSTI,
     modelPar_given_CTATSTI,
     modelPar_CTATGAT,
     modelPar_given_CTATGAT,
     modelPar_MEFFTATBOT,
     modelPar_given_MEFFTATBOT,
     modelPar_MEFFTATSTI,
     modelPar_given_MEFFTATSTI,
     modelPar_MEFFTATGAT,
     modelPar_given_MEFFTATGAT,
     modelPar_CBBTBOT,
     modelPar_given_CBBTBOT,
     modelPar_CBBTSTI,
     modelPar_given_CBBTSTI,
     modelPar_CBBTGAT,
     modelPar_given_CBBTGAT,
     modelPar_FBBTRBOT,
     modelPar_given_FBBTRBOT,
     modelPar_FBBTRSTI,
     modelPar_given_FBBTRSTI,
     modelPar_FBBTRGAT,
     modelPar_given_FBBTRGAT,
     modelPar_STFBBTBOT,
     modelPar_given_STFBBTBOT,
     modelPar_STFBBTSTI,
     modelPar_given_STFBBTSTI,
     modelPar_STFBBTGAT,
     modelPar_given_STFBBTGAT,
     modelPar_VBRBOT,
     modelPar_given_VBRBOT,
     modelPar_VBRSTI,
     modelPar_given_VBRSTI,
     modelPar_VBRGAT,
     modelPar_given_VBRGAT,
     modelPar_PBRBOT,
     modelPar_given_PBRBOT,
     modelPar_PBRSTI,
     modelPar_given_PBRSTI,
     modelPar_PBRGAT,
     modelPar_given_PBRGAT,
     modelPar_SWJUNEXP,
     modelPar_given_SWJUNEXP,
     modelPar_VJUNREF,
     modelPar_given_VJUNREF,
     modelPar_FJUNQ,
     modelPar_given_FJUNQ,
     // non-reals (including hidden)
     modelPar_LEVEL,
     modelPar_given_LEVEL,
     modelPar_TYPE,
     modelPar_given_TYPE// model variables
     ,
     // reals
     modelVar_IMAX_i,
     modelVar_VBIRBOT_i,
     modelVar_VBIRSTI_i,
     modelVar_VBIRGAT_i,
     modelVar_PBOT_i,
     modelVar_PSTI_i,
     modelVar_PGAT_i,
     modelVar_CSRHBOT_i,
     modelVar_CSRHSTI_i,
     modelVar_CSRHGAT_i,
     modelVar_CTATBOT_i,
     modelVar_CTATSTI_i,
     modelVar_CTATGAT_i,
     modelVar_CBBTBOT_i,
     modelVar_CBBTSTI_i,
     modelVar_CBBTGAT_i,
     modelVar_VBRBOT_i,
     modelVar_VBRSTI_i,
     modelVar_VBRGAT_i,
     modelVar_PBRBOT_i,
     modelVar_PBRSTI_i,
     modelVar_PBRGAT_i,
     modelVar_SWJUNEXP_i,
     modelVar_VJUNREF_i,
     modelVar_FJUNQ_i,
     modelVar_phitr,
     modelVar_phitd,
     modelVar_phitdinv,
     modelVar_perfc,
     modelVar_berfc,
     modelVar_cerfc,
     modelVar_ftdbot,
     modelVar_ftdsti,
     modelVar_ftdgat,
     modelVar_idsatbot,
     modelVar_idsatsti,
     modelVar_idsatgat,
     modelVar_vbibot,
     modelVar_vbisti,
     modelVar_vbigat,
     modelVar_vbiinvbot,
     modelVar_vbiinvsti,
     modelVar_vbiinvgat,
     modelVar_one_minus_PBOT,
     modelVar_one_minus_PSTI,
     modelVar_one_minus_PGAT,
     modelVar_one_over_one_minus_PBOT,
     modelVar_one_over_one_minus_PSTI,
     modelVar_one_over_one_minus_PGAT,
     modelVar_cjobot,
     modelVar_cjosti,
     modelVar_cjogat,
     modelVar_qprefbot,
     modelVar_qprefsti,
     modelVar_qprefgat,
     modelVar_qpref2bot,
     modelVar_qpref2sti,
     modelVar_qpref2gat,
     modelVar_wdepnulrbot,
     modelVar_wdepnulrsti,
     modelVar_wdepnulrgat,
     modelVar_wdepnulrinvbot,
     modelVar_wdepnulrinvsti,
     modelVar_wdepnulrinvgat,
     modelVar_VBIRBOTinv,
     modelVar_VBIRSTIinv,
     modelVar_VBIRGATinv,
     modelVar_atatbot,
     modelVar_atatsti,
     modelVar_atatgat,
     modelVar_btatpartbot,
     modelVar_btatpartsti,
     modelVar_btatpartgat,
     modelVar_fbbtbot,
     modelVar_fbbtsti,
     modelVar_fbbtgat,
     modelVar_alphaav,
     modelVar_fstopbot,
     modelVar_fstopsti,
     modelVar_fstopgat,
     modelVar_VBRinvbot,
     modelVar_VBRinvsti,
     modelVar_VBRinvgat,
     modelVar_slopebot,
     modelVar_slopesti,
     modelVar_slopegat,
     in.admsTemperature,
     in.adms_vt_nom,
     in.getDeviceOptions().gmin,
     staticContributions,
     dynamicContributions,
     in);


  // We now have the F and Q vector stuff, populate the dependencies:

  dfdp[in.admsNodeID_A] += staticContributions[in.admsNodeID_A].dx(0);
  dqdp[in.admsNodeID_A] += dynamicContributions[in.admsNodeID_A].dx(0);
  Findices[in.admsNodeID_A] = in.li_A;
  Qindices[in.admsNodeID_A] = in.li_A;
  dfdp[in.admsNodeID_K] += staticContributions[in.admsNodeID_K].dx(0);
  dqdp[in.admsNodeID_K] += dynamicContributions[in.admsNodeID_K].dx(0);
  Findices[in.admsNodeID_K] = in.li_K;
  Qindices[in.admsNodeID_K] = in.li_K;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date : 
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
/// 
/// 
/// @param[in] entity  The device entity that owns the parameter 
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
/// 
/// 
void ModelSensitivity::operator()
  (
     const ParameterBase &entity,
     const std::string &name,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
   ) const
{
  const ParameterBase * e1 = &entity;
  const Model & mod = *(dynamic_cast<const Model *> (e1));
  int sizeInstance = mod.instanceContainer.size();

  dfdp.resize((2+0)*sizeInstance);
  dqdp.resize((2+0)*sizeInstance);
  Findices.resize((2+0)*sizeInstance);
  Qindices.resize((2+0)*sizeInstance);

  std::vector <double> probeVars(1);
  std::vector <AdmsSensFadType> staticContributions(2+0);
  std::vector <AdmsSensFadType> dynamicContributions(2+0);


  // Copy out all the model parameters (doubles) into FAD types
  // Keep a map so we can set the right one to the independent variable
  // We do this solely to avoid a big ugly "if/else" block just to find the
  // one parameter we're doing sensitivities on.
  unordered_map <std::string,AdmsSensFadType*,HashNoCase,EqualNoCase> modParamMap;

  // reals
  AdmsSensFadType modelPar_DTA=mod.DTA;
  bool modelPar_given_DTA=mod.given("DTA");
  modParamMap["DTA"] = &modelPar_DTA;
  AdmsSensFadType modelPar_IMAX=mod.IMAX;
  bool modelPar_given_IMAX=mod.given("IMAX");
  modParamMap["IMAX"] = &modelPar_IMAX;
  AdmsSensFadType modelPar_TRJ=mod.TRJ;
  bool modelPar_given_TRJ=mod.given("TRJ");
  modParamMap["TRJ"] = &modelPar_TRJ;
  AdmsSensFadType modelPar_FREV=mod.FREV;
  bool modelPar_given_FREV=mod.given("FREV");
  modParamMap["FREV"] = &modelPar_FREV;
  AdmsSensFadType modelPar_CJORBOT=mod.CJORBOT;
  bool modelPar_given_CJORBOT=mod.given("CJORBOT");
  modParamMap["CJORBOT"] = &modelPar_CJORBOT;
  AdmsSensFadType modelPar_CJORSTI=mod.CJORSTI;
  bool modelPar_given_CJORSTI=mod.given("CJORSTI");
  modParamMap["CJORSTI"] = &modelPar_CJORSTI;
  AdmsSensFadType modelPar_CJORGAT=mod.CJORGAT;
  bool modelPar_given_CJORGAT=mod.given("CJORGAT");
  modParamMap["CJORGAT"] = &modelPar_CJORGAT;
  AdmsSensFadType modelPar_VBIRBOT=mod.VBIRBOT;
  bool modelPar_given_VBIRBOT=mod.given("VBIRBOT");
  modParamMap["VBIRBOT"] = &modelPar_VBIRBOT;
  AdmsSensFadType modelPar_VBIRSTI=mod.VBIRSTI;
  bool modelPar_given_VBIRSTI=mod.given("VBIRSTI");
  modParamMap["VBIRSTI"] = &modelPar_VBIRSTI;
  AdmsSensFadType modelPar_VBIRGAT=mod.VBIRGAT;
  bool modelPar_given_VBIRGAT=mod.given("VBIRGAT");
  modParamMap["VBIRGAT"] = &modelPar_VBIRGAT;
  AdmsSensFadType modelPar_PBOT=mod.PBOT;
  bool modelPar_given_PBOT=mod.given("PBOT");
  modParamMap["PBOT"] = &modelPar_PBOT;
  AdmsSensFadType modelPar_PSTI=mod.PSTI;
  bool modelPar_given_PSTI=mod.given("PSTI");
  modParamMap["PSTI"] = &modelPar_PSTI;
  AdmsSensFadType modelPar_PGAT=mod.PGAT;
  bool modelPar_given_PGAT=mod.given("PGAT");
  modParamMap["PGAT"] = &modelPar_PGAT;
  AdmsSensFadType modelPar_PHIGBOT=mod.PHIGBOT;
  bool modelPar_given_PHIGBOT=mod.given("PHIGBOT");
  modParamMap["PHIGBOT"] = &modelPar_PHIGBOT;
  AdmsSensFadType modelPar_PHIGSTI=mod.PHIGSTI;
  bool modelPar_given_PHIGSTI=mod.given("PHIGSTI");
  modParamMap["PHIGSTI"] = &modelPar_PHIGSTI;
  AdmsSensFadType modelPar_PHIGGAT=mod.PHIGGAT;
  bool modelPar_given_PHIGGAT=mod.given("PHIGGAT");
  modParamMap["PHIGGAT"] = &modelPar_PHIGGAT;
  AdmsSensFadType modelPar_IDSATRBOT=mod.IDSATRBOT;
  bool modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
  modParamMap["IDSATRBOT"] = &modelPar_IDSATRBOT;
  AdmsSensFadType modelPar_IDSATRSTI=mod.IDSATRSTI;
  bool modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
  modParamMap["IDSATRSTI"] = &modelPar_IDSATRSTI;
  AdmsSensFadType modelPar_IDSATRGAT=mod.IDSATRGAT;
  bool modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
  modParamMap["IDSATRGAT"] = &modelPar_IDSATRGAT;
  AdmsSensFadType modelPar_CSRHBOT=mod.CSRHBOT;
  bool modelPar_given_CSRHBOT=mod.given("CSRHBOT");
  modParamMap["CSRHBOT"] = &modelPar_CSRHBOT;
  AdmsSensFadType modelPar_CSRHSTI=mod.CSRHSTI;
  bool modelPar_given_CSRHSTI=mod.given("CSRHSTI");
  modParamMap["CSRHSTI"] = &modelPar_CSRHSTI;
  AdmsSensFadType modelPar_CSRHGAT=mod.CSRHGAT;
  bool modelPar_given_CSRHGAT=mod.given("CSRHGAT");
  modParamMap["CSRHGAT"] = &modelPar_CSRHGAT;
  AdmsSensFadType modelPar_XJUNSTI=mod.XJUNSTI;
  bool modelPar_given_XJUNSTI=mod.given("XJUNSTI");
  modParamMap["XJUNSTI"] = &modelPar_XJUNSTI;
  AdmsSensFadType modelPar_XJUNGAT=mod.XJUNGAT;
  bool modelPar_given_XJUNGAT=mod.given("XJUNGAT");
  modParamMap["XJUNGAT"] = &modelPar_XJUNGAT;
  AdmsSensFadType modelPar_CTATBOT=mod.CTATBOT;
  bool modelPar_given_CTATBOT=mod.given("CTATBOT");
  modParamMap["CTATBOT"] = &modelPar_CTATBOT;
  AdmsSensFadType modelPar_CTATSTI=mod.CTATSTI;
  bool modelPar_given_CTATSTI=mod.given("CTATSTI");
  modParamMap["CTATSTI"] = &modelPar_CTATSTI;
  AdmsSensFadType modelPar_CTATGAT=mod.CTATGAT;
  bool modelPar_given_CTATGAT=mod.given("CTATGAT");
  modParamMap["CTATGAT"] = &modelPar_CTATGAT;
  AdmsSensFadType modelPar_MEFFTATBOT=mod.MEFFTATBOT;
  bool modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
  modParamMap["MEFFTATBOT"] = &modelPar_MEFFTATBOT;
  AdmsSensFadType modelPar_MEFFTATSTI=mod.MEFFTATSTI;
  bool modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
  modParamMap["MEFFTATSTI"] = &modelPar_MEFFTATSTI;
  AdmsSensFadType modelPar_MEFFTATGAT=mod.MEFFTATGAT;
  bool modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
  modParamMap["MEFFTATGAT"] = &modelPar_MEFFTATGAT;
  AdmsSensFadType modelPar_CBBTBOT=mod.CBBTBOT;
  bool modelPar_given_CBBTBOT=mod.given("CBBTBOT");
  modParamMap["CBBTBOT"] = &modelPar_CBBTBOT;
  AdmsSensFadType modelPar_CBBTSTI=mod.CBBTSTI;
  bool modelPar_given_CBBTSTI=mod.given("CBBTSTI");
  modParamMap["CBBTSTI"] = &modelPar_CBBTSTI;
  AdmsSensFadType modelPar_CBBTGAT=mod.CBBTGAT;
  bool modelPar_given_CBBTGAT=mod.given("CBBTGAT");
  modParamMap["CBBTGAT"] = &modelPar_CBBTGAT;
  AdmsSensFadType modelPar_FBBTRBOT=mod.FBBTRBOT;
  bool modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
  modParamMap["FBBTRBOT"] = &modelPar_FBBTRBOT;
  AdmsSensFadType modelPar_FBBTRSTI=mod.FBBTRSTI;
  bool modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
  modParamMap["FBBTRSTI"] = &modelPar_FBBTRSTI;
  AdmsSensFadType modelPar_FBBTRGAT=mod.FBBTRGAT;
  bool modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
  modParamMap["FBBTRGAT"] = &modelPar_FBBTRGAT;
  AdmsSensFadType modelPar_STFBBTBOT=mod.STFBBTBOT;
  bool modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
  modParamMap["STFBBTBOT"] = &modelPar_STFBBTBOT;
  AdmsSensFadType modelPar_STFBBTSTI=mod.STFBBTSTI;
  bool modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
  modParamMap["STFBBTSTI"] = &modelPar_STFBBTSTI;
  AdmsSensFadType modelPar_STFBBTGAT=mod.STFBBTGAT;
  bool modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
  modParamMap["STFBBTGAT"] = &modelPar_STFBBTGAT;
  AdmsSensFadType modelPar_VBRBOT=mod.VBRBOT;
  bool modelPar_given_VBRBOT=mod.given("VBRBOT");
  modParamMap["VBRBOT"] = &modelPar_VBRBOT;
  AdmsSensFadType modelPar_VBRSTI=mod.VBRSTI;
  bool modelPar_given_VBRSTI=mod.given("VBRSTI");
  modParamMap["VBRSTI"] = &modelPar_VBRSTI;
  AdmsSensFadType modelPar_VBRGAT=mod.VBRGAT;
  bool modelPar_given_VBRGAT=mod.given("VBRGAT");
  modParamMap["VBRGAT"] = &modelPar_VBRGAT;
  AdmsSensFadType modelPar_PBRBOT=mod.PBRBOT;
  bool modelPar_given_PBRBOT=mod.given("PBRBOT");
  modParamMap["PBRBOT"] = &modelPar_PBRBOT;
  AdmsSensFadType modelPar_PBRSTI=mod.PBRSTI;
  bool modelPar_given_PBRSTI=mod.given("PBRSTI");
  modParamMap["PBRSTI"] = &modelPar_PBRSTI;
  AdmsSensFadType modelPar_PBRGAT=mod.PBRGAT;
  bool modelPar_given_PBRGAT=mod.given("PBRGAT");
  modParamMap["PBRGAT"] = &modelPar_PBRGAT;
  AdmsSensFadType modelPar_SWJUNEXP=mod.SWJUNEXP;
  bool modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
  modParamMap["SWJUNEXP"] = &modelPar_SWJUNEXP;
  AdmsSensFadType modelPar_VJUNREF=mod.VJUNREF;
  bool modelPar_given_VJUNREF=mod.given("VJUNREF");
  modParamMap["VJUNREF"] = &modelPar_VJUNREF;
  AdmsSensFadType modelPar_FJUNQ=mod.FJUNQ;
  bool modelPar_given_FJUNQ=mod.given("FJUNQ");
  modParamMap["FJUNQ"] = &modelPar_FJUNQ;


  // hidden reals


  // non-reals (including hiddens)
  int modelPar_LEVEL=mod.LEVEL;
  bool modelPar_given_LEVEL=mod.given("LEVEL");
  int modelPar_TYPE=mod.TYPE;
  bool modelPar_given_TYPE=mod.given("TYPE");


  // Set the one parameter whose name was passed in to be the independent
  // variable for Sacado purposes.  Since we stored variable pointers, this
  // makes sure that that ONE variable gets set right.
  // FIXME: make this check name for presence first!  Segfault on invalid.
  modParamMap[name]->diff(0,1);

  //make local copies of all model vars
  //reals
  AdmsSensFadType modelVar_IMAX_i=mod.IMAX_i;
  AdmsSensFadType modelVar_VBIRBOT_i=mod.VBIRBOT_i;
  AdmsSensFadType modelVar_VBIRSTI_i=mod.VBIRSTI_i;
  AdmsSensFadType modelVar_VBIRGAT_i=mod.VBIRGAT_i;
  AdmsSensFadType modelVar_PBOT_i=mod.PBOT_i;
  AdmsSensFadType modelVar_PSTI_i=mod.PSTI_i;
  AdmsSensFadType modelVar_PGAT_i=mod.PGAT_i;
  AdmsSensFadType modelVar_CSRHBOT_i=mod.CSRHBOT_i;
  AdmsSensFadType modelVar_CSRHSTI_i=mod.CSRHSTI_i;
  AdmsSensFadType modelVar_CSRHGAT_i=mod.CSRHGAT_i;
  AdmsSensFadType modelVar_CTATBOT_i=mod.CTATBOT_i;
  AdmsSensFadType modelVar_CTATSTI_i=mod.CTATSTI_i;
  AdmsSensFadType modelVar_CTATGAT_i=mod.CTATGAT_i;
  AdmsSensFadType modelVar_CBBTBOT_i=mod.CBBTBOT_i;
  AdmsSensFadType modelVar_CBBTSTI_i=mod.CBBTSTI_i;
  AdmsSensFadType modelVar_CBBTGAT_i=mod.CBBTGAT_i;
  AdmsSensFadType modelVar_VBRBOT_i=mod.VBRBOT_i;
  AdmsSensFadType modelVar_VBRSTI_i=mod.VBRSTI_i;
  AdmsSensFadType modelVar_VBRGAT_i=mod.VBRGAT_i;
  AdmsSensFadType modelVar_PBRBOT_i=mod.PBRBOT_i;
  AdmsSensFadType modelVar_PBRSTI_i=mod.PBRSTI_i;
  AdmsSensFadType modelVar_PBRGAT_i=mod.PBRGAT_i;
  AdmsSensFadType modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
  AdmsSensFadType modelVar_VJUNREF_i=mod.VJUNREF_i;
  AdmsSensFadType modelVar_FJUNQ_i=mod.FJUNQ_i;
  AdmsSensFadType modelVar_phitr=mod.phitr;
  AdmsSensFadType modelVar_phitd=mod.phitd;
  AdmsSensFadType modelVar_phitdinv=mod.phitdinv;
  AdmsSensFadType modelVar_perfc=mod.perfc;
  AdmsSensFadType modelVar_berfc=mod.berfc;
  AdmsSensFadType modelVar_cerfc=mod.cerfc;
  AdmsSensFadType modelVar_ftdbot=mod.ftdbot;
  AdmsSensFadType modelVar_ftdsti=mod.ftdsti;
  AdmsSensFadType modelVar_ftdgat=mod.ftdgat;
  AdmsSensFadType modelVar_idsatbot=mod.idsatbot;
  AdmsSensFadType modelVar_idsatsti=mod.idsatsti;
  AdmsSensFadType modelVar_idsatgat=mod.idsatgat;
  AdmsSensFadType modelVar_vbibot=mod.vbibot;
  AdmsSensFadType modelVar_vbisti=mod.vbisti;
  AdmsSensFadType modelVar_vbigat=mod.vbigat;
  AdmsSensFadType modelVar_vbiinvbot=mod.vbiinvbot;
  AdmsSensFadType modelVar_vbiinvsti=mod.vbiinvsti;
  AdmsSensFadType modelVar_vbiinvgat=mod.vbiinvgat;
  AdmsSensFadType modelVar_one_minus_PBOT=mod.one_minus_PBOT;
  AdmsSensFadType modelVar_one_minus_PSTI=mod.one_minus_PSTI;
  AdmsSensFadType modelVar_one_minus_PGAT=mod.one_minus_PGAT;
  AdmsSensFadType modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
  AdmsSensFadType modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
  AdmsSensFadType modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
  AdmsSensFadType modelVar_cjobot=mod.cjobot;
  AdmsSensFadType modelVar_cjosti=mod.cjosti;
  AdmsSensFadType modelVar_cjogat=mod.cjogat;
  AdmsSensFadType modelVar_qprefbot=mod.qprefbot;
  AdmsSensFadType modelVar_qprefsti=mod.qprefsti;
  AdmsSensFadType modelVar_qprefgat=mod.qprefgat;
  AdmsSensFadType modelVar_qpref2bot=mod.qpref2bot;
  AdmsSensFadType modelVar_qpref2sti=mod.qpref2sti;
  AdmsSensFadType modelVar_qpref2gat=mod.qpref2gat;
  AdmsSensFadType modelVar_wdepnulrbot=mod.wdepnulrbot;
  AdmsSensFadType modelVar_wdepnulrsti=mod.wdepnulrsti;
  AdmsSensFadType modelVar_wdepnulrgat=mod.wdepnulrgat;
  AdmsSensFadType modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
  AdmsSensFadType modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
  AdmsSensFadType modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
  AdmsSensFadType modelVar_VBIRBOTinv=mod.VBIRBOTinv;
  AdmsSensFadType modelVar_VBIRSTIinv=mod.VBIRSTIinv;
  AdmsSensFadType modelVar_VBIRGATinv=mod.VBIRGATinv;
  AdmsSensFadType modelVar_atatbot=mod.atatbot;
  AdmsSensFadType modelVar_atatsti=mod.atatsti;
  AdmsSensFadType modelVar_atatgat=mod.atatgat;
  AdmsSensFadType modelVar_btatpartbot=mod.btatpartbot;
  AdmsSensFadType modelVar_btatpartsti=mod.btatpartsti;
  AdmsSensFadType modelVar_btatpartgat=mod.btatpartgat;
  AdmsSensFadType modelVar_fbbtbot=mod.fbbtbot;
  AdmsSensFadType modelVar_fbbtsti=mod.fbbtsti;
  AdmsSensFadType modelVar_fbbtgat=mod.fbbtgat;
  AdmsSensFadType modelVar_alphaav=mod.alphaav;
  AdmsSensFadType modelVar_fstopbot=mod.fstopbot;
  AdmsSensFadType modelVar_fstopsti=mod.fstopsti;
  AdmsSensFadType modelVar_fstopgat=mod.fstopgat;
  AdmsSensFadType modelVar_VBRinvbot=mod.VBRinvbot;
  AdmsSensFadType modelVar_VBRinvsti=mod.VBRinvsti;
  AdmsSensFadType modelVar_VBRinvgat=mod.VBRinvgat;
  AdmsSensFadType modelVar_slopebot=mod.slopebot;
  AdmsSensFadType modelVar_slopesti=mod.slopesti;
  AdmsSensFadType modelVar_slopegat=mod.slopegat;


  // non-reals



  // Now loop over all instances and do the deed
  int inst=0;
  for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
  {

    Instance & in=*(*in_it);
    // initialize contributions to zero (automatically sets derivatives to zero)
    for (int i=0; i < 2+0 ; ++i)
    {
      staticContributions[i]=0;
      dynamicContributions[i]=0;
    }



    // Copy out all the instance parameters (doubles) into FAD types
    // reals
    AdmsSensFadType instancePar_AB=in.AB;
    bool instancePar_given_AB=in.given("AB");
    AdmsSensFadType instancePar_LS=in.LS;
    bool instancePar_given_LS=in.given("LS");
    AdmsSensFadType instancePar_LG=in.LG;
    bool instancePar_given_LG=in.given("LG");
    AdmsSensFadType instancePar_MULT=in.MULT;
    bool instancePar_given_MULT=in.given("MULT");


    // real hidden instance


    // Copy all the non-real instance params into vars of their appropriate type:




    // If there are any instance parameters that were not given, and have
    // corresponding model params, copy the model param into the instance.
    // This was already done by the instance constructor, but we do it again
    // because now we're propagating derivatives, and the user could be trying
    // to get sensitivity to the model parameter.
  

    //make local copies of all instance vars
    //reals
    AdmsSensFadType instanceVar_MULT_i=in.MULT_i;
    AdmsSensFadType instanceVar_AB_i=in.AB_i;
    AdmsSensFadType instanceVar_LS_i=in.LS_i;
    AdmsSensFadType instanceVar_LG_i=in.LG_i;
    AdmsSensFadType instanceVar_zflagbot=in.zflagbot;
    AdmsSensFadType instanceVar_zflagsti=in.zflagsti;
    AdmsSensFadType instanceVar_zflaggat=in.zflaggat;
    AdmsSensFadType instanceVar_VMAX=in.VMAX;
    AdmsSensFadType instanceVar_exp_VMAX_over_phitd=in.exp_VMAX_over_phitd;
    AdmsSensFadType instanceVar_vbimin=in.vbimin;
    AdmsSensFadType instanceVar_vch=in.vch;
    AdmsSensFadType instanceVar_vfmin=in.vfmin;
    AdmsSensFadType instanceVar_vbbtlim=in.vbbtlim;
    AdmsSensFadType instanceVar_xhighf1=in.xhighf1;
    AdmsSensFadType instanceVar_expxhf1=in.expxhf1;
    AdmsSensFadType instanceVar_xhighf2=in.xhighf2;
    AdmsSensFadType instanceVar_expxhf2=in.expxhf2;
    AdmsSensFadType instanceVar_xhighr=in.xhighr;
    AdmsSensFadType instanceVar_expxhr=in.expxhr;
    AdmsSensFadType instanceVar_ISATFOR1=in.ISATFOR1;
    AdmsSensFadType instanceVar_MFOR1=in.MFOR1;
    AdmsSensFadType instanceVar_ISATFOR2=in.ISATFOR2;
    AdmsSensFadType instanceVar_MFOR2=in.MFOR2;
    AdmsSensFadType instanceVar_ISATREV=in.ISATREV;
    AdmsSensFadType instanceVar_MREV=in.MREV;
    AdmsSensFadType instanceVar_m0flag=in.m0flag;

  
    //non-reals
  
  
  
    Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

    // extract solution variables and set as Fad independent variables.
    probeVars[in.admsProbeID_V_A_K] = (*solVectorPtr)[in.li_A] - (*solVectorPtr)[in.li_K];



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
    evaluateInitialModel(
       // model parameters
       // reals
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_FREV,
       modelPar_given_FREV,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE// model variables
       ,
       // reals
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_alphaav,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       mod.admsModTemp,in.getDeviceOptions().gmin,in);
    evaluateInitialInstance(
       // instance parameters
       // reals
       instancePar_AB,
       instancePar_given_AB,
       instancePar_LS,
       instancePar_given_LS,
       instancePar_LG,
       instancePar_given_LG,
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_MULT_i,
       instanceVar_AB_i,
       instanceVar_LS_i,
       instanceVar_LG_i,
       instanceVar_zflagbot,
       instanceVar_zflagsti,
       instanceVar_zflaggat,
       instanceVar_VMAX,
       instanceVar_exp_VMAX_over_phitd,
       instanceVar_vbimin,
       instanceVar_vch,
       instanceVar_vfmin,
       instanceVar_vbbtlim,
       instanceVar_xhighf1,
       instanceVar_expxhf1,
       instanceVar_xhighf2,
       instanceVar_expxhf2,
       instanceVar_xhighr,
       instanceVar_expxhr,
       instanceVar_ISATFOR1,
       instanceVar_MFOR1,
       instanceVar_ISATFOR2,
       instanceVar_MFOR2,
       instanceVar_ISATREV,
       instanceVar_MREV,
       instanceVar_m0flag,
       // model parameters
       // reals
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_FREV,
       modelPar_given_FREV,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE// model variables
       ,
       // reals
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_alphaav,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


    // Now call  the function that does the heavy lifting.

    evaluateModelEquations(
       probeVars,
       // probe constants
       in.admsProbeID_V_A_K,

       // node constants
       in.admsNodeID_A,
       in.admsNodeID_K,
       // instance parameters
       // reals
       instancePar_AB,
       instancePar_given_AB,
       instancePar_LS,
       instancePar_given_LS,
       instancePar_LG,
       instancePar_given_LG,
       instancePar_MULT,
       instancePar_given_MULT,
       // instance variables
       // reals
       instanceVar_MULT_i,
       instanceVar_AB_i,
       instanceVar_LS_i,
       instanceVar_LG_i,
       instanceVar_zflagbot,
       instanceVar_zflagsti,
       instanceVar_zflaggat,
       instanceVar_VMAX,
       instanceVar_exp_VMAX_over_phitd,
       instanceVar_vbimin,
       instanceVar_vch,
       instanceVar_vfmin,
       instanceVar_vbbtlim,
       instanceVar_xhighf1,
       instanceVar_expxhf1,
       instanceVar_xhighf2,
       instanceVar_expxhf2,
       instanceVar_xhighr,
       instanceVar_expxhr,
       instanceVar_ISATFOR1,
       instanceVar_MFOR1,
       instanceVar_ISATFOR2,
       instanceVar_MFOR2,
       instanceVar_ISATREV,
       instanceVar_MREV,
       instanceVar_m0flag,
       // model parameters
       // reals
       modelPar_DTA,
       modelPar_given_DTA,
       modelPar_IMAX,
       modelPar_given_IMAX,
       modelPar_TRJ,
       modelPar_given_TRJ,
       modelPar_FREV,
       modelPar_given_FREV,
       modelPar_CJORBOT,
       modelPar_given_CJORBOT,
       modelPar_CJORSTI,
       modelPar_given_CJORSTI,
       modelPar_CJORGAT,
       modelPar_given_CJORGAT,
       modelPar_VBIRBOT,
       modelPar_given_VBIRBOT,
       modelPar_VBIRSTI,
       modelPar_given_VBIRSTI,
       modelPar_VBIRGAT,
       modelPar_given_VBIRGAT,
       modelPar_PBOT,
       modelPar_given_PBOT,
       modelPar_PSTI,
       modelPar_given_PSTI,
       modelPar_PGAT,
       modelPar_given_PGAT,
       modelPar_PHIGBOT,
       modelPar_given_PHIGBOT,
       modelPar_PHIGSTI,
       modelPar_given_PHIGSTI,
       modelPar_PHIGGAT,
       modelPar_given_PHIGGAT,
       modelPar_IDSATRBOT,
       modelPar_given_IDSATRBOT,
       modelPar_IDSATRSTI,
       modelPar_given_IDSATRSTI,
       modelPar_IDSATRGAT,
       modelPar_given_IDSATRGAT,
       modelPar_CSRHBOT,
       modelPar_given_CSRHBOT,
       modelPar_CSRHSTI,
       modelPar_given_CSRHSTI,
       modelPar_CSRHGAT,
       modelPar_given_CSRHGAT,
       modelPar_XJUNSTI,
       modelPar_given_XJUNSTI,
       modelPar_XJUNGAT,
       modelPar_given_XJUNGAT,
       modelPar_CTATBOT,
       modelPar_given_CTATBOT,
       modelPar_CTATSTI,
       modelPar_given_CTATSTI,
       modelPar_CTATGAT,
       modelPar_given_CTATGAT,
       modelPar_MEFFTATBOT,
       modelPar_given_MEFFTATBOT,
       modelPar_MEFFTATSTI,
       modelPar_given_MEFFTATSTI,
       modelPar_MEFFTATGAT,
       modelPar_given_MEFFTATGAT,
       modelPar_CBBTBOT,
       modelPar_given_CBBTBOT,
       modelPar_CBBTSTI,
       modelPar_given_CBBTSTI,
       modelPar_CBBTGAT,
       modelPar_given_CBBTGAT,
       modelPar_FBBTRBOT,
       modelPar_given_FBBTRBOT,
       modelPar_FBBTRSTI,
       modelPar_given_FBBTRSTI,
       modelPar_FBBTRGAT,
       modelPar_given_FBBTRGAT,
       modelPar_STFBBTBOT,
       modelPar_given_STFBBTBOT,
       modelPar_STFBBTSTI,
       modelPar_given_STFBBTSTI,
       modelPar_STFBBTGAT,
       modelPar_given_STFBBTGAT,
       modelPar_VBRBOT,
       modelPar_given_VBRBOT,
       modelPar_VBRSTI,
       modelPar_given_VBRSTI,
       modelPar_VBRGAT,
       modelPar_given_VBRGAT,
       modelPar_PBRBOT,
       modelPar_given_PBRBOT,
       modelPar_PBRSTI,
       modelPar_given_PBRSTI,
       modelPar_PBRGAT,
       modelPar_given_PBRGAT,
       modelPar_SWJUNEXP,
       modelPar_given_SWJUNEXP,
       modelPar_VJUNREF,
       modelPar_given_VJUNREF,
       modelPar_FJUNQ,
       modelPar_given_FJUNQ,
       // non-reals (including hidden)
       modelPar_LEVEL,
       modelPar_given_LEVEL,
       modelPar_TYPE,
       modelPar_given_TYPE// model variables
       ,
       // reals
       modelVar_IMAX_i,
       modelVar_VBIRBOT_i,
       modelVar_VBIRSTI_i,
       modelVar_VBIRGAT_i,
       modelVar_PBOT_i,
       modelVar_PSTI_i,
       modelVar_PGAT_i,
       modelVar_CSRHBOT_i,
       modelVar_CSRHSTI_i,
       modelVar_CSRHGAT_i,
       modelVar_CTATBOT_i,
       modelVar_CTATSTI_i,
       modelVar_CTATGAT_i,
       modelVar_CBBTBOT_i,
       modelVar_CBBTSTI_i,
       modelVar_CBBTGAT_i,
       modelVar_VBRBOT_i,
       modelVar_VBRSTI_i,
       modelVar_VBRGAT_i,
       modelVar_PBRBOT_i,
       modelVar_PBRSTI_i,
       modelVar_PBRGAT_i,
       modelVar_SWJUNEXP_i,
       modelVar_VJUNREF_i,
       modelVar_FJUNQ_i,
       modelVar_phitr,
       modelVar_phitd,
       modelVar_phitdinv,
       modelVar_perfc,
       modelVar_berfc,
       modelVar_cerfc,
       modelVar_ftdbot,
       modelVar_ftdsti,
       modelVar_ftdgat,
       modelVar_idsatbot,
       modelVar_idsatsti,
       modelVar_idsatgat,
       modelVar_vbibot,
       modelVar_vbisti,
       modelVar_vbigat,
       modelVar_vbiinvbot,
       modelVar_vbiinvsti,
       modelVar_vbiinvgat,
       modelVar_one_minus_PBOT,
       modelVar_one_minus_PSTI,
       modelVar_one_minus_PGAT,
       modelVar_one_over_one_minus_PBOT,
       modelVar_one_over_one_minus_PSTI,
       modelVar_one_over_one_minus_PGAT,
       modelVar_cjobot,
       modelVar_cjosti,
       modelVar_cjogat,
       modelVar_qprefbot,
       modelVar_qprefsti,
       modelVar_qprefgat,
       modelVar_qpref2bot,
       modelVar_qpref2sti,
       modelVar_qpref2gat,
       modelVar_wdepnulrbot,
       modelVar_wdepnulrsti,
       modelVar_wdepnulrgat,
       modelVar_wdepnulrinvbot,
       modelVar_wdepnulrinvsti,
       modelVar_wdepnulrinvgat,
       modelVar_VBIRBOTinv,
       modelVar_VBIRSTIinv,
       modelVar_VBIRGATinv,
       modelVar_atatbot,
       modelVar_atatsti,
       modelVar_atatgat,
       modelVar_btatpartbot,
       modelVar_btatpartsti,
       modelVar_btatpartgat,
       modelVar_fbbtbot,
       modelVar_fbbtsti,
       modelVar_fbbtgat,
       modelVar_alphaav,
       modelVar_fstopbot,
       modelVar_fstopsti,
       modelVar_fstopgat,
       modelVar_VBRinvbot,
       modelVar_VBRinvsti,
       modelVar_VBRinvgat,
       modelVar_slopebot,
       modelVar_slopesti,
       modelVar_slopegat,
       in.admsTemperature,
       in.adms_vt_nom,
       in.getDeviceOptions().gmin,
       staticContributions,
       dynamicContributions,
       in);

  
    // We now have the F and Q vector stuff, populate the dependencies:
  
    dfdp[in.admsNodeID_A+inst*(2+0)] += staticContributions[in.admsNodeID_A].dx(0);
    dqdp[in.admsNodeID_A+inst*(2+0)] += dynamicContributions[in.admsNodeID_A].dx(0);
    Findices[in.admsNodeID_A+inst*(2+0)] = in.li_A;
    Qindices[in.admsNodeID_A+inst*(2+0)] = in.li_A;
    dfdp[in.admsNodeID_K+inst*(2+0)] += staticContributions[in.admsNodeID_K].dx(0);
    dqdp[in.admsNodeID_K+inst*(2+0)] += dynamicContributions[in.admsNodeID_K].dx(0);
    Findices[in.admsNodeID_K+inst*(2+0)] = in.li_K;
    Qindices[in.admsNodeID_K+inst*(2+0)] = in.li_K;
  }

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSJUNCAP200
} // namespace Device
} // namespace Xyce
